#include "Reseau.h"
#include "callbacks.h"
#include "Machine.h"


void Initialise_Structure_Machine (int Machine)
{
	printf("Machine %d initialise\n",Machine);
	Liste_Machines[Machine].Scan_Port = FALSE;
	Liste_Machines[Machine].Serveur = FALSE;
	Liste_Machines[Machine].Debug_Scan = NULL;
	Liste_Machines[Machine].Nb_Port_Ouvert = 0;
	Liste_Machines[Machine].TypeMateriel = INCONNU;
	Liste_Machines[Machine].color.red = -1;
	Liste_Machines[Machine].color.green = -1;
	Liste_Machines[Machine].color.blue = -1;
	Initialise_Structure_SMB (Machine);


}

void Ajoute_Nouvelle_Machine (int NumMachine, char *Adresse_Ip, char *Adresse_Mac, unsigned long int AdresseIp, char *AdresseMac)
{
	strcpy (Liste_Machines[NumMachine].Adresse_Ip, Adresse_Ip);
	strcpy (Liste_Machines[NumMachine].Adresse_Mac, Adresse_Mac);
	Liste_Machines[NumMachine].AdresseIp = AdresseIp;
	memcpy (Liste_Machines[NumMachine].AdresseMAC, AdresseMac, 6);
	printf ("Nouvelle Machine (%d) : (%s)  [%s]  \n", NumMachine, Liste_Machines[NumMachine].Adresse_Ip, Liste_Machines[NumMachine].Adresse_Mac);
	if (NumMachine != Nb_Machine_Trouve) {
		printf ("Erreur : Nb de machines trouve\n");
		exit (-1);
	}
	Nb_Machine_Trouve++;
}


void Affiche_Nouvelle_Machine (int Machine)
{
	gchar    *titre[1], *text[1];
	int       Num_Domaine_Serveur, Num_Domaine_Station;
	GtkCTreeNode *Node_Parent;


	printf ("Affichage machine : %d\n", Machine);
	if (Liste_Machines[Machine].Smb.HostName[0] == 0)
		titre[0] = g_strdup_printf (Liste_Machines[Machine].Adresse_Ip);
	else
		titre[0] = g_strdup_printf (Liste_Machines[Machine].Smb.HostName);

	Node_Parent = NULL;
	/* Recherche du parent */
	if (Node_Parent == NULL)
		Node_Parent = Ajoute_Domaine_Serveur (Machine);
	if (Node_Parent == NULL)
		Node_Parent = Ajoute_Domaine_Station (Machine);
	if (Node_Parent == NULL)
		Node_Parent = Ajoute_Imprimante (Machine);
	if (Node_Parent == NULL)
		Node_Parent = Ajoute_Routeur_Switch (Machine);
	if (Node_Parent == NULL)
		Node_Parent = Ajoute_Routeur (Machine);
	if (Node_Parent == NULL)
		Node_Parent = Ajoute_Switch (Machine);
	if (Node_Parent == NULL)
		Node_Parent = Ajoute_Point_Access_Wifi (Machine);
	if ((Node_Parent == NULL) && (Liste_Machines[Machine].Nb_Port_Ouvert > 0) && (Liste_Machines[Machine].Serveur) && (Liste_Machines[Machine].TypeMateriel == AUTRE))
		Node_Parent = Node_Serveur;	// c'est un serveur mais il n'est pas dans un domaine
	if ((Node_Parent == NULL) && (Liste_Machines[Machine].Nb_Port_Ouvert > 0) && (!Liste_Machines[Machine].Serveur) && (Liste_Machines[Machine].TypeMateriel == AUTRE))
		Node_Parent = Node_Station;	// c'est un station mais il n'est pas dans un domaine

	gdk_threads_enter ();
	if (Node_Parent == NULL) {
		/* Créer le noeud "Inconnu " */
		if (Node_Inconnu == NULL) {
			text[0] = g_strdup_printf ("Inconnu");
			Node_Inconnu = gtk_ctree_insert_node (GTK_CTREE (ctree_Liste_Machine), NULL, NULL, text, 5, Pixmap_Inconnu, Masque_Inconnu, Pixmap_Inconnu, Masque_Inconnu, FALSE, FALSE);
			gtk_ctree_node_set_row_data (GTK_CTREE (ctree_Liste_Machine), Node_Inconnu, (gpointer *) INCONNU);
			g_free (text[0]);
		}
		Liste_Machines[Machine].ctree = gtk_ctree_insert_node (GTK_CTREE (ctree_Liste_Machine), Node_Inconnu, NULL, titre, 5, Liste_Machines[Machine].Image, Liste_Machines[Machine].Masque, Liste_Machines[Machine].Image, Liste_Machines[Machine].Masque, FALSE, FALSE);
		Liste_Machines[Machine].ctree_Parent = Node_Inconnu;
		gtk_ctree_node_set_row_data (GTK_CTREE (ctree_Liste_Machine), Liste_Machines[Machine].ctree, (gpointer *) Machine);

	}
	else {
		Liste_Machines[Machine].ctree = gtk_ctree_insert_node (GTK_CTREE (ctree_Liste_Machine), Node_Parent, NULL, titre, 5, Liste_Machines[Machine].Image, Liste_Machines[Machine].Masque, Liste_Machines[Machine].Image, Liste_Machines[Machine].Masque, FALSE, FALSE);
		Liste_Machines[Machine].ctree_Parent = Node_Parent;
		gtk_ctree_node_set_row_data (GTK_CTREE (ctree_Liste_Machine), Liste_Machines[Machine].ctree, (gpointer *) Machine);
	}
	/* Modification de la couleur de fond */
	gtk_ctree_node_set_background (GTK_CTREE (ctree_Liste_Machine), Liste_Machines[Machine].ctree, &Liste_Machines[Machine].color);

	gdk_threads_leave ();
	g_free (titre[0]);


	/*gchar    *titre[1];
	 * 
	 * 
	 * 
	 * 
	 * if ((Index_Port>-1)&&(Liste_Port_Scan[Index_Port].Marquer==1)){
	 * printf("Marque pour machine %d, port %d\n",Machine,Port);
	 * color.red = Liste_Port_Scan[Index_Port].red * 255;
	 * color.green = Liste_Port_Scan[Index_Port].green * 255;
	 * color.blue = Liste_Port_Scan[Index_Port].blue * 255;
	 * gtk_ctree_node_set_background(GTK_CTREE(ctree_Liste_Machine), Liste_Machines[Machine].ctree, &color);
	 * }
	 * 
	 * 
	 * text[0] = g_strdup_printf (Liste_Machines[NumMachine].Adresse_Ip);
	 * gdk_threads_enter ();
	 * Liste_Machines[NumMachine].ctree = gtk_ctree_insert_node (GTK_CTREE (ctree_Liste_Machine), Node_Inconnu, NULL, text, 5, NULL, NULL, NULL, NULL, FALSE, FALSE);
	 * Liste_Machines[NumMachine].ctree_Parent = Node_Inconnu;
	 * gtk_ctree_node_set_row_data (GTK_CTREE (ctree_Liste_Machine), Liste_Machines[NumMachine].ctree, (gpointer *) NumMachine);
	 * gdk_threads_leave ();
	 * g_free (text[0]);
	 */


}
