/*
 *  Copyright (C) 2004 Thierry Lagarde <tlagarde@user.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef         __OS_DETECT
#define         __OS_DETECT

#include "crypt-md5.h"


struct struct_Liste_Signature {
	char     *Nom;
	int       Type_Machine;
	int       Requete_Netbios;
	int       Routeur;
	md5_byte_t digest[16 + 1];
	int       Etat_Equipement;
	int       Etat_Equipement_Eteint;
	int       Etat_Equipement_Message;
	int       Etat_Equipement_Email;
};
struct struct_Liste_Signature *Liste_Signature;
int       Nb_Signature;




struct struct_Reponse {
	unsigned char TaillePacketReponse;	// si il y a un Trailer, la taille de la trame change
	/* IP */
	unsigned char HeaderLengthIP;
	unsigned char DSF;
	unsigned short TailleTotal;
	unsigned char Id;	//test si = à 0
	unsigned short Flags_IP_Offset;
	unsigned char TTL;
	/* TCP */
	unsigned char NumSeq;	//test si = à 0
	unsigned char HeaderLengthTCP;
	unsigned char Flags_TCP;
	unsigned short WindowSize;
};

struct struct_Signature_Reponse {
	struct struct_Reponse Syn_Normal_Ouvert;
	struct struct_Reponse Syn_Null_Ouvert;
	struct struct_Reponse Syn_ECN_Ouvert;
	struct struct_Reponse Syn_FIN_URG_PSH_Ouvert;
	struct struct_Reponse Ack_Ouvert;
	struct struct_Reponse Fin_Ouvert;

	struct struct_Reponse Syn_Normal_Fermer;
	struct struct_Reponse Syn_Null_Fermer;
	struct struct_Reponse Syn_ECN_Fermer;
	struct struct_Reponse Syn_FIN_URG_PSH_Fermer;
	struct struct_Reponse Ack_Fermer;
	struct struct_Reponse Fin_Fermer;

	struct struct_Reponse Icmp_Ping_31;
	struct struct_Reponse Icmp_Timestamp;
	struct struct_Reponse Icmp_UDP_Close;
};

#endif
