/*
 *  Copyright (C) 2004 Thierry Lagarde <tlagarde@user.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "Declaration.h"
#include <pthread.h>


int Valeur_Semaphore (sem_t * sem)
{
	int       valeur;

	sem_getvalue (sem, &valeur);
	return valeur;
}


void demmarage_Thread (void *thread, int NumMachine)
{
	pthread_t pThread;

	if (pthread_create (&pThread, NULL, (void *) thread, NumMachine) != 0) {
		printf ("[S] Demmarage_Thread (%d): Impossible de démarrer le thread pour la machine %d\n", getpid (), NumMachine);
		exit (0);
	}
	pthread_detach(pThread);
}
