/*
 *  Copyright (C) 2004 Thierry Lagarde <tlagarde@user.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef         __RESEAU
#define         __RESEAU

#include <time.h>
#include "Declaration.h"
#include "Commun.h"


/* Ip */
#define TRAME_IP	0x0800
#define IP_ADDR_LEN	4
#define IP_VERSION4	0x4
/* ARP */
#define TRAME_ARP	0x0806
/* UDP */
#define UDP		0x11
/* TCP */
#define TCP 	0x06
/* ICMP */
#define ICMP	0x01
/* Netbios */
#define NETBIOS		0x89
#define REGISTRATION_GROUP 1
#define REGISTRATION_UNIQUE 2
#define NBNS		0x89
/* Définition constante message BROWSE*/
#define MASTER_ANNONCE	0x0f
#define HOST_ANNONCE	0x01



/* num sélection liste */
#define INCONNU -1
#define MATERIEL -2
#define STATION -3
#define SERVEUR -4
#define SWITCH -5
#define ROUTEUR -6
#define IMPRIMANTE -7
#define ROUTEUR_SWITCH -8
#define POINT_ACCESS_WIFI -9
#define AUTRE -10
#define DOMAINE -11

unsigned char Mon_Adresse_Ip[16];
unsigned long int MonAdresseIp;
unsigned char MonAdresseMac[ETH_ALEN];
char     *Interface;
gboolean  Autoriser_Scan;
gboolean  Relecture_Fichiers_Configuration;
int       Nb_Max_Thread;

struct struct_trame {
	unsigned char Dest_MAC[6];
	unsigned char Source_MAC[6];
	unsigned short Proto;
	unsigned char Datagramme[10000];
	int       Taille_Trame;
};


struct struct_Liste_Machines {
	unsigned char Adresse_Ip[16];
	unsigned long int AdresseIp;
	unsigned char Adresse_Mac[18];
	unsigned char AdresseMAC[6];
	gboolean  Scan_Port_En_Cours;	// boolean
	gboolean  Machine_Restaurer;
	gboolean  Machine_ReScanner;
	gboolean  Machine_Allumer;
	time_t    temps_Arret;
};

#define MAX_MACHINE	1000
struct struct_Liste_Machines Liste_Machines[MAX_MACHINE];
int       Nb_Machine_Dans_La_Liste;

#endif
