/*
 *  Copyright (C) 2004 Thierry Lagarde <tlagarde@user.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "Declaration.h"
#include "Sous_Reseau_Autorise.h"
extern int h_errno;


#define FIN 		-1
#define EFFACER 	NULL



void Creer_Liste_Sous_Reseau ()
{
	FILE     *Fichier_Sous_Reseau;
	char      buf[512], CheminFichier[256];
	unsigned char Class;	// 1 ou 2 ou 3
	unsigned char Prive1;
	unsigned char Prive2;
	unsigned char Prive3;

	sprintf (CheminFichier, "%s/Conf/SubNet", pwd_Utilisateur);
	if ((Fichier_Sous_Reseau = fopen (CheminFichier, "r")) == NULL) {
		perror ("[I] fopen :");
		printf ("[I] Impossible de lire SubNet\n");
	}
	Nb_Sous_Reseau = 0;
	while (fgets (buf, sizeof (buf), Fichier_Sous_Reseau))
		Nb_Sous_Reseau++;
	rewind (Fichier_Sous_Reseau);
	Liste_Sous_Reseau = (struct struct_Liste_Sous_Reseau *) malloc (sizeof (struct struct_Liste_Sous_Reseau) * (Nb_Sous_Reseau + 1));
	Nb_Sous_Reseau = 0;
	printf ("**********************************\n");
	printf ("*   Liste des sous-reseaux\n");
	while (fgets (buf, sizeof (buf), Fichier_Sous_Reseau)) {
		if (sscanf (buf, "%d;%d;%d;%d;", &Class, &Prive1, &Prive2, &Prive3) != 4) {
			printf ("[I] Erreur de lecture du fichier Sous_Reseau\n");
			exit (0);
		}
		switch (Class) {
		    case 1:
			    sprintf (buf, "%d.", Prive1);
			    break;
		    case 2:
			    sprintf (buf, "%d.%d.", Prive1, Prive2);
			    break;
		    case 3:
			    sprintf (buf, "%d.%d.%d.", Prive1, Prive2, Prive3);
			    break;
		    default:
			    printf ("[S]  Erreur lecture SubNet");
			    exit (-1);
		}
		strcpy (Liste_Sous_Reseau[Nb_Sous_Reseau].Adresse, buf);
		Liste_Sous_Reseau[Nb_Sous_Reseau].Taille = strlen(Liste_Sous_Reseau[Nb_Sous_Reseau].Adresse);
		printf ("*  [%s]  T(%d)\n", Liste_Sous_Reseau[Nb_Sous_Reseau].Adresse,Liste_Sous_Reseau[Nb_Sous_Reseau].Taille);
		Nb_Sous_Reseau++;
	}
	printf ("**********************************\n");
	Liste_Sous_Reseau[Nb_Sous_Reseau].Adresse[0] = FIN;	//FIN
	printf ("[I] Creation de la liste des sous reseaux (%d sous reseau trouves)\n", Nb_Sous_Reseau);
	fclose (Fichier_Sous_Reseau);
}
