/*
 *  Copyright (C) 2004 Thierry Lagarde <tlagarde@user.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "Reseau.h"
#include "Declaration.h"
#include "Sous_Reseau.h"
#include "Sous_Reseau_Autorise.h"


extern void Liste_Interface ();
extern void Get_My_MAC (int, char *);
extern void Get_My_Ip (int, char *);
extern void Nettoie_Liste_Machine ();

void     *Nouveau_Sous_Reseau (int);
void     *ScanMachine (int);

void     *Thread_Recherche_Ip ()
{
	struct sockaddr sock;
	int       Socket;
	char      Adresse_Ip[16], Adresse_Mac[18];
	unsigned long int AdresseIp;
	int       nouvMachine, NumMachine, NumSousReseau, i, j, Taille_Ip_En_Cours;
	unsigned short Port_Source;
	gboolean  Arret_Machine_NBNS;
	int       n_read, Conv;
	struct struct_trame Packet;
	time_t    temps;
	struct struct_Message_Temps_Reel Message_Temps_Reel;


	strcpy (sock.sa_data, Interface);
	sock.sa_family = AF_INET;
	if ((Socket = socket (AF_INET, SOCK_PACKET, htons (ETH_P_ALL))) < 0) {
		perror ("[S] Socket: ");
		exit (1);
	}


	printf ("[S] Thread Recherche Ip : OK    pid(%d)\n", getpid ());

	/* Scanne ma plage Ip */
	memcpy (&Sous_Reseau[0].Reseau, &MonAdresseIp, IP_ADDR_LEN - 1);
	demmarage_Thread (Nouveau_Sous_Reseau, 0);

	while (1) {
		Arret_Machine_NBNS = FALSE;
		n_read = recvfrom (Socket, &Packet, sizeof (Packet), 0, NULL, 0);
		sprintf (Adresse_Mac, "%02X:%02X:%02X:%02X:%02X:%02X", Packet.Source_MAC[0], Packet.Source_MAC[1], Packet.Source_MAC[2], Packet.Source_MAC[3], Packet.Source_MAC[4], Packet.Source_MAC[5]);
		nouvMachine = 0;
		switch (htons (Packet.Proto)) {
		    case TRAME_IP:
			    if ((Packet.Datagramme[0] >> 4) == IP_VERSION4) {
				    memcpy (&AdresseIp, &Packet.Datagramme[12], 4);
				    sprintf (Adresse_Ip, "%d.%d.%d.%d", Packet.Datagramme[12], Packet.Datagramme[13], Packet.Datagramme[14], Packet.Datagramme[15]);
				    if ((Packet.Dest_MAC[5] == 255) && (Packet.Datagramme[9] == UDP) && (Packet.Datagramme[22] == 0) && (Packet.Datagramme[23] == NBNS)) {
					    //printf ("NBNS Trame  [%s] %02X%02X   %02X%02X\n", Adresse_Ip, Packet.Datagramme[30], Packet.Datagramme[31], Packet.Datagramme[71], Packet.Datagramme[72]);
					    if ((Packet.Datagramme[30] == 0x30) && (Packet.Datagramme[31] == 0x10) && (Packet.Datagramme[71] == 0x41) && (Packet.Datagramme[72] == 0x41))
						    Arret_Machine_NBNS = TRUE;

				    }
				    nouvMachine++;
			    }
			    break;
		    case TRAME_ARP:
			    memcpy (&AdresseIp, &Packet.Datagramme[14], 4);
			    sprintf (Adresse_Ip, "%d.%d.%d.%d", Packet.Datagramme[14], Packet.Datagramme[15], Packet.Datagramme[16], Packet.Datagramme[17]);
			    nouvMachine++;
			    break;
		}

		if (nouvMachine != 0) {
			//(nouvMachine != 0) && ((strncmp (Adresse_Ip, "10.", 3) == 0) || (strncmp (Adresse_Ip, "172.16.", 7) == 0) || (strncmp (Adresse_Ip, "192.168.", 8) == 0)))
			i = 0;
			while ((i < Nb_Sous_Reseau) && (strncmp (Adresse_Ip,Liste_Sous_Reseau[i].Adresse ,Liste_Sous_Reseau[i].Taille ) != 0)) {
						//printf("Adresse Ip [%s]   (%i)[%s]\n",Adresse_Ip,i,Liste_Sous_Reseau[i].Adresse );
					    i++;
			}
			//printf("### FIN Adresse Ip [%s]   (%i)[%s]\n",Adresse_Ip,i,Liste_Sous_Reseau[i].Adresse );
			if ((i< Nb_Sous_Reseau) &&(strncmp (Adresse_Ip,Liste_Sous_Reseau[i].Adresse ,Liste_Sous_Reseau[i].Taille ) == 0)){
				if ((strcmp (Adresse_Ip, Mon_Adresse_Ip) == 0) || (strcmp (Adresse_Ip, "0.0.0.0") == 0) || (strcmp (Adresse_Ip, "127.0.0.1") == 0)) {//
					// c'est moi
				}
				else {
					/* Recherche si la nouvelle machine trouve est deja dans la liste des machines */
					NumMachine = 0;
					while ((Liste_Machines[NumMachine].Adresse_Ip[0] != 0)
						&& (memcmp (&Liste_Machines[NumMachine].AdresseIp, &AdresseIp, IP_ADDR_LEN) != 0)) {
						NumMachine++;
					}
					if (memcmp (&Liste_Machines[NumMachine].AdresseIp, &AdresseIp, IP_ADDR_LEN) != 0) {
						/* Nouvelle Machine
						 * Stocke les nouveaux sous réseau      */
						NumSousReseau = 0;
						while ((Sous_Reseau[NumSousReseau].Reseau[0] != 0)
							&& (memcmp (&Sous_Reseau[NumSousReseau].Reseau, &AdresseIp, IP_ADDR_LEN - 1) != 0)) {
							NumSousReseau++;
						}
						if (Sous_Reseau[NumSousReseau].Reseau[0] == 0) {
							printf ("[S] Detection d'un nouveau reseau : %s\n", Adresse_Ip);
							memcpy (&Sous_Reseau[NumSousReseau].Reseau, &AdresseIp, IP_ADDR_LEN - 1);
							demmarage_Thread (Nouveau_Sous_Reseau, NumSousReseau);
						}
						/* Initialise les données de la nouvelle machine */
						if ((Autoriser_Scan) && (Liste_Machines[NumMachine].Adresse_Ip[0] == 0)) {	// boolean
							strcpy (Liste_Machines[NumMachine].Adresse_Ip, Adresse_Ip);
							strcpy (Liste_Machines[NumMachine].Adresse_Mac, Adresse_Mac);
							Liste_Machines[NumMachine].AdresseIp = AdresseIp;
							memcpy (Liste_Machines[NumMachine].AdresseMAC, Packet.Source_MAC, 6);
							Liste_Machines[NumMachine].Scan_Port_En_Cours = FALSE;	// boolean
							Liste_Machines[NumMachine].Machine_Restaurer = FALSE;	// boolean
							Liste_Machines[NumMachine].Machine_ReScanner = FALSE;	// boolean
							Liste_Machines[NumMachine].Machine_Allumer = TRUE;
							Liste_Machines[NumMachine].temps_Arret = 0;
							printf ("[S] Nouvelle Machine (%d) : (%s)  [%s]  \n", NumMachine, Liste_Machines[NumMachine].Adresse_Ip, Liste_Machines[NumMachine].Adresse_Mac);
							Nb_Machine_Dans_La_Liste++;
							sem_post (&Semaphore_Nouvelle_Machine);
							Message_Info ();
						}
					}
					else {
						/* Machine Existante */
						if (Arret_Machine_NBNS) {
							if (Liste_Machines[NumMachine].Machine_Allumer) {
								Liste_Machines[NumMachine].Machine_Allumer = FALSE;
								time (&Liste_Machines[NumMachine].temps_Arret);
								printf ("[S] Changement etat Machine [%d] = Arret    (%ld)\n", NumMachine, Liste_Machines[NumMachine].temps_Arret);
								Message_Temps_Reel.type = 1;
								Message_Temps_Reel.type_message = ARRET_MACHINE;
								memcpy (Message_Temps_Reel.Mac_Adresse_Machine, Packet.Source_MAC, 6);
								if (msgsnd (File_Envoie_Message_Temps_Reel, (void *) &Message_Temps_Reel, sizeof (Message_Temps_Reel) - sizeof (long), 0) < 0) {
									perror ("[S] msgsnd");
									exit (1);
								}
							}
						}
						else {
							if (Liste_Machines[NumMachine].Machine_Allumer == FALSE) {
								/* La machine Change d'état   eteint --> Allumer */
								time (&temps);
								if (temps > (Liste_Machines[NumMachine].temps_Arret + 20)) {	// on attend au moins 20 secondes après l'arret de la machine pour dire qu'elle est en train de redémarrer
									printf ("[S] Changement etat Machine [%d] = Allumer\n", NumMachine);
									Liste_Machines[NumMachine].Machine_Allumer = TRUE;
									Message_Temps_Reel.type = 1;
									Message_Temps_Reel.type_message = DEMARRAGE_MACHINE;
									memcpy (Message_Temps_Reel.Mac_Adresse_Machine, Packet.Source_MAC, 6);
									if (msgsnd (File_Envoie_Message_Temps_Reel, (void *) &Message_Temps_Reel, sizeof (Message_Temps_Reel) - sizeof (long), 0) < 0) {
										perror ("[S] msgsnd");
										exit (1);
									}
								}
								else
									printf ("[S]Changement pas pris en compte etat Machine [%d] = Allumer   (%ld)\n", NumMachine, temps);
							}
						}
					}
				}
			}
		}
	}
}
