/*
 *  Copyright (C) 2004 Thierry Lagarde <tlagarde@user.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include <time.h>
#include "Reseau.h"
#include "Port.h"
#include "Declaration.h"
#include "OS_Detect.h"


char      Syn[] = { 0x45, 0x00, 0x00, 0x28, 0x00, 0x00, 0x00, 0x00, 0x7F, 0x06, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x50, 0x02, 0x1F, 0xFE, 0x00, 0x00, 0x00, 0x00 };


int ScanPort (int Machine, int Port_Client)
{
	int       PidScan, Socket, Taille_Trame;
	struct sockaddr sock;
	unsigned short Id_Ip, Port, Port_Source_En_Cours, Port_Dest_En_Cours;
	unsigned int MonNumSeq;
	struct struct_trame PacketReponse, PacketScan;
	unsigned short CheckSum_Calc;
	char      Fin;
	time_t    temps;
	struct tm *tm;
	int       seconde_Debut, seconde_Ecoule, seconde_Actuelle, seconde_Next;
	unsigned int Taille_Ip_En_Cours, Taille_Datagramme_IP_En_Cours, Taille_Message_Tcp_En_Cours, NumAckEnCours;
	int       Etat;

	PidScan = getpid ();
	usleep (10000);
	Id_Ip = (unsigned short) random ();
	MonNumSeq = (int) random ();
	Port = ((unsigned short) random ());
	Port = (Port & 0x0FFF) + 0xF000;
	strcpy (sock.sa_data, Interface);
	sock.sa_family = AF_INET;
	if ((Socket = socket (AF_INET, SOCK_PACKET, htons (ETH_P_ALL))) < 0) {
		perror ("[S] Socket: ");
		exit (1);
	}
	set_NonBlock (Socket);
	MonNumSeq = htonl (MonNumSeq);
	memcpy (&PacketScan.Dest_MAC, &Liste_Machines[Machine].AdresseMAC, ETH_ALEN);
	memcpy (&PacketScan.Source_MAC, MonAdresseMac, ETH_ALEN);
	PacketScan.Proto = htons (TRAME_IP);
	memcpy (&PacketScan.Datagramme, Syn, 40);
	PacketScan.Datagramme[4] = (Id_Ip >> 8) & 0xFF;
	PacketScan.Datagramme[5] = Id_Ip & 0xFF;
	memcpy (&PacketScan.Datagramme[12], &MonAdresseIp, IP_ADDR_LEN);
	memcpy (&PacketScan.Datagramme[16], &Liste_Machines[Machine].AdresseIp, IP_ADDR_LEN);
	CheckSum_Calc = htons (ckecksum (&PacketScan.Datagramme[0], 20, 0));
	memcpy (&PacketScan.Datagramme[10], &CheckSum_Calc, 2);
	PacketScan.Datagramme[20] = (Port >> 8) & 0xFF;
	PacketScan.Datagramme[21] = Port & 0xFF;
	PacketScan.Datagramme[22] = (Port_Client >> 8) & 0xFF;
	PacketScan.Datagramme[23] = Port_Client & 0xFF;
	memcpy (&PacketScan.Datagramme[24], &MonNumSeq, 4);
	//CheckSum_Calc = ckecksum (&PacketScan.Datagramme[12], 24,26);
	//CheckSum_Calc = CheckSum_Calc - 20 - 6;
//      if (CheckSum_Calc < 0)
//              CheckSum_Calc--;
	CheckSum_Calc = htons (ckecksum (&PacketScan.Datagramme[12], 24, 26));
	memcpy (&PacketScan.Datagramme[36], &CheckSum_Calc, 2);

	if ((sendto (Socket, &PacketScan, 54, 0, &sock, sizeof (sock))) < 0) {
		perror ("[S] Erreur : Envoie packet");
		exit (-1);
	}
	time (&temps);
	tm = localtime (&temps);
	//Debug_Scan_3 (Machine, "%02d:%02d:%02d ", tm->tm_hour, tm->tm_min, tm->tm_sec);
	seconde_Debut = tm->tm_sec;
	seconde_Next = seconde_Debut;
	seconde_Ecoule = 0;
	MonNumSeq = htonl (MonNumSeq);
	Etat = ETAT_INCONNU;
	Fin = FALSE;		// boolean
	while (!Fin) {		// boolean
		if (waiting_donnee (Socket, 1000)) {
			Taille_Trame = recvfrom (Socket, &PacketReponse, sizeof (struct struct_trame), 0, NULL, 0);
			if ((memcmp (PacketReponse.Source_MAC, Liste_Machines[Machine].AdresseMAC, ETH_ALEN) == 0)
				&& (memcmp (PacketReponse.Dest_MAC, MonAdresseMac, ETH_ALEN) == 0)) {
				if ((htons (PacketReponse.Proto) == TRAME_IP) && ((PacketReponse.Datagramme[0] >> 4) == IP_VERSION4)) {
					if ((memcmp (&PacketReponse.Datagramme[16], &MonAdresseIp, IP_ADDR_LEN) == 0)
						&& (memcmp (&PacketReponse.Datagramme[12], &Liste_Machines[Machine].AdresseIp, IP_ADDR_LEN) == 0)) {
						Taille_Ip_En_Cours = (PacketReponse.Datagramme[0] & 0x0F) << 2;
						Taille_Datagramme_IP_En_Cours = (PacketReponse.Datagramme[2] << 8) + PacketReponse.Datagramme[3];
						Taille_Message_Tcp_En_Cours = ((PacketReponse.Datagramme[Taille_Ip_En_Cours + 12] & 0xF0) >> 4) * 4;
						memcpy (&Port_Source_En_Cours, &PacketReponse.Datagramme[Taille_Ip_En_Cours], 2);
						Port_Source_En_Cours = htons (Port_Source_En_Cours);
						memcpy (&Port_Dest_En_Cours, &PacketReponse.Datagramme[Taille_Ip_En_Cours + 2], 2);
						Port_Dest_En_Cours = htons (Port_Dest_En_Cours);
						if ((Port_Source_En_Cours == Port_Client) && (Port_Dest_En_Cours == Port)) {
							memcpy (&NumAckEnCours, &PacketReponse.Datagramme[Taille_Ip_En_Cours + 8], 4);
							NumAckEnCours = htonl (NumAckEnCours);
							if ((NumAckEnCours - 1) == MonNumSeq) {
								switch (PacketReponse.Datagramme[Taille_Ip_En_Cours + 13]) {
								    case 0x14:	// ACK,RESET
								    case 0x1C:	//ACK,RESET,PUSH
									    Etat = FERMER;
									    break;
								    case 0x12:	// SYN,ACK
									    Etat = OUVERT;
									    break;
								    default:
									    printf ("[S] Case Impossible [%d ]dans Scan pas de (ACK,RESET) ou de (ACK) [%s] Scan (%d)->(%d) en %d seconde \n", PacketReponse.Datagramme[Taille_Ip_En_Cours + 13], Liste_Machines[Machine].Adresse_Ip, Port, Port_Client, seconde_Ecoule);
								}
								Fin = TRUE;	// boolean
							}
						}
					}
				}
			}
		}
		time (&temps);
		tm = localtime (&temps);
		seconde_Actuelle = tm->tm_sec;
		if (seconde_Actuelle != seconde_Next) {
			seconde_Ecoule++;
			seconde_Next = seconde_Actuelle;
			/* Renvoye la trame Syn au bout de 3, 6, 12 , 18 secondes */
			if ((seconde_Ecoule == 3) || (seconde_Ecoule == 6) || (seconde_Ecoule == 12) || (seconde_Ecoule == 18)) {
				Id_Ip++;
				PacketScan.Datagramme[4] = (Id_Ip >> 8) & 0xFF;
				PacketScan.Datagramme[5] = Id_Ip & 0xFF;
				CheckSum_Calc = 0;
				memcpy (&PacketScan.Datagramme[10], &CheckSum_Calc, 2);
				CheckSum_Calc = htons (ckecksum (&PacketScan.Datagramme[0], 20, 0));
				memcpy (&PacketScan.Datagramme[10], &CheckSum_Calc, 2);
				if ((sendto (Socket, &PacketScan, 54, 0, &sock, sizeof (sock))) < 0) {
					perror ("[S] Erreur : Envoie packet");
					exit (-1);
				}
				printf ("[S] ################  Machine[%d](%d)->(%d) a  %d seconde  Nouvelle tentative\n", Machine, Port, Port_Client, seconde_Ecoule);
			}
			if (seconde_Ecoule == 21) {
				Fin = TRUE;	// boolean
				Etat = FIREWALLED;
			}
		}
	}

/*	switch (Etat) {
	    case FERMER:
		    // printf ("Machine[%d]  Port (%d) en %d seconde  Etat : FERMER\n", Machine, Port_Client, seconde_Ecoule);
		    break;
	    case OUVERT:
		    printf ("Machine[%d] Port (%d) en %d seconde  Etat : OUVERT\n", Machine, Port_Client, seconde_Ecoule);
		    break;
	    case FIREWALLED:
		    printf ("Machine[%d] Port (%d) en %d seconde  Etat : FIREWALLED\n", Machine, Port_Client, seconde_Ecoule);
		    break;
	    default:
		    printf ("Machine[%d] Port (%d) en %d seconde  Etat : ERREUR\n", Machine, Port_Client, seconde_Ecoule);
		    break;
	}*/
	close (Socket);
	return Etat;
}


void Ajoute_port (struct struct_Machines_Resultat *Resultat, int Machine, int Index_Port, int Etat, int Port, int Type_Machine)
{
	if (Etat == OUVERT) {
		Resultat->Port[Resultat->Nb_Port_Ouvert].Num_Port = Port;
		Resultat->Port[Resultat->Nb_Port_Ouvert].Etat = Etat;
		if (Type_Machine == SERVEUR) {
			Resultat->Serveur = TRUE;	// SERVEUR;
		}
		Resultat->Port[Resultat->Nb_Port_Ouvert].Index_Port = Index_Port;
		Resultat->Port[Resultat->Nb_Port_Ouvert].Type_Machine = Type_Machine;
		Resultat->Nb_Port_Ouvert++;
	}
	if (Etat == FERMER) {
		Resultat->Nb_Port_Fermer++;
	}
	if (Etat == FIREWALLED) {
		Resultat->Nb_Port_Firewaller++;
	}
}



void     *ScanMachine (int Machine, int Num_Machine_Interface)
{
	int       i, Tentative_NetBios, Port, Signature;
	struct struct_Machines_Resultat Resultat;


	printf ("[S][%d] Scan par Thread %d    tailleResultat %d\n", Machine, getpid (), sizeof (Resultat));
	if (Nb_Max_Thread - Valeur_Semaphore (&Semaphore_Thread_Scan) == 0) {
		if (Relecture_Fichiers_Configuration) {	// boolean
			Creer_PortList ();	// relecture en tout securite aucun scan n'est en cours
			Creer_SignatureList ();
			Relecture_Fichiers_Configuration = FALSE;	// boolean
		}
	}
	if (!Liste_Machines[Machine].Scan_Port_En_Cours) {	// boolean
		Liste_Machines[Machine].Scan_Port_En_Cours = TRUE;	// boolean
		bzero (&Resultat, sizeof (struct struct_Machines_Resultat));
		Resultat.type = 1;
		Resultat.Serveur = FALSE;
		strcpy (Resultat.Adresse_Ip, Liste_Machines[Machine].Adresse_Ip);
		strcpy (Resultat.Adresse_Mac, Liste_Machines[Machine].Adresse_Mac);
		Resultat.AdresseIp = Liste_Machines[Machine].AdresseIp;
		memcpy (Resultat.AdresseMAC, Liste_Machines[Machine].AdresseMAC, 6);
		/* Initialisation de la structure liste port */
		Resultat.Nb_Port_Ouvert = 0;
		Resultat.Nb_Port_Fermer = 0;
		Resultat.Nb_Port_Firewaller = 0;
		Resultat.Nb_Port_Total_Scanner = Nb_Port_Dans_Liste_Scan;
		for (i = 0; i < MAX_PORTS; i++)
			Resultat.Port[i].Num_Port = -1;
		/* Scan la machine */
		for (i = 0; i < Nb_Port_Dans_Liste_Scan; i++) {
			Ajoute_port (&Resultat, Machine, i, ScanPort (Machine, Liste_Port_Scan[i].Num_Port), Liste_Port_Scan[i].Num_Port, Liste_Port_Scan[i].Type_Machine);
		}
		printf ("[S][%d] Fin Scan Port [%s]  ouvert(%d/%d) fermer(%d)  firewall(%d)\n\n\n", Machine, Liste_Machines[Machine].Adresse_Ip, Resultat.Nb_Port_Ouvert, Resultat.Nb_Port_Total_Scanner,Resultat.Nb_Port_Fermer, Resultat.Nb_Port_Firewaller);
		/* Recherche de la signature du systeme */
		if (Resultat.Port[0].Num_Port != -1) {	// si 1 port au moins d'ouvert
			DetecteurOs (&Resultat, Machine, Resultat.Port[0].Num_Port, 65535);
		}

		/* Initialise la structure netbios */
		Resultat.Smb.HostName[0] = 0;
		Resultat.Smb.DomainName[0] = 0;
		Resultat.Smb.Utilisateur[0] = 0;
		for (i = 0; i < NUM_MAX_REGISTRATION; i++)
			Resultat.Smb.Smb_Registration[i].Type = 0;

		Signature = 0;
		while ((Signature < Nb_Signature) && (memcmp (Liste_Signature[Signature].digest, Resultat.digest, 16) != 0)) {
			Signature++;
		}


		printf ("[S][%d] Signature : %02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X\n", Machine, Resultat.digest[0], Resultat.digest[1], Resultat.digest[2], Resultat.digest[3], Resultat.digest[4], Resultat.digest[5], Resultat.digest[6], Resultat.digest[7], Resultat.digest[8], Resultat.digest[9], Resultat.digest[10], Resultat.digest[11], Resultat.digest[12], Resultat.digest[13], Resultat.digest[14], Resultat.digest[15]);
		if (memcmp (Liste_Signature[Signature].digest, Resultat.digest, 16) == 0)
			printf ("[S][%d] System : [%s]    Type : [%d]\n", Machine, Liste_Signature[Signature].Nom, Liste_Signature[Signature].Type_Machine);
		else
			printf ("[S][%d] System : Inconnu\n", Machine);
		if (Liste_Signature[Signature].Requete_Netbios == 1)
			printf ("[S][%d] Requete netbios : Oui\n", Machine);
		else
			printf ("[S][%d] Requete netbios : non\n", Machine);

		if (Liste_Signature[Signature].Routeur == 1)
			printf ("[S][%d] Teste Routeur : Oui\n", Machine);
		else
			printf ("[S][%d] Teste Routeur : non\n", Machine);


		if (Liste_Signature[Signature].Requete_Netbios == 1) {
			/* Envoie une demande NETBIOS */
			printf ("[S][%d] Envoie demande NETBIOS a [%s]\n", Machine, Liste_Machines[Machine].Adresse_Ip);
			Tentative_NetBios = 0;
			while ((Tentative_NetBios < 3) && (!Demande_NetBios (&Resultat, Machine, Tentative_NetBios))) {	// boolean
				Tentative_NetBios++;
				sleep (5);
				printf ("[S][%d] Nouvelle tentative(%d) de demande NETBIOS a [%s]\n", Machine, Tentative_NetBios, Liste_Machines[Machine].Adresse_Ip);
			}
		}

		printf ("[S][%d] ***********************\n", Machine);
		printf ("[S][%d] Adresse_Ip : %s\n", Machine, Resultat.Adresse_Ip);
		printf ("[S][%d] Adresse_Mac : %s\n", Machine, Resultat.Adresse_Mac);
		printf ("[S][%d] Signature : %02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X\n", Machine, Resultat.digest[0], Resultat.digest[1], Resultat.digest[2], Resultat.digest[3], Resultat.digest[4], Resultat.digest[5], Resultat.digest[6], Resultat.digest[7], Resultat.digest[8], Resultat.digest[9], Resultat.digest[10], Resultat.digest[11], Resultat.digest[12], Resultat.digest[13], Resultat.digest[14], Resultat.digest[15]);
		printf ("[S][%d] Nom NetBios: %s\n", Machine, Resultat.Smb.HostName);
		printf ("[S][%d] Nom du Domaine : %s\n", Machine, Resultat.Smb.DomainName);
		printf ("[S][%d] Nom de l'utilisateur : %s\n", Machine, Resultat.Smb.Utilisateur);
		i = 0;
		while (Resultat.Smb.Smb_Registration[i].Type != 0) {
			if (Resultat.Smb.Smb_Registration[i].Type == REGISTRATION_GROUP)
				printf ("[S][%d] GROUP %s <%02X>\n", Machine, Resultat.Smb.Smb_Registration[i].Name, Resultat.Smb.Smb_Registration[i].Numero);
			else
				printf ("[S][%d] UNIQUE   %s <%02X>\n", Machine, Resultat.Smb.Smb_Registration[i].Name, Resultat.Smb.Smb_Registration[i].Numero);
			i++;
		}
		if (Resultat.Serveur)
			printf ("[S][%d] Machine Serveur\n", Machine);
		else
			printf ("[S][%d] Machine non serveur\n", Machine);
		printf ("[S][%d] Nb port Ouvert : %d\n", Machine, Resultat.Nb_Port_Ouvert);
		for (i = 0; i < Resultat.Nb_Port_Ouvert; i++) {
			printf ("[S][%d] Port %d ouvert   IndexPort(%d)   Type_Machine(%d)\n", Machine, Resultat.Port[i].Num_Port, Resultat.Port[i].Index_Port, Resultat.Port[i].Type_Machine);
		}
		printf ("[S][%d] ***********************\n", Machine);


		if (!Liste_Machines[Machine].Machine_ReScanner)	// boolean
			sem_post (&Semaphore_Thread_Scan);
		else
			Message ("Rescan finish", INFO);
		Liste_Machines[Machine].Machine_ReScanner = TRUE;	// boolean
		Liste_Machines[Machine].Scan_Port_En_Cours = FALSE;	// boolean


		Resultat.Nb_Machine_Dans_La_Liste = Nb_Machine_Dans_La_Liste;
		Resultat.Nb_Machine_En_Cours_De_Scan = Nb_Max_Thread - Valeur_Semaphore (&Semaphore_Thread_Scan);
		Resultat.Nb_Machine_En_Attente_De_Scan = Valeur_Semaphore (&Semaphore_Nouvelle_Machine);
		if (msgsnd (File_Reception_Nouvelle_Machine, (void *) &Resultat, sizeof (Resultat) - sizeof (long), 0) < 0) {
			perror ("[S] msgsnd");
			exit (1);
		}
		printf ("[S][%d] Fin Scan %d  En cours de scan (%d) / (%d)\n", Machine, getpid (), Nb_Max_Thread - Valeur_Semaphore (&Semaphore_Thread_Scan), Valeur_Semaphore (&Semaphore_Nouvelle_Machine));
	}
	else
		Message ("Already scanning", WARNING);
	pthread_exit (NULL);
}
