/*
 *  Copyright (C) 2004 Thierry Lagarde <tlagarde@user.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "Reseau.h"
#include "callbacks.h"
#include "Machine.h"
#include <gtk/gtk.h>

void Debut_Debug (int Machine)
{
	char      Chemin[255];

	sprintf (Chemin, "/root/.Autoscan/Debug/%d.log", Machine);
	if ((Liste_Machines[Machine].Debug_Scan = fopen (Chemin, "a")) == NULL) {
		perror ("fopen :");
		printf ("Impossible d'ecrire fichier debug\n");
		exit (-1);
	}	
}

void Debut_Debug_Scan (int Machine)
{
	char      Chemin[255];

	sprintf (Chemin, "/root/.Autoscan/Debug/%d.log", Machine);
	if ((Liste_Machines[Machine].Debug_Scan = fopen (Chemin, "w")) == NULL) {
		perror ("fopen :");
		printf ("Impossible d'ecrire fichier debug\n");
		exit (-1);
	}	
}

void Afficher_Debug_Scan (int Machine)
{
	char      Chemin[255], buf[512];;
	FILE     *Fichier_Debug;

	gtk_text_set_point (GTK_EDITABLE (textview_Debug_Scan), 0);
	gtk_text_forward_delete (GTK_EDITABLE (textview_Debug_Scan), gtk_text_get_length (GTK_EDITABLE (textview_Debug_Scan)));	
	sprintf (Chemin, "/root/.Autoscan/Debug/%d.log", Machine);
	if ((Fichier_Debug = fopen (Chemin, "r")) == NULL) {
		perror ("fopen :");
		printf ("Impossible d'ecrire fichier debug\n");
		exit (-1);
	}	
	while (fgets (buf, sizeof (buf), Fichier_Debug)) {
		gtk_text_insert(GTK_EDITABLE(textview_Debug_Scan),NULL,NULL,NULL,buf,strlen(buf));
	}
	fclose (Fichier_Debug);
}

void Debug_Scan_0 (int Machine, char *Message)
{
	if (fputs (Message,Liste_Machines[Machine].Debug_Scan) != 1) {
		printf ("Erreur Ecriture fichier Debug_Scan\n");
	}
	fflush(Liste_Machines[Machine].Debug_Scan);
}



void Debug_Scan (int Machine, char *Message, gpointer * donnee)
{
	char      Tmp[255];

	sprintf (Tmp, Message, donnee);
	if (fputs (Tmp, Liste_Machines[Machine].Debug_Scan) != 1) {
		printf ("Erreur Ecriture fichier Debug_Scan\n");
	}
	fflush(Liste_Machines[Machine].Debug_Scan);
}

void Debug_Scan_2 (int Machine, char *Message, gpointer * donnee, gpointer * donnee2)
{
	char      Tmp[255];

	sprintf (Tmp, Message, donnee, donnee2);
	if (fputs (Tmp, Liste_Machines[Machine].Debug_Scan) != 1) {
		printf ("Erreur Ecriture fichier Debug_Scan\n");
	}
	fflush(Liste_Machines[Machine].Debug_Scan);
}

void Debug_Scan_3 (int Machine, char *Message, gpointer * donnee, gpointer * donnee2, gpointer * donnee3)
{
	char      Tmp[255];

	sprintf (Tmp, Message, donnee, donnee2, donnee3);
	if (fputs (Tmp, Liste_Machines[Machine].Debug_Scan) != 1) {
		printf ("Erreur Ecriture fichier Debug_Scan\n");
	}
	fflush(Liste_Machines[Machine].Debug_Scan);
}

void Debug_Scan_4 (int Machine, char *Message, gpointer * donnee, gpointer * donnee2, gpointer * donnee3, gpointer * donnee4)
{
	char      Tmp[255];

	sprintf (Tmp, Message, donnee, donnee2, donnee3, donnee4);
	if (fputs (Tmp, Liste_Machines[Machine].Debug_Scan) != 1) {
		printf ("Erreur Ecriture fichier Debug_Scan\n");
	}
	fflush(Liste_Machines[Machine].Debug_Scan);
}

void Debug_Scan_7 (int Machine, char *Message, gpointer * donnee, gpointer * donnee2, gpointer * donnee3, gpointer * donnee4, gpointer * donnee5, gpointer * donnee6, gpointer * donnee7)
{
	char      Tmp[255];

	sprintf (Tmp, Message, donnee, donnee2, donnee3, donnee4, donnee5, donnee6, donnee7);
	if (fputs (Tmp, Liste_Machines[Machine].Debug_Scan) != 1) {
		printf ("Erreur Ecriture fichier Debug_Scan\n");
	}
	fflush(Liste_Machines[Machine].Debug_Scan);
}


void Debug_Scan_16 (int Machine, char *Message, gpointer * donnee, gpointer * donnee2, gpointer * donnee3, gpointer * donnee4, gpointer * donnee5, gpointer * donnee6, gpointer * donnee7, gpointer * donnee8, gpointer * donnee9, gpointer * donnee10, gpointer * donnee11, gpointer * donnee12, gpointer * donnee13, gpointer * donnee14, gpointer * donnee15, gpointer * donnee16)
{
	char      Tmp[255];

	sprintf (Tmp, Message, donnee, donnee2, donnee3, donnee4, donnee5, donnee6, donnee7, donnee8, donnee9, donnee10, donnee11, donnee12, donnee13, donnee14, donnee15, donnee16);
	if (fputs (Tmp, Liste_Machines[Machine].Debug_Scan) != 1) {
		printf ("Erreur Ecriture fichier Debug_Scan\n");
	}
	fflush(Liste_Machines[Machine].Debug_Scan);
}


void Fin_Debug_Scan (int Machine)
{
	fclose (Liste_Machines[Machine].Debug_Scan);
	Liste_Machines[Machine].Debug_Scan = NULL;
}
