/*
 *  Copyright (C) 2004 Thierry Lagarde <tlagarde@user.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "Reseau.h"
#include "callbacks.h"
#include "Port.h"
#include "Machine.h"


gboolean Enregistrement (char *Chemin)
{
	FILE     *Fichier_Reseau;
	char      buf[512];
	int       i, j, NumMachine, Type_Machine, Index_Port, NbEnregistrement;

	printf ("[I] Enregistrement\n");
	if ((Fichier_Reseau = fopen (Chemin, "w")) == NULL) {
		perror ("[I] fopen :");
		printf ("[I] Impossible d'enregistrer reseau\n");
		exit (-1);
	}
	NumMachine = 0;
	while (Liste_Machines[NumMachine].Adresse_Ip[0] != 0) {
		sprintf (buf, "[%s]\n", Liste_Machines[NumMachine].Adresse_Mac);
		printf ("[I] %d  %s\n", NumMachine, buf);
		if (fputs (buf, Fichier_Reseau) != 1)
			printf ("[I] Erreur Ecriture fichier reseau\n");
		sprintf (buf, "    [Adresse_Ip=%s]\n", Liste_Machines[NumMachine].Adresse_Ip);
		if (fputs (buf, Fichier_Reseau) != 1)
			printf ("[I] Erreur Ecriture fichier reseau\n");
		sprintf (buf, "    [digest=%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X]\n", Liste_Machines[NumMachine].digest[0], Liste_Machines[NumMachine].digest[1], Liste_Machines[NumMachine].digest[2], Liste_Machines[NumMachine].digest[3], Liste_Machines[NumMachine].digest[4], Liste_Machines[NumMachine].digest[5], Liste_Machines[NumMachine].digest[6], Liste_Machines[NumMachine].digest[7], Liste_Machines[NumMachine].digest[8], Liste_Machines[NumMachine].digest[9], Liste_Machines[NumMachine].digest[10], Liste_Machines[NumMachine].digest[11], Liste_Machines[NumMachine].digest[12], Liste_Machines[NumMachine].digest[13], Liste_Machines[NumMachine].digest[14], Liste_Machines[NumMachine].digest[15]);
		if (fputs (buf, Fichier_Reseau) != 1)
			printf ("[I] Erreur Ecriture fichier reseau\n");

		sprintf (buf, "    [NumPort=%d]\n", Liste_Machines[NumMachine].Nb_Port_Ouvert);
		if (fputs (buf, Fichier_Reseau) != 1)
			printf ("[I] Erreur Ecriture fichier reseau\n");
		i = 0;
		while (Liste_Machines[NumMachine].Nb_Port_Ouvert != i) {
			Index_Port = -1;
			Type_Machine = INCONNU;
			for (j = 0; j < Nb_Port_Dans_Liste_Scan; j++) {
				if (Liste_Port_Scan[j].Num_Port == Liste_Machines[NumMachine].Port[i].Num_Port) {
					Index_Port = j;
					continue;
				}
			}
			if (Index_Port != -1) {
				printf ("[I] port %d  index%d   type %d\n", Liste_Port_Scan[Index_Port].Num_Port, Index_Port, Liste_Port_Scan[Index_Port].Type_Machine);
				Type_Machine = Liste_Port_Scan[Index_Port].Type_Machine;
			}

			sprintf (buf, "    [%d,%d,%d,%s]\n", Liste_Machines[NumMachine].Port[i].Num_Port, Liste_Machines[NumMachine].Port[i].Etat, Type_Machine, "");
			if (fputs (buf, Fichier_Reseau) != 1)
				printf ("[I] Erreur Ecriture fichier reseau\n");
			i++;
		}

		NbEnregistrement = 0;
		while (Liste_Machines[NumMachine].Smb.Smb_Registration[NbEnregistrement].Type != 0) {
			NbEnregistrement++;
		}
		sprintf (buf, "    [NumEnregistrement=%d]\n", NbEnregistrement);
		if (fputs (buf, Fichier_Reseau) != 1)
			printf ("[I] Erreur Ecriture fichier reseau\n");
		for (i = 0; i < NbEnregistrement; i++) {
			sprintf (buf, "    [%d,%d,%s]\n", Liste_Machines[NumMachine].Smb.Smb_Registration[i].Type, Liste_Machines[NumMachine].Smb.Smb_Registration[i].Numero, Liste_Machines[NumMachine].Smb.Smb_Registration[i].Name);
			printf("[I] %s\n",buf);
			if (fputs (buf, Fichier_Reseau) != 1)
				printf ("[I] Erreur Ecriture fichier reseau\n");

		}
		NumMachine++;
	}
	fclose (Fichier_Reseau);
}
