/*
 *  Copyright (C) 2004 Thierry Lagarde <tlagarde@user.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "Port.h"
#include "Reseau.h"
#include "callbacks.h"
#include "Machine.h"


extern int h_errno;

#define FIN 		-1
#define EFFACER 	-2



void Ajoute_Nouveau_Port (char *buf, int Emplacement)
{
	char     *pBuf;
	int       Taille;

	//printf ("Ajout\n");
	if (sscanf (buf, "%d;%d;%d;%d;%d;%d;%d;%d;%d;%d;%d;", &Liste_Port_Scan[Emplacement].Num_Port, &Liste_Port_Scan[Emplacement].Type_Machine, &Liste_Port_Scan[Emplacement].LireEntete, &Liste_Port_Scan[Emplacement].Marquer, &Liste_Port_Scan[Emplacement].red, &Liste_Port_Scan[Emplacement].green, &Liste_Port_Scan[Emplacement].blue, &Liste_Port_Scan[Emplacement].Etat_Port, &Liste_Port_Scan[Emplacement].Etat_Port_Fermer, &Liste_Port_Scan[Emplacement].Etat_Port_Message, &Liste_Port_Scan[Emplacement].Etat_Port_Email) != 11) {
		printf ("[I] Erreur de lecture du fichier PortListe\n");
		exit (0);
	}

	pBuf = index (buf, ';') + 1;
	pBuf = index (pBuf, ';') + 1;
	pBuf = index (pBuf, ';') + 1;
	pBuf = index (pBuf, ';') + 1;
	pBuf = index (pBuf, ';') + 1;
	pBuf = index (pBuf, ';') + 1;
	pBuf = index (pBuf, ';') + 1;
	pBuf = index (pBuf, ';') + 1;
	pBuf = index (pBuf, ';') + 1;
	pBuf = index (pBuf, ';') + 1;
	pBuf = index (pBuf, ';') + 1;
	//printf ("buf : [%s\n]", pBuf);
	/* Recupere le Nom */
	Taille = index (pBuf, ';') - pBuf;
	Liste_Port_Scan[Emplacement].Nom = malloc (sizeof (char) + Taille + 1);
	strncpy (Liste_Port_Scan[Emplacement].Nom, pBuf, Taille);
	Liste_Port_Scan[Emplacement].Nom[Taille] = 0;
	/* Recupere le chemin de l'icone */
	pBuf = pBuf + Taille + 1;
	Taille = index (pBuf, ';') - pBuf;
	Liste_Port_Scan[Emplacement].Fichier_Icone = malloc (sizeof (char) + Taille + 1);
	strncpy (Liste_Port_Scan[Emplacement].Fichier_Icone, pBuf, Taille);
	Liste_Port_Scan[Emplacement].Fichier_Icone[Taille] = 0;
	/* Recupere la description */
	pBuf = pBuf + Taille + 1;
	Taille = index (pBuf, ';') - pBuf;
	Liste_Port_Scan[Emplacement].Description = malloc (sizeof (char) + Taille + 1);
	strncpy (Liste_Port_Scan[Emplacement].Description, pBuf, Taille);
	Liste_Port_Scan[Emplacement].Description[Taille] = 0;
	/* Recupere le nom du programme */
	pBuf = pBuf + Taille + 1;
	Taille = index (pBuf, ';') - pBuf;
	Liste_Port_Scan[Emplacement].Programme = malloc (sizeof (char) + Taille + 1);
	strncpy (Liste_Port_Scan[Emplacement].Programme, pBuf, Taille);
	Liste_Port_Scan[Emplacement].Programme[Taille] = 0;
	/* Recupere en-tete */
	pBuf = pBuf + Taille + 1;
	Taille = index (pBuf, ';') - pBuf;
	Liste_Port_Scan[Emplacement].En_Tete = malloc (sizeof (char) + Taille + 1);
	strncpy (Liste_Port_Scan[Emplacement].En_Tete, pBuf, Taille);
	Liste_Port_Scan[Emplacement].En_Tete[Taille] = 0;
	/* Recupere le chemin de l'icone Fermer */
	pBuf = pBuf + Taille + 1;
	Taille = index (pBuf, ';') - pBuf;
	Liste_Port_Scan[Emplacement].Fichier_Icone_Fermer = malloc (sizeof (char) + Taille + 1);
	strncpy (Liste_Port_Scan[Emplacement].Fichier_Icone_Fermer, pBuf, Taille);
	Liste_Port_Scan[Emplacement].Fichier_Icone_Fermer[Taille] = 0;
	/* Recupere Email  */
	pBuf = pBuf + Taille + 1;
	Taille = index (pBuf, ';') - pBuf;
	Liste_Port_Scan[Emplacement].Email = malloc (sizeof (char) + Taille + 1);
	strncpy (Liste_Port_Scan[Emplacement].Email, pBuf, Taille);
	Liste_Port_Scan[Emplacement].Email[Taille] = 0;

}



void Creer_PortList ()
{
	FILE     *Fichier_PortList;
	char      buf[512],CheminFichier[256];
	
	sprintf (CheminFichier, "%s/.AutoScan/Conf/Port", Info_User->pw_dir);
	if ((Fichier_PortList = fopen (CheminFichier, "r")) == NULL) {
		perror ("[I] fopen :");
		printf ("[I] Impossible de lire PortListe\n");
		exit (-1);
	}
	Nb_Port_Dans_Liste_Scan = 0;
	while (fgets (buf, sizeof (buf), Fichier_PortList))
		Nb_Port_Dans_Liste_Scan++;
	rewind (Fichier_PortList);
	Liste_Port_Scan = (struct struct_Liste_Port *) malloc (sizeof (struct struct_Liste_Port) * (Nb_Port_Dans_Liste_Scan + 1));
	Nb_Port_Dans_Liste_Scan = 0;

	while (fgets (buf, sizeof (buf), Fichier_PortList)) {
		Ajoute_Nouveau_Port (buf, Nb_Port_Dans_Liste_Scan);
		Nb_Port_Dans_Liste_Scan++;
	}
	Liste_Port_Scan[Nb_Port_Dans_Liste_Scan].Num_Port = FIN;	//FIN
	printf ("[I] Creation de la liste des ports (%d ports trouves)\n", Nb_Port_Dans_Liste_Scan);
	fclose (Fichier_PortList);
}



/*
*
*      Interface
*/

void Init_Info_Port ()
{
	/* Initialise l interface */
	Modif_Port = TRUE;	// permet de ne pas prendre en compte les modifications par la fonction Liste_Port_changed
	gnome_icon_entry_set_filename (iconentry_Liste_Port_Ouvert, NULL);
	gnome_icon_entry_set_filename (iconentry_Liste_Port_Fermer, NULL);
	gtk_entry_set_text (GTK_ENTRY (combo_entry_Liste_Port_Machine_Type), "Other");
	gtk_entry_set_text (GTK_ENTRY (entry_Liste_Port_Service), "");
	gtk_entry_set_text (GTK_ENTRY (entry_Liste_Port_Programme), "");
	gtk_entry_set_text (GTK_ENTRY (entry_Liste_Port_Description), "");
	gtk_entry_set_text (GTK_ENTRY (entry_Liste_Port_Etat_Action_Email), "");
//      gtk_entry_set_text (GTK_ENTRY (entry_Liste_Port_Entete), "");
	gtk_adjustment_set_value (GTK_ADJUSTMENT (spinbutton_Liste_Port_Port_adj), 1);
//      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_Liste_Port_entete), FALSE);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_Liste_Port_Marque), FALSE);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_Liste_Port_Etat), FALSE);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_Liste_Port_Etat_Close), FALSE);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_Liste_Port_Etat_Action_Email), FALSE);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_Liste_Port_Etat_Action_Message), FALSE);
	gtk_widget_set_sensitive (checkbutton_Liste_Port_Marque, FALSE);
	gtk_widget_set_sensitive (ctree_Liste_Port, TRUE);
	gtk_widget_set_sensitive (button_Liste_Port_Ajouter, TRUE);
	gtk_widget_set_sensitive (button_Liste_Port_Sauvegarder, TRUE);
	gtk_widget_set_sensitive (button_Liste_Port_Ok, FALSE);
	gtk_widget_set_sensitive (button_Liste_Port_Annuler, FALSE);
	gtk_widget_set_sensitive (combo_entry_Liste_Port_Machine_Type, FALSE);
	gtk_widget_set_sensitive (entry_Liste_Port_Service, FALSE);
	gtk_widget_set_sensitive (entry_Liste_Port_Description, FALSE);
//      gtk_widget_set_sensitive (entry_Liste_Port_Entete, FALSE);
//      gtk_widget_set_sensitive (checkbutton_Liste_Port_entete, FALSE);
	gtk_widget_set_sensitive (checkbutton_Liste_Port_Etat, FALSE);
	gtk_widget_set_sensitive (label_Liste_Port_Etat, FALSE);
	gtk_widget_set_sensitive (checkbutton_Liste_Port_Etat_Close, FALSE);
	gtk_widget_set_sensitive (checkbutton_Liste_Port_Etat_Action_Email, FALSE);
	gtk_widget_set_sensitive (checkbutton_Liste_Port_Etat_Action_Message, FALSE);
	gtk_widget_set_sensitive (entry_Liste_Port_Etat_Action_Email, FALSE);
	gtk_widget_set_sensitive (spinbutton_Liste_Port_Port, FALSE);
	gtk_widget_set_sensitive (iconentry_Liste_Port_Ouvert, FALSE);
	gtk_widget_set_sensitive (iconentry_Liste_Port_Fermer, FALSE);
	gtk_widget_set_sensitive (entry_Liste_Port_Programme, FALSE);
	gtk_widget_set_sensitive (colorpicker_Liste_Port, FALSE);
	Port_Selectionner = -1;
	Ajout_Port = FALSE;
	Modif_Port = FALSE;
}

void Change_Etat_Port ()
{
	if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (checkbutton_Liste_Port_Etat))) {
		gtk_widget_set_sensitive (label_Liste_Port_Etat, TRUE);
		gtk_widget_set_sensitive (checkbutton_Liste_Port_Etat_Close, TRUE);
		gtk_widget_set_sensitive (checkbutton_Liste_Port_Etat_Action_Email, TRUE);
		gtk_widget_set_sensitive (checkbutton_Liste_Port_Etat_Action_Message, TRUE);
		gtk_widget_set_sensitive (entry_Liste_Port_Etat_Action_Email, TRUE);
	}
	else {
		gtk_widget_set_sensitive (label_Liste_Port_Etat, FALSE);
		gtk_widget_set_sensitive (checkbutton_Liste_Port_Etat_Close, FALSE);
		gtk_widget_set_sensitive (checkbutton_Liste_Port_Etat_Action_Email, FALSE);
		gtk_widget_set_sensitive (checkbutton_Liste_Port_Etat_Action_Message, FALSE);
		gtk_widget_set_sensitive (entry_Liste_Port_Etat_Action_Email, FALSE);
	}
}


void on_checkbutton_Liste_Port_Etat_clicked (GtkButton * button, gpointer user_data)
{
	Change_Etat_Port ();
}

void on_liste_ports_activate (GtkMenuItem * menuitem, gpointer user_data)
{
	gchar    *text[3];
	char      Tmp[255];
	int       i;
	GtkCTreeNode *Node;
	GdkColor  color;

	Init_Info_Port ();
	gtk_widget_set_sensitive (button_Liste_Port_Enlever, FALSE);
	gtk_clist_clear (GTK_CLIST (ctree_Liste_Port));
	gtk_clist_freeze (GTK_CLIST (ctree_Liste_Port));
	for (i = 0; i < Nb_Port_Dans_Liste_Scan; i++) {
		if (Liste_Port_Scan[i].Num_Port != EFFACER) {
			sprintf (Tmp, "%d", Liste_Port_Scan[i].Num_Port);
			text[0] = g_strdup_printf (Tmp);
			text[1] = g_strdup_printf (Liste_Port_Scan[i].Nom);
			text[2] = g_strdup_printf (Liste_Port_Scan[i].Description);
			Node = gtk_ctree_insert_node (GTK_CTREE (ctree_Liste_Port), NULL, NULL, text, 5, NULL, NULL, NULL, NULL, FALSE, FALSE);
			gtk_ctree_node_set_row_data (GTK_CTREE (ctree_Liste_Port), Node, (gpointer *) i);
			Liste_Port_Scan[i].Node = Node;
			g_free (text[0]);
			g_free (text[1]);
			g_free (text[2]);
			if (Liste_Port_Scan[i].Marquer == 1) {
				color.red = Liste_Port_Scan[i].red * 255;
				color.green = Liste_Port_Scan[i].green * 255;
				color.blue = Liste_Port_Scan[i].blue * 255;
				gtk_ctree_node_set_background (GTK_CTREE (ctree_Liste_Port), Node, &color);
			}
		}
	}
	gtk_clist_thaw (GTK_CLIST (ctree_Liste_Port));
	gtk_widget_show (window_Liste_Port);
}





void on_button_Liste_Port_Ajouter_clicked (GtkButton * button, gpointer user_data)
{
	Init_Info_Port ();
	Ajout_Port = TRUE;
	printf ("[I] Ajoute un nouveau port\n");
	gtk_widget_set_sensitive (button_Liste_Port_Ajouter, FALSE);
	gtk_widget_set_sensitive (button_Liste_Port_Enlever, FALSE);
	gtk_widget_set_sensitive (button_Liste_Port_Sauvegarder, FALSE);
//      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_Liste_Port_entete), FALSE);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_Liste_Port_Marque), FALSE);
	gtk_widget_set_sensitive (button_Liste_Port_Ok, TRUE);
	gtk_widget_set_sensitive (button_Liste_Port_Annuler, TRUE);
	gtk_widget_set_sensitive (combo_entry_Liste_Port_Machine_Type, TRUE);
	gtk_widget_set_sensitive (entry_Liste_Port_Service, TRUE);
	gtk_widget_set_sensitive (entry_Liste_Port_Description, TRUE);
//      gtk_widget_set_sensitive (entry_Liste_Port_Entete, TRUE);
//      gtk_widget_set_sensitive (checkbutton_Liste_Port_entete, TRUE);
	gtk_widget_set_sensitive (checkbutton_Liste_Port_Marque, TRUE);
	gtk_widget_set_sensitive (spinbutton_Liste_Port_Port, TRUE);
	gtk_widget_set_sensitive (iconentry_Liste_Port_Ouvert, TRUE);
	gtk_widget_set_sensitive (iconentry_Liste_Port_Fermer, TRUE);
	gtk_widget_set_sensitive (entry_Liste_Port_Programme, TRUE);
	gtk_widget_set_sensitive (colorpicker_Liste_Port, TRUE);
	gtk_widget_set_sensitive (ctree_Liste_Port, FALSE);
	gtk_widget_set_sensitive (checkbutton_Liste_Port_Etat, FALSE);  //<<<<<<<<<<<<<<<<<<<<<<<<<<
	Change_Etat_Port ();
	/*gtk_widget_set_sensitive (checkbutton_Liste_Port_Etat_Close, TRUE);
	gtk_widget_set_sensitive (checkbutton_Liste_Port_Etat_Action_Email, TRUE);
	gtk_widget_set_sensitive (checkbutton_Liste_Port_Etat_Action_Message, TRUE);
	gtk_widget_set_sensitive (entry_Liste_Port_Etat_Action_Email, TRUE);*/
	gnome_color_picker_set_i8 (colorpicker_Liste_Port, 255, 255, 255, 0);

}


void on_button_Liste_Port_Enlever_clicked (GtkButton * button, gpointer user_data)
{
	if (Port_Selectionner != -1) {
		printf ("[I] Suppression du port %d\n", Liste_Port_Scan[Port_Selectionner].Num_Port);
		gtk_ctree_remove_node (ctree_Liste_Port, Liste_Port_Scan[Port_Selectionner].Node);
		Liste_Port_Scan[Port_Selectionner].Num_Port = EFFACER;
		Port_Selectionner = -1;
		gtk_widget_set_sensitive (button_Liste_Port_Enlever, FALSE);
		Init_Info_Port ();
	}
}


void on_button_Liste_Port_Ok_clicked (GtkButton * button, gpointer user_data)
{
	int       type, Marquer, Entete, Index, Port, IndexFrere, FrereTrouve;
	gchar    *text[3];
	char      Tmp[512], red, green, blue, alpha, Etat_Port, Etat_Port_Fermer, Etat_Port_Message, Etat_Port_Email;
	GtkCTreeNode *Node;
	GtkCTreeNode *Frere;
	GdkColor  color;


	if (Modif_Port) {
		printf ("[I] Suppression du port Modifie %d\n", Liste_Port_Scan[Port_Selectionner].Num_Port);
		printf ("[I] Suppression du port %d\n", Liste_Port_Scan[Port_Selectionner].Num_Port);
		gtk_ctree_remove_node (ctree_Liste_Port, Liste_Port_Scan[Port_Selectionner].Node);
		Liste_Port_Scan[Port_Selectionner].Num_Port = EFFACER;
	}
	Port = (int) gtk_adjustment_get_value (GTK_ADJUSTMENT (spinbutton_Liste_Port_Port_adj));
	printf ("[I] Ajout du port %d\n", Port);
	/* Cherche si le port existe déjà */
	for (Index = 0; Index < Nb_Port_Dans_Liste_Scan; Index++) {
		if (Liste_Port_Scan[Index].Num_Port == Port)
			return;
	}

	gnome_color_picker_get_i8 (colorpicker_Liste_Port, &red, &green, &blue, &alpha);
	type = INCONNU;
	if (strcmp (gtk_entry_get_text (GTK_ENTRY (combo_entry_Liste_Port_Machine_Type)), "Materiel") == 0)
		type = MATERIEL;
	if (strcmp (gtk_entry_get_text (GTK_ENTRY (combo_entry_Liste_Port_Machine_Type)), "Server") == 0)
		type = SERVEUR;
	if (strcmp (gtk_entry_get_text (GTK_ENTRY (combo_entry_Liste_Port_Machine_Type)), "Station") == 0)
		type = STATION;
/*	if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (checkbutton_Liste_Port_entete)))
		Entete = 1;
	else
		Entete = 0;*/
	Entete = 0;		//inutilisé

	if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (checkbutton_Liste_Port_Marque)))
		Marquer = 1;
	else
		Marquer = 0;

	if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (checkbutton_Liste_Port_Etat)))
		Etat_Port = 1;
	else
		Etat_Port = 0;

	if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (checkbutton_Liste_Port_Etat_Close)))
		Etat_Port_Fermer = 1;
	else
		Etat_Port_Fermer = 0;

	if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (checkbutton_Liste_Port_Etat_Action_Message)))
		Etat_Port_Message = 1;
	else
		Etat_Port_Message = 0;

	if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (checkbutton_Liste_Port_Etat_Action_Email)))
		Etat_Port_Email = 1;
	else
		Etat_Port_Email = 0;



	sprintf (Tmp, "%d;%d;%d;%d;%d;%d;%d;%d;%d;%d;%d;%s;%s;%s;%s;%s;%s;%s;\n", (int) gtk_adjustment_get_value (GTK_ADJUSTMENT (spinbutton_Liste_Port_Port_adj)), type, Entete, Marquer, red, green, blue, Etat_Port, Etat_Port_Fermer, Etat_Port_Message, Etat_Port_Email, gtk_entry_get_text (GTK_ENTRY (entry_Liste_Port_Service)), gnome_icon_entry_get_filename (iconentry_Liste_Port_Ouvert), gtk_entry_get_text (GTK_ENTRY (entry_Liste_Port_Description)), gtk_entry_get_text (GTK_ENTRY (entry_Liste_Port_Programme)), "", gnome_icon_entry_get_filename (iconentry_Liste_Port_Fermer), gtk_entry_get_text (GTK_ENTRY (entry_Liste_Port_Etat_Action_Email)));
	printf ("[I] Buf : [%s]\n", Tmp);

	/* Redimensionne le tableau */
	if ((Liste_Port_Scan = realloc (Liste_Port_Scan, sizeof (struct struct_Liste_Port) * (Nb_Port_Dans_Liste_Scan + 2))) == NULL) {
		printf ("[I] Realloc erreur\n");
		exit (0);
	}
	/* Ajoute le nouveau port dans le tableau */
	Ajoute_Nouveau_Port (Tmp, Nb_Port_Dans_Liste_Scan);
	Nb_Port_Dans_Liste_Scan++;
	Liste_Port_Scan[Nb_Port_Dans_Liste_Scan].Num_Port = FIN;	//FIN
	/* Affiche la nouvelle entree dans la liste */
	sprintf (Tmp, "%d", Liste_Port_Scan[Index].Num_Port);
	text[0] = g_strdup_printf (Tmp);
	text[1] = g_strdup_printf (Liste_Port_Scan[Index].Nom);
	text[2] = g_strdup_printf (Liste_Port_Scan[Index].Description);
	/* Recherche son frere */
	Frere = NULL;
	IndexFrere = 0;
	FrereTrouve = -1;
	while (IndexFrere < (Nb_Port_Dans_Liste_Scan - 1)) {	// -1 pour pas qu'il scan le nouveau 
		if (Liste_Port_Scan[IndexFrere].Num_Port > 0) {
			printf ("[I] Moi %d=%d<%d\n", Index, Liste_Port_Scan[Index].Num_Port, Liste_Port_Scan[IndexFrere].Num_Port);
			if (Liste_Port_Scan[Index].Num_Port < Liste_Port_Scan[IndexFrere].Num_Port) {
				printf ("[I] Frere trouve %d\n", IndexFrere);
				if (FrereTrouve != -1) {
					printf ("%d < %d\n", (Liste_Port_Scan[IndexFrere].Num_Port - Liste_Port_Scan[Index].Num_Port), (Liste_Port_Scan[FrereTrouve].Num_Port - Liste_Port_Scan[Index].Num_Port));
					if ((Liste_Port_Scan[IndexFrere].Num_Port - Liste_Port_Scan[Index].Num_Port) < (Liste_Port_Scan[FrereTrouve].Num_Port - Liste_Port_Scan[Index].Num_Port)) {
						printf ("[I] Nouveau frere + proche %d\n", IndexFrere);
						Frere = Liste_Port_Scan[IndexFrere].Node;
						FrereTrouve = IndexFrere;
					}
				}
				else {	// Aucun frere déjà trouver
					Frere = Liste_Port_Scan[IndexFrere].Node;
					FrereTrouve = IndexFrere;
				}
			}
			else
				printf ("[I] Pas de frere %d\n", IndexFrere);
		}
		IndexFrere++;
	}
	Node = gtk_ctree_insert_node (GTK_CTREE (ctree_Liste_Port), NULL, Frere, text, 5, NULL, NULL, NULL, NULL, FALSE, FALSE);
	gtk_ctree_node_set_row_data (GTK_CTREE (ctree_Liste_Port), Node, (gpointer *) (Nb_Port_Dans_Liste_Scan - 1));
	Liste_Port_Scan[Index].Node = Node;
	if (Liste_Port_Scan[Index].Marquer == 1) {
		color.red = Liste_Port_Scan[Index].red * 255;
		color.green = Liste_Port_Scan[Index].green * 255;
		color.blue = Liste_Port_Scan[Index].blue * 255;
		gtk_ctree_node_set_background (GTK_CTREE (ctree_Liste_Port), Node, &color);
	}
	g_free (text[0]);
	g_free (text[1]);
	g_free (text[2]);

	Init_Info_Port ();
}


void on_button_Liste_Port_Annuler_clicked (GtkButton * button, gpointer user_data)
{
	if (Modif_Port)
		printf ("[I] Annulation Modification du port %d\n", Liste_Port_Scan[Port_Selectionner].Num_Port);
	else
		printf ("[I] Annulation Ajout du port %d\n", (int) gtk_adjustment_get_value (GTK_ADJUSTMENT (spinbutton_Liste_Port_Port_adj)));
	Init_Info_Port ();
}




void on_ctree_Liste_Port_tree_select_row (GtkCTree * ctree, GtkCTreeNode * node, gint column, gpointer user_data)
{
	Port_Selectionner = (int) gtk_ctree_node_get_row_data (GTK_CTREE (ctree), node);
	printf ("[I] Port : %d\n", Port_Selectionner);
	Modif_Port = TRUE;	// permet de ne pas prendre en compte les modifications par la fonction Liste_Port_changed
	/* Affichage des Données */
	gtk_entry_set_text (GTK_ENTRY (entry_Liste_Port_Service), Liste_Port_Scan[Port_Selectionner].Nom);
	gtk_entry_set_text (GTK_ENTRY (entry_Liste_Port_Programme), Liste_Port_Scan[Port_Selectionner].Programme);
	gtk_entry_set_text (GTK_ENTRY (entry_Liste_Port_Description), Liste_Port_Scan[Port_Selectionner].Description);
//      gtk_entry_set_text (GTK_ENTRY (entry_Liste_Port_Entete), Liste_Port_Scan[Port_Selectionner].En_Tete);
	gtk_adjustment_set_value (GTK_ADJUSTMENT (spinbutton_Liste_Port_Port_adj), Liste_Port_Scan[Port_Selectionner].Num_Port);
	gtk_entry_set_text (GTK_ENTRY (entry_Liste_Port_Etat_Action_Email), Liste_Port_Scan[Port_Selectionner].Email);

/*	if (Liste_Port_Scan[Port_Selectionner].LireEntete == 0)
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_Liste_Port_entete), FALSE);
	else
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_Liste_Port_entete), TRUE);
*/
	if (Liste_Port_Scan[Port_Selectionner].Marquer == 0)
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_Liste_Port_Marque), FALSE);
	else
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_Liste_Port_Marque), TRUE);

	if (Liste_Port_Scan[Port_Selectionner].Etat_Port == 0)
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_Liste_Port_Etat), FALSE);
	else
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_Liste_Port_Etat), TRUE);

	if (Liste_Port_Scan[Port_Selectionner].Etat_Port_Fermer == 0)
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_Liste_Port_Etat_Close), FALSE);
	else
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_Liste_Port_Etat_Close), TRUE);

	if (Liste_Port_Scan[Port_Selectionner].Etat_Port_Message == 0)
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_Liste_Port_Etat_Action_Message), FALSE);
	else
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_Liste_Port_Etat_Action_Message), TRUE);

	if (Liste_Port_Scan[Port_Selectionner].Etat_Port_Email == 0)
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_Liste_Port_Etat_Action_Email), FALSE);
	else
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_Liste_Port_Etat_Action_Email), TRUE);

	switch (Liste_Port_Scan[Port_Selectionner].Type_Machine) {
	    case MATERIEL:
		    gtk_entry_set_text (GTK_ENTRY (combo_entry_Liste_Port_Machine_Type), "Materiel");
		    break;
	    case SERVEUR:
		    gtk_entry_set_text (GTK_ENTRY (combo_entry_Liste_Port_Machine_Type), "Server");
		    break;
	    case STATION:
		    gtk_entry_set_text (GTK_ENTRY (combo_entry_Liste_Port_Machine_Type), "Station");
		    break;
	    default:
		    gtk_entry_set_text (GTK_ENTRY (combo_entry_Liste_Port_Machine_Type), "Other");
	}
	if (strlen (Liste_Port_Scan[Port_Selectionner].Fichier_Icone) == 0) {
		printf ("[I] Pas Icone\n");
		gnome_icon_entry_set_filename (iconentry_Liste_Port_Ouvert, NULL);
	}
	else {
		if (!gnome_icon_entry_set_filename (iconentry_Liste_Port_Ouvert, Liste_Port_Scan[Port_Selectionner].Fichier_Icone))
			printf ("[I] Icone %s non charger\n", Liste_Port_Scan[Port_Selectionner].Fichier_Icone);
	}

	if (strlen (Liste_Port_Scan[Port_Selectionner].Fichier_Icone_Fermer) == 0) {
		printf ("[I] Pas Icone Fermer\n");
		gnome_icon_entry_set_filename (iconentry_Liste_Port_Fermer, NULL);
	}
	else {
		if (!gnome_icon_entry_set_filename (iconentry_Liste_Port_Fermer, Liste_Port_Scan[Port_Selectionner].Fichier_Icone_Fermer))
			printf ("[I] Icone Fermer %s non charger\n", Liste_Port_Scan[Port_Selectionner].Fichier_Icone_Fermer);
	}
	gnome_color_picker_set_i8 (colorpicker_Liste_Port, Liste_Port_Scan[Port_Selectionner].red, Liste_Port_Scan[Port_Selectionner].green, Liste_Port_Scan[Port_Selectionner].blue, 0);
	gtk_widget_set_sensitive (button_Liste_Port_Ok, FALSE);
	gtk_widget_set_sensitive (button_Liste_Port_Annuler, FALSE);
	gtk_widget_set_sensitive (button_Liste_Port_Ajouter, TRUE);
	gtk_widget_set_sensitive (button_Liste_Port_Enlever, TRUE);
	gtk_widget_set_sensitive (button_Liste_Port_Sauvegarder, TRUE);
	Change_Etat_Port ();
	gtk_widget_set_sensitive (combo_entry_Liste_Port_Machine_Type, TRUE);
	gtk_widget_set_sensitive (entry_Liste_Port_Service, TRUE);
	gtk_widget_set_sensitive (entry_Liste_Port_Description, TRUE);
//      gtk_widget_set_sensitive (entry_Liste_Port_Entete, TRUE);
//      gtk_widget_set_sensitive (checkbutton_Liste_Port_entete, TRUE);
	gtk_widget_set_sensitive (checkbutton_Liste_Port_Marque, TRUE);
	gtk_widget_set_sensitive (spinbutton_Liste_Port_Port, TRUE);
	gtk_widget_set_sensitive (iconentry_Liste_Port_Ouvert, TRUE);
	gtk_widget_set_sensitive (iconentry_Liste_Port_Fermer, TRUE);
	gtk_widget_set_sensitive (entry_Liste_Port_Programme, TRUE);
	gtk_widget_set_sensitive (colorpicker_Liste_Port, TRUE);
	gtk_widget_set_sensitive (checkbutton_Liste_Port_Etat, FALSE);   //<<<<<<<<<<<<<<<<<<<<<<<<<<<
	Modif_Port = FALSE;
	Ajout_Port = FALSE;
}



void Liste_Port_changed (GtkEditable * editable, gpointer user_data)
{
	if ((!Modif_Port) && (!Ajout_Port)) {
		gtk_widget_set_sensitive (button_Liste_Port_Ajouter, FALSE);
		gtk_widget_set_sensitive (button_Liste_Port_Enlever, FALSE);
		gtk_widget_set_sensitive (button_Liste_Port_Sauvegarder, FALSE);
		gtk_widget_set_sensitive (button_Liste_Port_Annuler, TRUE);
		gtk_widget_set_sensitive (button_Liste_Port_Ok, TRUE);
		gtk_widget_set_sensitive (ctree_Liste_Port, FALSE);
		Modif_Port = TRUE;
		printf ("[I] Modifie le port %d\n", Liste_Port_Scan[Port_Selectionner].Num_Port);
	}
}


void on_button_Liste_Port_Sauvegarder_clicked (GtkButton * button, gpointer user_data)
{
	FILE     *Fichier_PortList;
	char      buf[512],CheminFichier[256];
	int       Min, Index, IndexMin, NbEnregistrer;
	struct struct_Demande Demande_Relire_Fichier_Liste_Port;

	/* Enregistrement de la liste de ports */
	sprintf (CheminFichier, "%s/.AutoScan/Conf/Port", Info_User->pw_dir);
	if ((Fichier_PortList = fopen (CheminFichier, "w")) == NULL) {
		perror ("[I] fopen :");
		printf ("[I] Impossible de lire PortListe\n");
		exit (-1);
	}
	/* Enregistre les ports en les triant par le numèro de ports */
	NbEnregistrer = 0;
	IndexMin = 0;
	while ((IndexMin != -1) && (NbEnregistrer < Nb_Port_Dans_Liste_Scan)) {	// si tout n'est pas trouvé
		Index = 0;
		Min = 65536;
		IndexMin = -1;
		while (Index < Nb_Port_Dans_Liste_Scan) {
			if ((Liste_Port_Scan[Index].Num_Port > 0) && (Min > Liste_Port_Scan[Index].Num_Port)) {	// si pas effacer et + petit que min
				IndexMin = Index;
				Min = Liste_Port_Scan[Index].Num_Port;
			}
			Index++;
		}
		if (IndexMin != -1) {
			printf ("[I] %d:   Index(%d) = %d\n", NbEnregistrer, IndexMin, Liste_Port_Scan[IndexMin].Num_Port);
			/* Enregistrement */
			if (strcmp (Liste_Port_Scan[IndexMin].Fichier_Icone, "(null)") == 0)
				strcpy (Liste_Port_Scan[IndexMin].Fichier_Icone, "");
			if (strcmp (Liste_Port_Scan[IndexMin].Fichier_Icone_Fermer, "(null)") == 0)
				strcpy (Liste_Port_Scan[IndexMin].Fichier_Icone_Fermer, "");

			sprintf (buf, "%d;%d;%d;%d;%d;%d;%d;%d;%d;%d;%d;%s;%s;%s;%s;%s;%s;%s;\n", Liste_Port_Scan[IndexMin].Num_Port, Liste_Port_Scan[IndexMin].Type_Machine, Liste_Port_Scan[IndexMin].LireEntete, Liste_Port_Scan[IndexMin].Marquer, Liste_Port_Scan[IndexMin].red, Liste_Port_Scan[IndexMin].green, Liste_Port_Scan[IndexMin].blue, Liste_Port_Scan[IndexMin].Etat_Port, Liste_Port_Scan[IndexMin].Etat_Port_Fermer, Liste_Port_Scan[IndexMin].Etat_Port_Message, Liste_Port_Scan[IndexMin].Etat_Port_Email, Liste_Port_Scan[IndexMin].Nom, Liste_Port_Scan[IndexMin].Fichier_Icone, Liste_Port_Scan[IndexMin].Description, Liste_Port_Scan[IndexMin].Programme, Liste_Port_Scan[IndexMin].En_Tete, Liste_Port_Scan[IndexMin].Fichier_Icone_Fermer, Liste_Port_Scan[IndexMin].Email);

			printf ("[I] Buf : [%s]\n", buf);
			if (fputs (buf, Fichier_PortList) != 1)
				printf ("[I] Erreur Ecriture fichier PortListe\n");
			/* Suppression dans le tableau */
			Liste_Port_Scan[IndexMin].Num_Port = EFFACER;
		}
		NbEnregistrer++;
	}
	fclose (Fichier_PortList);
	/* Libere la liste des ports (A finir tout n'est pas libérer !!!) */
	free (Liste_Port_Scan);
	/* Créer une nouvelle liste avec le contenu du fichier */
	Creer_PortList ();
	/* Demande a autoscan_d de relire la liste des ports */
	Demande_Relire_Fichier_Liste_Port.type = 1;
	Demande_Relire_Fichier_Liste_Port.type_demande = RELECTURE_FICHIER_CONFIGURATION;
	strcpy (Demande_Relire_Fichier_Liste_Port.donnee, "");
	if (msgsnd (File_Envoie_Demande, (void *) &Demande_Relire_Fichier_Liste_Port, sizeof (Demande_Relire_Fichier_Liste_Port) - sizeof (long), 0) < 0) {
		perror ("[I] msgsnd");
		exit (1);
	}
	gtk_widget_hide (window_Liste_Port);
}




int Ajoute_port (int Machine, int Index_Port, int Etat, int Port, int Type_Machine)
{
	if (Etat == OUVERT) {
		printf ("[I] Ajout port : [%d]   index : [%d]\n", Port, Index_Port);
		Liste_Machines[Machine].Port[Liste_Machines[Machine].Nb_Port_Ouvert].Num_Port = Port;
		Liste_Machines[Machine].Port[Liste_Machines[Machine].Nb_Port_Ouvert].Etat = Etat;
		if (Type_Machine == SERVEUR)
			Liste_Machines[Machine].Serveur = TRUE;
		Liste_Machines[Machine].Nb_Port_Ouvert++;
		if ((Index_Port > -1) && (Liste_Port_Scan[Index_Port].Marquer == 1)) {
			printf ("[I] Marque pour machine %d, port %d\n", Machine, Port);
			Liste_Machines[Machine].color.red = Liste_Port_Scan[Index_Port].red * 255;
			Liste_Machines[Machine].color.green = Liste_Port_Scan[Index_Port].green * 255;
			Liste_Machines[Machine].color.blue = Liste_Port_Scan[Index_Port].blue * 255;
		}
	}
	return Port;
}
