/*
 *  Copyright (C) 2004 Thierry Lagarde <tlagarde@user.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "Reseau.h"
#include "callbacks.h"
#include "Port.h"
#include "Signature.h"
#include "Machine.h"


gboolean Restauration (char *Fichier)
{
	FILE     *Fichier_Reseau;
	char      buf[512];
	int       Nb_Machine_Restaurer, Nb_Port, i, j, Num_Port, Etat_Port, Type_Machine, Index_Port, Nb_Enregistrement;
	char      Temp[255];
	gchar    *text[1];
	unsigned char Adresse_Ip[20];
	unsigned long int AdresseIp;
	unsigned char Adresse_Mac[20];
	unsigned char AdresseMAC[10];
	struct struct_Demande Demande;
		
	printf ("[I] Restauration\n");
	sprintf(buf,"AutoScan Beta 0.92  (%s)",Fichier);
	gtk_window_set_title (GTK_WINDOW (window), buf);
	if ((Fichier_Reseau = fopen (Fichier, "r")) == NULL) {
		perror ("[I] fopen :");
		printf ("[I] Impossible de lire %s\n",Fichier);
		exit (-1);
	}

	/* Debut de la restauration du réseau */
	gtk_clist_freeze (GTK_CLIST (ctree_Liste_Machine));
	Nb_Machine_Restaurer = 0;
	while (fgets (buf, sizeof (buf), Fichier_Reseau)) {
		printf ("[I] buf:%s", buf);
		/* Recuperation de l'adresse MAC */
		if (sscanf (buf, "[%02X:%02X:%02X:%02X:%02X:%02X]", &AdresseMAC[0], &AdresseMAC[1], &AdresseMAC[2], &AdresseMAC[3], &AdresseMAC[4], &AdresseMAC[5]) == 6) {
			sprintf (Adresse_Mac, "%02X:%02X:%02X:%02X:%02X:%02X", AdresseMAC[0], AdresseMAC[1], AdresseMAC[2], AdresseMAC[3], AdresseMAC[4], AdresseMAC[5]);

			/* Recuperation de l'adresse IP */
			if (fgets (buf, sizeof (buf), Fichier_Reseau) == NULL)
				return FALSE;
			if (sscanf (buf, "    [Adresse_Ip=%s]", Adresse_Ip) == 1) {
				Adresse_Ip[strlen (Adresse_Ip) - 1] = 0;	// enleve le crochet
				AdresseIp = inet_addr (Adresse_Ip);
				/* Ajoute la nouvelle machine dans la structure */
				Initialise_Structure_Machine (Nb_Machine_Restaurer);
				Ajoute_Nouvelle_Machine (Nb_Machine_Restaurer, Adresse_Ip, Adresse_Mac, AdresseIp, AdresseMAC);
				/* Informe le service autosan_d qu'une nouvelle machine a ete restaure */
				Demande.type = 1;
				Demande.type_demande = MACHINE_RESTAURER;
				strcpy (Demande.Adresse_Ip, Liste_Machines[Nb_Machine_Restaurer].Adresse_Ip);
				strcpy (Demande.Adresse_Mac, Liste_Machines[Nb_Machine_Restaurer].Adresse_Mac);		
				Demande.AdresseIp = AdresseIp;
				memcpy (Demande.AdresseMAC, AdresseMAC, 6);
				if (msgsnd (File_Envoie_Demande, (void *) &Demande, sizeof (Demande) - sizeof (long), 0) < 0) {
					perror ("[I] msgsnd");
					exit (1);
				}
				/* Recuperation de la signature */
				if (fgets (buf, sizeof (buf), Fichier_Reseau) == NULL)
					return FALSE;
				printf ("[I] buf:%s", buf);
				if (sscanf (buf, "    [digest=%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X]", &Liste_Machines[Nb_Machine_Restaurer].digest[0], &Liste_Machines[Nb_Machine_Restaurer].digest[1], &Liste_Machines[Nb_Machine_Restaurer].digest[2], &Liste_Machines[Nb_Machine_Restaurer].digest[3], &Liste_Machines[Nb_Machine_Restaurer].digest[4], &Liste_Machines[Nb_Machine_Restaurer].digest[5], &Liste_Machines[Nb_Machine_Restaurer].digest[6], &Liste_Machines[Nb_Machine_Restaurer].digest[7], &Liste_Machines[Nb_Machine_Restaurer].digest[8], &Liste_Machines[Nb_Machine_Restaurer].digest[9], &Liste_Machines[Nb_Machine_Restaurer].digest[10], &Liste_Machines[Nb_Machine_Restaurer].digest[11], &Liste_Machines[Nb_Machine_Restaurer].digest[12], &Liste_Machines[Nb_Machine_Restaurer].digest[13], &Liste_Machines[Nb_Machine_Restaurer].digest[14], &Liste_Machines[Nb_Machine_Restaurer].digest[15]) == 16) {
					/* Identifie_Machine */
					Identifie_Machine (Nb_Machine_Restaurer);

					/* Recuperation de la liste des ports */
					if (fgets (buf, sizeof (buf), Fichier_Reseau) == NULL)
						return FALSE;
					if (sscanf (buf, "    [NumPort=%d]", &Nb_Port) == 1) {
						for (i = 0; i < Nb_Port; i++) {
							if (fgets (buf, sizeof (buf), Fichier_Reseau) == NULL)
								return FALSE;
							if (sscanf (buf, "    [%d,%d,%d,%s]", &Num_Port, &Etat_Port, &Type_Machine, Temp) == 4) {
								printf ("[I] Port %d ", i);
								Index_Port = -1;
								for (j = 0; j < Nb_Port_Dans_Liste_Scan; j++) {
									if (Liste_Port_Scan[j].Num_Port == Num_Port) {
										Index_Port = j;
										continue;
									}
								}
								printf ("[I] Indexport % d  machine %d   etat%d,   num%d   type%d\n", Index_Port, Nb_Machine_Restaurer, Etat_Port, Num_Port, Type_Machine);
								Ajoute_port (Nb_Machine_Restaurer, Index_Port, Etat_Port, Num_Port, Type_Machine); 
								Liste_Machines[Nb_Machine_Restaurer].Nb_Port_Total_Scanner = 0; // pas recuperer
								Liste_Machines[Nb_Machine_Restaurer].Nb_Port_Firewaller = -1; //pas recuperer
							
							}
							else {
								printf ("[I] Erreur de restauration : Recherche num port\n");
								return FALSE;
							}
						}
						printf ("[I] Fin recuperation liste port\n");

						/* Recuperation de la liste des enregistrements */
						if (fgets (buf, sizeof (buf), Fichier_Reseau) == NULL)
							return FALSE;
						if (sscanf (buf, "    [NumEnregistrement=%d]", &Nb_Enregistrement) == 1) {
							for (i = 0; i < Nb_Enregistrement; i++) {
								if (fgets (buf, sizeof (buf), Fichier_Reseau) == NULL)
									return FALSE;
								if (sscanf (buf, "    [%d,%d,%s]", &Liste_Machines[Nb_Machine_Restaurer].Smb.Smb_Registration[i].Type, &Liste_Machines[Nb_Machine_Restaurer].Smb.Smb_Registration[i].Numero, Liste_Machines[Nb_Machine_Restaurer].Smb.Smb_Registration[i].Name) == 3) {
									Liste_Machines[Nb_Machine_Restaurer].Smb.Smb_Registration[i].Name[strlen (Liste_Machines[Nb_Machine_Restaurer].Smb.Smb_Registration[i].Name) - 1] = 0;	//enleve le crochet
									Recuperation_Information_NetBios (Nb_Machine_Restaurer, i);
								}
								else {
									printf ("[I] Erreur de restauration : Recherche enregistrement \n");
									return FALSE;
								}
							}
							printf ("[I] Fin recuperation liste enregistrement\n");
						}
						else {
							printf ("[I] Erreur de restauration : Recherche nombre enregistrement\n");
							return FALSE;
						}
					}
					else {
						printf ("[I] Erreur de restauration : Recherche nombre port\n");
						return FALSE;
					}
				}
				else {
					printf ("[I] Erreur de restauration : Recherche digest\n");
					return FALSE;
				}
			}
			else {
				printf ("[I] Erreur de restauration : Recherche Adresse Ip\n");
				return FALSE;
			}
		}
		else {
			printf ("[I] Erreur de restauration : Recherche Adresse Mac\n");
			return FALSE;
		}

		Affiche_Nouvelle_Machine (Nb_Machine_Restaurer,TRUE,FALSE);
		Nb_Machine_Restaurer++;
	}
	printf ("[I] Restauration des machines (%d machines trouvees)\n", Nb_Machine_Restaurer);
	gtk_clist_thaw (GTK_CLIST (ctree_Liste_Machine));
	fclose (Fichier_Reseau);
}
