/*
 *  Copyright (C) 2004 Thierry Lagarde <tlagarde@user.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "Reseau.h"
#include "Commun.h"
#include "Port.h"
#include "Signature.h"
#include "Machine.h"
#include "Sous_Reseau.h"
#include "Samba.h"


#include <sys/ipc.h>
#include <sys/msg.h>

void     *ScanMachine (int);
void     *Nouveau_Sous_Reseau (int);
extern char **environ;


void Fin (int message)
{
	struct struct_Demande Demande;
	struct struct_Message Message_Envoyer;
	gboolean  fin;

	if (!Bug_autoscan_d) {
		if (message != ARRET_CONTROL_C) {
			printf ("[I] Demande au service super-utilisateur de s'arreter\n");
			Demande.type = 1;
			Demande.type_demande = DEMANDE_ARRET_AUTOSCAN_D;
			strcpy (Demande.donnee, "");
			if (msgsnd (File_Envoie_Demande, (void *) &Demande, sizeof (Demande) - sizeof (long), 0) < 0) {
				perror ("[I] msgsnd");
				exit (1);
			}
		}
		fin = FALSE;
		do {
			if ((msgrcv (File_Envoie_Message, (void *) &Message_Envoyer, sizeof (Message_Envoyer) - sizeof (long), 0, 0)) > -1) {
				if (Message_Envoyer.type_message == AUTOSCAN_D_ARRETER) {
					printf ("[I] Confirmation : autoscan_d est arrete\n");
					fin = TRUE;
				}
			}
		} while (!fin);
	}
	else
		printf ("[I] autoscan_d a plante\n");
	/* Destruction des files de messages */
	if (msgctl (msgget (KEY_FILE_RECEPTION_NOUVELLE_MACHINE, 0), IPC_RMID, NULL) == 0) {
		printf ("[I] File KEY_FILE_RECEPTION_NOUVELLE_MACHINE detruite\n");
	}
	if (msgctl (msgget (KEY_FILE_DEMANDE, 0), IPC_RMID, NULL) == 0) {
		printf ("[I] File KEY_FILE_DEMANDE detruite\n");
	}
	if (msgctl (msgget (KEY_FILE_MESSAGE, 0), IPC_RMID, NULL) == 0) {
		printf ("[I] File KEY_FILE_MESSAGE detruite\n");
	}
	if (msgctl (msgget (KEY_FILE_MESSAGE_TEMP_REEL, 0), IPC_RMID, NULL) == 0) {
		printf ("[I] File KEY_FILE_MESSAGE_TEMP_REEL detruite\n");
	}
/* Force la destruction de l'interface */
	destruction_applet_icone ();
	gtk_widget_hide_all (window);
	gtk_widget_unrealize (window);
	while (gdk_events_pending ()) {
		gdk_event_get ();
	}
	Demonte_Tout_Partage ();
	printf ("[I] Fin\n");
	gtk_exit (0);
}

void on_d__marrer_le_scan_activate (GtkMenuItem * menuitem, gpointer user_data)
{
	Scan_Actif = TRUE;
}


void on_stop_activate (GtkMenuItem * menuitem, gpointer user_data)
{
	Scan_Actif = FALSE;
}


void on_mettre____jour_activate (GtkMenuItem * menuitem, gpointer user_data)
{

}


void on_nouveau_activate (GtkMenuItem * menuitem, gpointer user_data)
{

}


void on_ouvrir_activate (GtkMenuItem * menuitem, gpointer user_data)
{

}


void on_enregistrer_activate (GtkMenuItem * menuitem, gpointer user_data)
{
	char      Chemin_AutoScan[255];

	sprintf (Chemin_AutoScan, "%s/.AutoScan/Network/", Info_User->pw_dir);
	gtk_file_selection_set_filename (GTK_FILE_SELECTION (fileselection_Enregistrer), Chemin_AutoScan);
	gtk_widget_show (fileselection_Enregistrer);

}


void on_force_un_sous_r__seau_activate (GtkMenuItem * menuitem, gpointer user_data)
{
	gtk_widget_show (window_Force_Reseau);
}







void on_quitter_activate (GtkMenuItem * menuitem, gpointer user_data)
{
	Fin (ARRET);
}


void on_pr__f__rences_activate (GtkMenuItem * menuitem, gpointer user_data)
{
	gtk_widget_show (window_Preference);

}


void on____propos_activate (GtkMenuItem * menuitem, gpointer user_data)
{
	about = create_about ();
	gtk_widget_show (about);
}

void Afficher_Liste_Port_Ouvert ()
{
	int       i, j;
	gchar    *text[1];
	char      Tmp[255];

	gnome_icon_list_clear (GNOME_ICON_LIST (iconlist));
	/* Service */
	i = 0;
	printf ("[I] nb port Ouvert : %d\n", Liste_Machines[MachineSelectionner].Nb_Port_Ouvert);
	while (Liste_Machines[MachineSelectionner].Nb_Port_Ouvert != i) {
		sprintf (Tmp, "%d", Liste_Machines[MachineSelectionner].Port[i].Num_Port);
		//printf ("%d\n", Liste_Machines[MachineSelectionner].Port[i].Num_Port);
		if (Liste_Machines[MachineSelectionner].Port[i].Etat == OUVERT) {
			j = 0;
			while ((j < Nb_Port_Dans_Liste_Scan) && (Liste_Port_Scan[j].Num_Port != Liste_Machines[MachineSelectionner].Port[i].Num_Port)) {
				j++;
			}

			if (j == Nb_Port_Dans_Liste_Scan) {
				printf ("[I] Erreur Port %d introuvable\n", Liste_Machines[MachineSelectionner].Port[i].Num_Port);
			}
			else {

				if (Liste_Port_Scan[j].Fichier_Icone[0] != 0) {
					printf ("[I] Nom : [%s]\n", Liste_Port_Scan[j].Nom);
					if (Liste_Machines[MachineSelectionner].Machine_Allumer)
						gnome_icon_list_append (GNOME_ICON_LIST (iconlist), Liste_Port_Scan[j].Fichier_Icone, Liste_Port_Scan[j].Nom);
					else
						gnome_icon_list_append (GNOME_ICON_LIST (iconlist), Liste_Port_Scan[j].Fichier_Icone_Fermer, Liste_Port_Scan[j].Nom);

				}
				else {
					if (Liste_Machines[MachineSelectionner].Machine_Allumer)
						gnome_icon_list_append (GNOME_ICON_LIST (iconlist), "/usr/share/pixmaps/AutoScan/default.png", Liste_Port_Scan[j].Nom);
					else
						gnome_icon_list_append (GNOME_ICON_LIST (iconlist), "/usr/share/pixmaps/AutoScan/default_Down.png", Liste_Port_Scan[j].Nom);
					printf ("[I] Nom : [%s]  Icone : [Icones/default.png]\n", Liste_Port_Scan[j].Nom);
				}
			}
		}
		i++;
	}
}

void Afficher_Info_Machine ()
{
	char      Tmp[255];
	int       i;
	gchar    *text[1];

	gtk_clist_freeze (GTK_CLIST (ctree_Info));
	if (Liste_Machines[MachineSelectionner].Machine_Allumer) {
		gtk_widget_set_sensitive (ctree_Info, TRUE);
		gtk_widget_set_sensitive (iconlist, TRUE);
	}
	else {
		gtk_widget_set_sensitive (ctree_Info, FALSE);
		gtk_widget_set_sensitive (iconlist, FALSE);
	}
	printf ("[I] Machine selectionner : %d\n", MachineSelectionner);
	sprintf (Tmp, "Ip Address: [%s]", Liste_Machines[MachineSelectionner].Adresse_Ip);
	text[0] = g_strdup_printf (Tmp);
	gtk_ctree_insert_node (GTK_CTREE (ctree_Info), NULL, NULL, text, 5, Pixmap_Hwinfo, Masque_Hwinfo, Pixmap_Hwinfo, Masque_Hwinfo, FALSE, FALSE);
	g_free (text[0]);

	sprintf (Tmp, "Mac Address : [%s]", Liste_Machines[MachineSelectionner].Adresse_Mac);
	text[0] = g_strdup_printf (Tmp);
	gtk_ctree_insert_node (GTK_CTREE (ctree_Info), NULL, NULL, text, 5, Pixmap_Hwinfo, Masque_Hwinfo, Pixmap_Hwinfo, Masque_Hwinfo, FALSE, FALSE);
	g_free (text[0]);

	i = 0;
	printf ("[I] Recherche Fabricant\n");
	while ((i < NbMacAdresse) && (MacListe[i].Constructeur)) {
		if ((MacListe[i].MAC[0] == Liste_Machines[MachineSelectionner].AdresseMAC[0])
			&& (MacListe[i].MAC[1] == Liste_Machines[MachineSelectionner].AdresseMAC[1])
			&& (MacListe[i].MAC[2] == Liste_Machines[MachineSelectionner].AdresseMAC[2])) {
			sprintf (Tmp, "Network Card : [%s]", MacListe[i].Constructeur);
			text[0] = g_strdup_printf (Tmp);
			gtk_ctree_insert_node (GTK_CTREE (ctree_Info), NULL, NULL, text, 5, Pixmap_Hwinfo, Masque_Hwinfo, Pixmap_Hwinfo, Masque_Hwinfo, FALSE, FALSE);
			g_free (text[0]);
			i = NbMacAdresse;
		}
		i++;
	}

	i = 0;
	while ((i < Nb_Signature) && (memcmp (Liste_Signature[i].digest, Liste_Machines[MachineSelectionner].digest, 16) != 0)) {
		i++;
	}
	if (memcmp (Liste_Signature[i].digest, Liste_Machines[MachineSelectionner].digest, 16) == 0)
		sprintf (Tmp, "System : %s", Liste_Signature[i].Nom);
	else
		sprintf (Tmp, "System : Inconnu (%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X)", Liste_Machines[MachineSelectionner].digest[0], Liste_Machines[MachineSelectionner].digest[1], Liste_Machines[MachineSelectionner].digest[2], Liste_Machines[MachineSelectionner].digest[3], Liste_Machines[MachineSelectionner].digest[4], Liste_Machines[MachineSelectionner].digest[5], Liste_Machines[MachineSelectionner].digest[6], Liste_Machines[MachineSelectionner].digest[7], Liste_Machines[MachineSelectionner].digest[8], Liste_Machines[MachineSelectionner].digest[9], Liste_Machines[MachineSelectionner].digest[10], Liste_Machines[MachineSelectionner].digest[11], Liste_Machines[MachineSelectionner].digest[12], Liste_Machines[MachineSelectionner].digest[13], Liste_Machines[MachineSelectionner].digest[14], Liste_Machines[MachineSelectionner].digest[15]);


	text[0] = g_strdup_printf (Tmp);
	gtk_ctree_insert_node (GTK_CTREE (ctree_Info), NULL, NULL, text, 5, Pixmap_HostName, Masque_HostName, Pixmap_HostName, Masque_HostName, FALSE, FALSE);
	g_free (text[0]);


	if (Liste_Machines[MachineSelectionner].Smb.HostName[0] != 0) {
		sprintf (Tmp, "Host Name : [%s]", Liste_Machines[MachineSelectionner].Smb.HostName);
		text[0] = g_strdup_printf (Tmp);
		gtk_ctree_insert_node (GTK_CTREE (ctree_Info), NULL, NULL, text, 5, Pixmap_HostName, Masque_HostName, Pixmap_HostName, Masque_HostName, FALSE, FALSE);
		g_free (text[0]);
	}

	if (Liste_Machines[MachineSelectionner].Smb.DomainName[0] != 0) {
		sprintf (Tmp, "DomainName : [%s]", Liste_Machines[MachineSelectionner].Smb.DomainName);
		text[0] = g_strdup_printf (Tmp);
		gtk_ctree_insert_node (GTK_CTREE (ctree_Info), NULL, NULL, text, 5, Pixmap_HostName, Masque_HostName, Pixmap_HostName, Masque_HostName, FALSE, FALSE);
		g_free (text[0]);
	}

	if (Liste_Machines[MachineSelectionner].Smb.Utilisateur[0] != 0) {
		sprintf (Tmp, "User : [%s]", Liste_Machines[MachineSelectionner].Smb.Utilisateur);
		text[0] = g_strdup_printf (Tmp);
		gtk_ctree_insert_node (GTK_CTREE (ctree_Info), NULL, NULL, text, 5, Pixmap_Utilisateur, Masque_Utilisateur, Pixmap_Utilisateur, Masque_Utilisateur, FALSE, FALSE);
		g_free (text[0]);
	}

	gtk_clist_thaw (GTK_CLIST (ctree_Info));
}

void on_ctree_Liste_Machine_tree_select_row (GtkCTree * ctree, GtkCTreeNode * node, gint column, gpointer user_data)
{
	int       i, j;
	gchar    *text[1];
	char      Tmp[255];
	GtkCTreeNode *ctree_NetBios;


	IconeSelectionner = -1;
	MachineSelectionner = (int) gtk_ctree_node_get_row_data (GTK_CTREE (ctree), node);
	printf ("[I] Machine (%d)\n", MachineSelectionner);
	if ((Mode_Documentation) && (MachineSelectionner != -1)) {
		printf ("Mode Info_Mode\n");
		gtk_widget_destroy (frame_Documentation);
		Init_Info_Mode ();
		printf ("Mode Info_Mode : Ok\n");
		Mode_Documentation = FALSE;
		Mode_Documentation_Demarrage = FALSE;
	}

	if (MachineSelectionner == -1) {
		if (!Mode_Documentation || Mode_Documentation_Demarrage) {
			Init_Documentation ("/usr/share/doc/AutoScan/Os1.html");
			Mode_Documentation_Demarrage = FALSE;
		}
		Mode_Documentation = TRUE;
		return;
	}
	//gtk_widget_hide(vpaned);
	//gtk_widget_show (frame_Documentation);


	gtk_clist_clear (GTK_CLIST (ctree_Info));
	if (MachineSelectionner >= 0) {
		Mode_Liste_Icone_Port = TRUE;
		Afficher_Info_Machine ();

		i = 0;
		while (Liste_Machines[MachineSelectionner].Smb.Smb_Registration[i].Type != 0) {
			i++;
		}
		if (i != 0) {
			sprintf (Tmp, "NetBios Names (%d)", i);
			text[0] = g_strdup_printf (Tmp);
			ctree_NetBios = gtk_ctree_insert_node (GTK_CTREE (ctree_Info), NULL, NULL, text, 5, Pixmap_Info, Masque_Info, Pixmap_Info, Masque_Info, FALSE, FALSE);
			g_free (text[0]);

			i = 0;
			while (Liste_Machines[MachineSelectionner].Smb.Smb_Registration[i].Type != 0) {
				sprintf (Tmp, "%s <%02X>", Liste_Machines[MachineSelectionner].Smb.Smb_Registration[i].Name, Liste_Machines[MachineSelectionner].Smb.Smb_Registration[i].Numero);
				if (Liste_Machines[MachineSelectionner].Smb.Smb_Registration[i].Type == REGISTRATION_GROUP)
					strcat (Tmp, " GROUP ");
				if (Liste_Machines[MachineSelectionner].Smb.Smb_Registration[i].Type == REGISTRATION_UNIQUE)
					strcat (Tmp, " UNIQUE ");

				switch (Liste_Machines[MachineSelectionner].Smb.Smb_Registration[i].Numero) {
				    case 0x00:
					    if (Liste_Machines[MachineSelectionner].Smb.Smb_Registration[i].Type == REGISTRATION_UNIQUE)
						    strcat (Tmp, " Workstation Service");
					    else
						    strcat (Tmp, " Domain Name");
					    break;
				    case 0x01:
					    if (Liste_Machines[MachineSelectionner].Smb.Smb_Registration[i].Type == REGISTRATION_UNIQUE)
						    strcat (Tmp, " Messenger Service");
					    else
						    strcat (Tmp, " Master Browser");
					    break;
				    case 0x03:
					    strcat (Tmp, " Messenger Service");
					    break;
				    case 0x06:
					    strcat (Tmp, " RAS Server Service");
					    break;
				    case 0x1b:
					    strcat (Tmp, " Domain Master Browser");
					    break;
				    case 0x1c:
					    strcat (Tmp, " Domain Controllers");
					    break;
				    case 0x1d:
					    strcat (Tmp, " Master Browser");
					    break;
				    case 0x1e:
					    if (Liste_Machines[MachineSelectionner].Smb.Smb_Registration[i].Type == REGISTRATION_GROUP)
						    strcat (Tmp, " Browser Service Elections");
					    break;
				    case 0x1F:
					    strcat (Tmp, " NetDDE Service");
					    break;
				    case 0x20:
					    strcat (Tmp, " File Server Service");
					    break;
				    case 0x21:
					    strcat (Tmp, " RAS Client Service");
					    break;
				    case 0x22:
					    strcat (Tmp, " Microsoft Exchange Interchange(MSMail Connector)");
					    break;
				    case 0x23:
					    strcat (Tmp, " Microsoft Exchange Store");
					    break;
				    case 0x24:
					    strcat (Tmp, " Microsoft Exchange Directory");
					    break;
				    case 0x30:
					    strcat (Tmp, " Modem Sharing Server Service");
					    break;
				    case 0x31:
					    strcat (Tmp, " Modem Sharing Client Service");
					    break;
				    case 0x42:
					    strcat (Tmp, " Mcaffee Anti-Virus");
					    break;
				    case 0x43:
					    strcat (Tmp, " SMS Clients Remote Control");
					    break;
				    case 0x44:
					    strcat (Tmp, " SMS Administrators Remote Control Tool");
					    break;
				    case 0x45:
					    strcat (Tmp, " SMS Clients Remote Chat");
					    break;
				    case 0x46:
					    strcat (Tmp, " SMS Clients Remote Transfer");
					    break;
				    case 0x4C:
					    strcat (Tmp, " DEC Pathworks TCPIP service on Windows NT");
					    break;
				    case 0x52:
					    strcat (Tmp, " DEC Pathworks TCPIP service on Windows NT");
					    break;
				    case 0x6a:
					    strcat (Tmp, " Microsoft Exchange IMC");
					    break;
				    case 0x87:
					    strcat (Tmp, " Microsoft Exchange MTA");
					    break;
				    case 0xbe:
					    strcat (Tmp, " Network Monitor Agent");
					    break;
				    case 0xbf:
					    strcat (Tmp, " Network Monitor Application");
					    break;
				    default:
					    strcat (Tmp, " Unknown");
					    break;
				}
				text[0] = g_strdup_printf (Tmp);
				gtk_ctree_insert_node (GTK_CTREE (ctree_Info), ctree_NetBios, NULL, text, 5, Pixmap_Info, Masque_Info, Pixmap_Info, Masque_Info, FALSE, FALSE);
				g_free (text[0]);
				i++;
			}
		}
		Afficher_Liste_Port_Ouvert ();
		//gnome_icon_list_set_selection_mode (GNOME_ICON_LIST (iconlist), GTK_SELECTION_EXTENDED);
	}
	else {
		gtk_widget_set_sensitive (ctree_Info, FALSE);
		gtk_widget_set_sensitive (iconlist, FALSE);
	}

}

gboolean on_ctree_Liste_Machine_event (GtkWidget * widget, GdkEvent * event, gpointer user_data)
{
	if (MachineSelectionner > -1) {
		if (event->type == GDK_BUTTON_PRESS) {
			GdkEventButton *bev = (GdkEventButton *) event;

			if (bev->button == 3) {
				gtk_menu_popup (GTK_MENU (menu_Liste_Machine), NULL, NULL, NULL, NULL, bev->button, bev->time);
				return TRUE;
			}
		}
	}

	return FALSE;
}

void Lancement_Programme (char *nomProgramme)
{
	pid_t     pid_fils;

	pid_fils = fork ();	// cration d'un fils
	if (pid_fils == 0) {
		/* Fils */
		printf ("[I] Lancement du programme : %s\n", nomProgramme);
		execl (nomProgramme, nomProgramme, NULL);	// lance le programme
		exit (0);
	}
	/* Pre */
	printf ("[I] PID de %s = %d\n", nomProgramme, pid_fils);

}

void on_iconlist_select_icon (GnomeIconList * gil, gint num, GdkEvent * event, gpointer data)	// (GnomeIconList * iconlist, gint num, GdkEvent * event, gpointer user_data)
{
	pid_t     pid_fils;
	char      Command[255], *command, Num_Port[10];
	int       i, NumPortSelectionner, Taille;
	gboolean  ScriptAssocieLancer;
	char      Nom_Fichier[255];
	char      Tmp[255];
	char      Nom_Partage[255];



	printf ("Icon %d selected", num);
	if (event) {
		printf (" with event type %d \n", (int) event->type);

		if (IconeFocus == num) {
			//gnome_icon_list_unselect_all (GNOME_ICON_LIST (iconlist));
			if (Mode_Liste_Icone_Port) {
				ScriptAssocieLancer = FALSE;
				NumPortSelectionner = Liste_Machines[MachineSelectionner].Port[num].Num_Port;
				printf ("[I] Select Icone(%d) Port:[%d] IP:[%s]\n", num, NumPortSelectionner, Liste_Machines[MachineSelectionner].Adresse_Ip);
				IconeSelectionner = num;	//IconeSelectionner = -1;
				// Recherche de l'index du port dans le tableau 
				i = 0;
				while (Liste_Port_Scan[i].Num_Port != NumPortSelectionner) {
					i++;
				}
				// Recherche d'un script associe 
				if (Liste_Port_Scan[i].Programme[0] != 0) {
					ScriptAssocieLancer = TRUE;
					pid_fils = fork ();	// cration d'un fils
					if (pid_fils == 0) {
						printf ("[I] Programme : [%s]\n", Liste_Port_Scan[i].Programme);
						Taille = sizeof (char) * (strlen (Liste_Port_Scan[i].Programme));
						command = (char *) malloc (Taille);
						strcpy (command, Liste_Port_Scan[i].Programme);
						printf ("[I] Commande : [%s]  taille (%d)\n", command, Taille);
						command = Gestion_Variable (command, "_IP_", &Taille, Liste_Machines[MachineSelectionner].Adresse_Ip);
						printf ("[I] Commande : [%s]  taille (%d)\n", command, Taille);
						sprintf (Num_Port, "%d", NumPortSelectionner);
						command = Gestion_Variable (command, "_PORT_", &Taille, Num_Port);
						printf ("[I] Commande : [%s]  taille (%d)\n", command, Taille);
						system (command);
						free (command);
						exit (127);
					}
				}
				// Lance les programmes integres 
				switch (Liste_Machines[MachineSelectionner].Port[num].Num_Port) {
				    case 25:
					    ScriptAssocieLancer = TRUE;
					    gtk_widget_show (window_Tester_Smtp);
					    break;
				    case POP3:
					    ScriptAssocieLancer = TRUE;
					    gtk_widget_show (window_Pop3);
					    break;
				    case 139:
					    ScriptAssocieLancer = TRUE;
					    gtk_widget_set_sensitive (iconlist, FALSE);
					    Affiche_Partage ();
					    break;
				}

				if (!ScriptAssocieLancer)
					Message ("    No program associates has this port\n\n\nGo in the menu of settings", GNOME_MESSAGE_BOX_INFO);
			}
			else {
				/*if (!Mode_Liste_Partage) {
				 * printf ("[I] Partage selectionne : [%s] \n", gnome_icon_list_get_icon_data (GNOME_ICON_LIST (iconlist), num));
				 * strcpy (Tmp, gnome_icon_list_get_icon_data (GNOME_ICON_LIST (iconlist), num));
				 * 
				 * Creation_Mode_Liste ();
				 * Affiche_Samba (Tmp);
				 * } */
				strcpy (Tmp, gnome_icon_list_get_icon_data (GNOME_ICON_LIST (iconlist), num));
				printf ("[I]  Partage selectionne : [%s]\n", Tmp);
				Tmp[strlen (Tmp) - 1] = 0;
				printf ("[I] supprime /  : [%s]\n", Tmp);
				strcpy (Nom_Partage, Tmp + 7 + strlen (Liste_Machines[MachineSelectionner].Smb.HostName));
				printf ("[I]  enleve smb://../   :   [%s]  taille(%d)\n", Nom_Partage, strlen (Nom_Partage));

				strcpy (Tmp, gnome_icon_list_get_icon_data (GNOME_ICON_LIST (iconlist), num));
				if (((Tmp + strlen (Tmp) - 1) == rindex (Tmp, '/')) || ((Tmp + strlen (Tmp) - 1) == rindex (Tmp, '.'))) {
					printf ("[I] Affichage partage en cours : [%s] \n", Tmp);
					gtk_widget_set_sensitive (iconlist, FALSE);
					gnome_icon_list_unselect_all (GNOME_ICON_LIST (iconlist));
					IconeFocus = -1;
					if (Affiche_Liste_Partage_Samba (gnome_icon_list_get_icon_data (GNOME_ICON_LIST (iconlist), num))) {
						if ((strlen (Nom_Partage) != 0) && (index (Nom_Partage, '/') == NULL)) {	//smb://../= 7
							printf ("[I] Partage : [%s]\n", Nom_Partage);
							Monte_Partage (MachineSelectionner, Liste_Machines[MachineSelectionner].Smb.HostName, Nom_Partage);
							/*pid_fils = fork ();   // cration d'un fils
							 * if (pid_fils == 0) {
							 * // Fils 
							 * // Creation du repertoire Mount 
							 * sprintf (Nom_Fichier, "%s/.AutoScan/Mount/", Info_User->pw_dir);
							 * if (mkdir (Nom_Fichier, 0755) != 0)
							 * printf ("[I] Mkdir : Erreur\n");
							 * // Creation du repertoire correspondant au partage 
							 * sprintf (Nom_Fichier, "%s/.AutoScan/Mount/%s%s/", Info_User->pw_dir, Liste_Machines[MachineSelectionner].Smb.HostName, Nom_Partage);
							 * if (mkdir (Nom_Fichier, 0755) != 0)
							 * printf ("Mkdir : Erreur\n");
							 * 
							 * sprintf (Tmp, "smbmount '//%s/%s' '%s' -o username=%s%c%s,workgroup=%s", Liste_Machines[MachineSelectionner].Smb.HostName, Nom_Partage, Nom_Fichier, gtk_entry_get_text (GTK_ENTRY (entry_Partage_Utilisateur)), '%', gtk_entry_get_text (GTK_ENTRY (entry_Partage_Mot_Passe)), gtk_entry_get_text (GTK_ENTRY (entry_Partage_Domaine)));
							 * printf ("[I] Commande : [%s]\n", Tmp);
							 * system (Tmp);
							 * exit (127);
							 * } */
						}
					}
				}
				else {
					printf ("[I] Fichier selectionne : [%s]\n", Tmp);
				}
			}
		}
		//else
		//IconeSelectionner = num;
	}
	else
		printf ("\n");
}


gboolean on_iconlist_event (GtkWidget * widget, GdkEvent * event, gpointer user_data)
{
	if (IconeSelectionner > -1) {
		if (event->type == GDK_BUTTON_PRESS) {
			GdkEventButton *bev = (GdkEventButton *) event;

			if (bev->button == 3) {
				gtk_menu_popup (GTK_MENU (menu_Port), NULL, NULL, NULL, NULL, bev->button, bev->time);
				return TRUE;
			}
		}
		if (event->type == GDK_2BUTTON_PRESS) {
		}
	}
	return FALSE;
}


void on_re_scanne_la_machine_activate (GtkMenuItem * menuitem, gpointer user_data)
{
	GError   *error = NULL;
	struct struct_Demande Demande;

	if (MachineSelectionner > -1) {
		printf ("[I] Re-scan machine %d\n", MachineSelectionner);
		Demande.type = 1;
		Demande.type_demande = RE_SCAN_MACHINE;
		strcpy (Demande.donnee, Liste_Machines[MachineSelectionner].Adresse_Ip);
		if (msgsnd (File_Envoie_Demande, (void *) &Demande, sizeof (Demande) - sizeof (long), 0) < 0) {
			perror ("[I] msgsnd");
			exit (1);
		}
	}
}


void on_net_send_activate (GtkMenuItem * menuitem, gpointer user_data)
{
	gtk_widget_show (window_NetSend);
}


void on_telnet_activate (GtkMenuItem * menuitem, gpointer user_data)
{
	pid_t     pid_fils;
	char      Command[255];

	if (IconeSelectionner != -1) {
		pid_fils = fork ();	// cration d'un fils
		if (pid_fils == 0) {
			/* Fils */
			sprintf (Command, "gnome-terminal --command=\"telnet %s %d\"\n", Liste_Machines[MachineSelectionner].Adresse_Ip, Liste_Machines[MachineSelectionner].Port[IconeSelectionner].Num_Port);
			printf ("[I] Lancement telnet  : [%s}\n", Command);
			system (Command);
			exit (127);
		}
	}
}

void on_window_destroy (GtkObject * object, gpointer user_data)
{
	printf ("Destroy\n");
	Fin (ARRET);
}

void on_button_Tester_Smtp_Envoyer_clicked (GtkButton * button, gpointer user_data)
{
	gtk_widget_hide (window_Tester_Smtp);
	Envoie_Email (MachineSelectionner, gtk_entry_get_text (GTK_ENTRY (entry_Tester_Smtp_Emetteur)), gtk_entry_get_text (GTK_ENTRY (entry_Tester_Smtp_Recepteur)), gtk_entry_get_text (GTK_ENTRY (entry_Tester_Smtp_Objet)), gtk_editable_get_chars (GTK_EDITABLE (textview_Tester_Smtp_Message), 0, -1));
}


void on_button_Tester_Smtp_Annuler_clicked (GtkButton * button, gpointer user_data)
{
	gtk_widget_hide (window_Tester_Smtp);
}

void on_button_Net_Send_Envoyer_clicked (GtkButton * button, gpointer user_data)
{
	pid_t     pid_fils;
	char      Command[255];

	pid_fils = fork ();	// cration d'un fils
	if (pid_fils == 0) {
		/* Fils */
		sprintf (Command, "echo \"%s\" | smbclient -M %s", gtk_editable_get_chars (GTK_EDITABLE (textview_Net_Send_Message), 0, -1), Liste_Machines[MachineSelectionner].Smb.HostName);
		printf ("[I] Commande : [%s]\n", Command);
		system (Command);
		exit (127);
	}
	gtk_widget_hide (window_NetSend);
}


void on_button_Net_Send_Annuler_clicked (GtkButton * button, gpointer user_data)
{
	gtk_widget_hide (window_NetSend);
}


void on_button_Pop3_Rafraichir_clicked (GtkButton * button, gpointer user_data)
{
	Pop3 (MachineSelectionner, gtk_entry_get_text (GTK_ENTRY (entry_Pop3_User)), gtk_entry_get_text (GTK_ENTRY (entry_Pop3_Password)));
}


void on_button_Pop3_Quitter_clicked (GtkButton * button, gpointer user_data)
{
	gtk_widget_hide (window_Pop3);
}






void on_button_Force_Reseau_Appliquer_clicked (GtkButton * button, gpointer user_data)
{
	int       NumSousReseau;
	unsigned long int AdresseIp;
	GError   *error = NULL;
	char      Tmp[20];
	struct struct_Demande Demande;

	AdresseIp = inet_addr (gtk_entry_get_text (GTK_ENTRY (entry_Force_Reseau)));
	printf ("[I] %04X\n", AdresseIp);
	if (AdresseIp != INADDR_NONE) {
		Demande.type = 1;
		Demande.type_demande = SCAN_SOUS_RESEAU;
		strcpy (Demande.donnee, gtk_entry_get_text (GTK_ENTRY (entry_Force_Reseau)));
		if (msgsnd (File_Envoie_Demande, (void *) &Demande, sizeof (Demande) - sizeof (long), 0) < 0) {
			perror ("[I] msgsnd");
			exit (1);
		}
	}
	else
		printf ("[I] Adresse Incorrecte\n");
	gtk_widget_hide (window_Force_Reseau);
}


void on_button_Force_Reseau_Annuler_clicked (GtkButton * button, gpointer user_data)
{
	gtk_widget_hide (window_Force_Reseau);
}

void on_ok_button_Ouvrir_clicked (GtkButton * button, gpointer user_data)
{

}


void on_cancel_button_Ouvrir_clicked (GtkButton * button, gpointer user_data)
{

}





void on_ok_button_Enregistrer_clicked (GtkButton * button, gpointer user_data)
{
	printf ("[I] %s\n", gtk_file_selection_get_filename (GTK_FILE_SELECTION (fileselection_Enregistrer)));
	Enregistrement (gtk_file_selection_get_filename (GTK_FILE_SELECTION (fileselection_Enregistrer)));
	gtk_widget_hide (fileselection_Enregistrer);
}


void on_cancel_button_Enregistrer_clicked (GtkButton * button, gpointer user_data)
{
	gtk_widget_hide (fileselection_Enregistrer);
}

void on_debug_scan_activate (GtkMenuItem * menuitem, gpointer user_data)
{
	Afficher_Debug_Scan (MachineSelectionner);
	gtk_widget_show (window_Debug_Scan);
}


void on_button_Debug_Scan_Fermer_clicked (GtkButton * button, gpointer user_data)
{
	gtk_widget_hide (window_Debug_Scan);
}



void on_ctree_Dns_Liste_tree_select_row (GtkCTree * ctree, GtkCTreeNode * node, gint column, gpointer user_data)
{

}


void on_ctree_Dns_Info_tree_select_row (GtkCTree * ctree, GtkCTreeNode * node, gint column, gpointer user_data)
{

}

void on_resultat_script_activate (GtkMenuItem * menuitem, gpointer user_data)
{
	gtk_widget_show (window_Resultat_Script);
}


void on_une_machine_activate (GtkMenuItem * menuitem, gpointer user_data)
{
	gtk_widget_set_sensitive (entry_Recherche_Adresse_Mac, TRUE);
	gtk_widget_set_sensitive (entry_Recherche_Adresse_Ip, FALSE);
	gtk_widget_set_sensitive (entry_Recherche_Nom_NetBios, FALSE);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (radiobutton_Recherche_Adresse_Mac), TRUE);
	gtk_widget_show (window_Recherche_Machine);
}



void on_radiobutton_Recherche_Adresse_Mac_toggled (GtkToggleButton * togglebutton, gpointer user_data)
{
	gtk_widget_set_sensitive (entry_Recherche_Adresse_Mac, TRUE);
	gtk_widget_set_sensitive (entry_Recherche_Adresse_Ip, FALSE);
	gtk_widget_set_sensitive (entry_Recherche_Nom_NetBios, FALSE);
}


void on_radiobutton_Recherche_Adresse_Ip_toggled (GtkToggleButton * togglebutton, gpointer user_data)
{
	gtk_widget_set_sensitive (entry_Recherche_Adresse_Mac, FALSE);
	gtk_widget_set_sensitive (entry_Recherche_Adresse_Ip, TRUE);
	gtk_widget_set_sensitive (entry_Recherche_Nom_NetBios, FALSE);
}


void on_radiobutton_Recherche_Nom_NetBios_toggled (GtkToggleButton * togglebutton, gpointer user_data)
{
	gtk_widget_set_sensitive (entry_Recherche_Adresse_Mac, FALSE);
	gtk_widget_set_sensitive (entry_Recherche_Adresse_Ip, FALSE);
	gtk_widget_set_sensitive (entry_Recherche_Nom_NetBios, TRUE);
}


void on_button_Recherche_Annuler_clicked (GtkButton * button, gpointer user_data)
{
	gtk_widget_hide (window_Recherche_Machine);
}


void on_button_Recherche_Valider_clicked (GtkButton * button, gpointer user_data)
{
	unsigned long int AdresseIp;
	int       i;

	if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (radiobutton_Recherche_Adresse_Mac))) {
		printf ("[I] Recherche par adresse Mac\n");
		i = 0;
		while ((i < Nb_Machine_Trouve) && (strcmp (&Liste_Machines[i].Adresse_Mac, gtk_entry_get_text (GTK_ENTRY (entry_Recherche_Adresse_Mac))) != 0)) {
			i++;
		}
		if (strcmp (&Liste_Machines[i].Adresse_Mac, gtk_entry_get_text (GTK_ENTRY (entry_Recherche_Adresse_Mac))) != 0)
			Message ("unreachable machine", GNOME_MESSAGE_BOX_INFO);
		else {
			printf ("[I] Machine trouve : %d\n", i);
			gtk_ctree_select (GTK_CTREE (ctree_Liste_Machine), Liste_Machines[i].ctree);
			gtk_ctree_expand (GTK_CTREE (ctree_Liste_Machine), Liste_Machines[i].ctree_Parent);
			if (Liste_Machines[i].Serveur)
				gtk_ctree_expand (GTK_CTREE (ctree_Liste_Machine), Node_Serveur);
			if ((Liste_Machines[i].TypeMateriel == STATION) && (!Liste_Machines[i].Serveur))
				gtk_ctree_expand (GTK_CTREE (ctree_Liste_Machine), Node_Station);
			gtk_ctree_node_moveto (GTK_CTREE (ctree_Liste_Machine), Liste_Machines[i].ctree, 0, 0, 0);
		}

	}
	if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (radiobutton_Recherche_Adresse_Ip))) {
		AdresseIp = inet_addr (gtk_entry_get_text (GTK_ENTRY (entry_Recherche_Adresse_Ip)));
		printf ("[I] %04X\n", AdresseIp);
		if (AdresseIp != INADDR_NONE) {
			printf ("[I] Recherche par adresse Ip\n");
			i = 0;
			while ((i < Nb_Machine_Trouve) && (memcmp (&AdresseIp, &Liste_Machines[i].AdresseIp, 4) != 0)) {
				i++;
			}
			if (memcmp (&AdresseIp, &Liste_Machines[i].AdresseIp, 4) != 0)
				Message ("unreachable machine", GNOME_MESSAGE_BOX_INFO);
			else {
				printf ("[I] Machine trouve : %d\n", i);
				gtk_ctree_select (GTK_CTREE (ctree_Liste_Machine), Liste_Machines[i].ctree);
				gtk_ctree_expand (GTK_CTREE (ctree_Liste_Machine), Liste_Machines[i].ctree_Parent);
				if (Liste_Machines[i].Serveur)
					gtk_ctree_expand (GTK_CTREE (ctree_Liste_Machine), Node_Serveur);
				if ((Liste_Machines[i].TypeMateriel == STATION) && (!Liste_Machines[i].Serveur))
					gtk_ctree_expand (GTK_CTREE (ctree_Liste_Machine), Node_Station);
				gtk_ctree_node_moveto (GTK_CTREE (ctree_Liste_Machine), Liste_Machines[i].ctree, 0, 0, 0);
			}
		}
		else {
			Message ("Ip address incorrect", GNOME_MESSAGE_BOX_INFO);
		}
	}
	if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (radiobutton_Recherche_Nom_NetBios))) {
		printf ("[I] Recherche par Nom netbios\n");
		i = 0;
		while ((i < Nb_Machine_Trouve) && (strcmp (&Liste_Machines[i].Smb.HostName, gtk_entry_get_text (GTK_ENTRY (entry_Recherche_Nom_NetBios))) != 0)) {
			i++;
		}
		if (strcmp (&Liste_Machines[i].Smb.HostName, gtk_entry_get_text (GTK_ENTRY (entry_Recherche_Nom_NetBios))) != 0)
			Message ("unreachable machine", GNOME_MESSAGE_BOX_INFO);
		else {
			printf ("[I] Machine trouve : %d\n", i);
			gtk_ctree_select (GTK_CTREE (ctree_Liste_Machine), Liste_Machines[i].ctree);
			gtk_ctree_expand (GTK_CTREE (ctree_Liste_Machine), Liste_Machines[i].ctree_Parent);
			if (Liste_Machines[i].Serveur)
				gtk_ctree_expand (GTK_CTREE (ctree_Liste_Machine), Node_Serveur);
			if ((Liste_Machines[i].TypeMateriel == STATION) && (!Liste_Machines[i].Serveur))
				gtk_ctree_expand (GTK_CTREE (ctree_Liste_Machine), Node_Station);
			gtk_ctree_node_moveto (GTK_CTREE (ctree_Liste_Machine), Liste_Machines[i].ctree, 0, 0, 0);
		}
	}

	gtk_widget_hide (window_Recherche_Machine);
}


void on_button_Resultat_Script_Fermer_clicked (GtkButton * button, gpointer user_data)
{
	gtk_widget_hide (window_Resultat_Script);
}


void Affiche_Serveur (int port_rechercher)
{
	int       Machine, Port, serveur;

	serveur = -1;
	for (Machine = 0; Machine < Nb_Machine_Trouve; Machine++) {
		for (Port = 0; Port < Liste_Machines[Machine].Nb_Port_Ouvert; Port++) {
			if (Liste_Machines[Machine].Port[Port].Num_Port == port_rechercher)
				serveur = Machine;
		}
	}
	if (serveur == -1)
		Message ("untraceable machine", GNOME_MESSAGE_BOX_INFO);
	else {
		printf ("[I] serveur trouve : %d\n", serveur);
		gtk_ctree_select (GTK_CTREE (ctree_Liste_Machine), Liste_Machines[serveur].ctree);
		gtk_ctree_expand (GTK_CTREE (ctree_Liste_Machine), Liste_Machines[serveur].ctree_Parent);
		if (Liste_Machines[serveur].Serveur)
			gtk_ctree_expand (GTK_CTREE (ctree_Liste_Machine), Node_Serveur);
		if ((Liste_Machines[serveur].TypeMateriel == STATION) && (!Liste_Machines[serveur].Serveur))
			gtk_ctree_expand (GTK_CTREE (ctree_Liste_Machine), Node_Station);
		gtk_ctree_node_moveto (GTK_CTREE (ctree_Liste_Machine), Liste_Machines[serveur].ctree, 0, 0, 0);
	}
}


void on_le_proxy_activate (GtkMenuItem * menuitem, gpointer user_data)
{
	Affiche_Serveur (8080);

}


void on_serveur_dns_activate (GtkMenuItem * menuitem, gpointer user_data)
{
	Affiche_Serveur (53);
}


void on_serveur_dhcp_activate (GtkMenuItem * menuitem, gpointer user_data)
{
	Affiche_Serveur (67);
}

void on_rescan_etat_machine_activate (GtkMenuItem * menuitem, gpointer user_data)
{

}


void on_rescan_reseau_activate (GtkMenuItem * menuitem, gpointer user_data)
{

}

void on_window_Tester_Smtp_destroy (GtkObject * object, gpointer user_data)
{
	window_Tester_Smtp = create_window_Tester_Smtp ();
}


void on_window_NetSend_destroy (GtkObject * object, gpointer user_data)
{
	window_NetSend = create_window_NetSend ();
}


void on_window_Pop3_destroy (GtkObject * object, gpointer user_data)
{
	window_Pop3 = create_window_Pop3 ();
}


void on_window_Liste_Port_destroy (GtkObject * object, gpointer user_data)
{
	window_Liste_Port = create_window_Liste_Port ();
	gtk_ctree_set_line_style (GTK_CTREE (ctree_Liste_Port), GTK_CTREE_LINES_NONE);
	gnome_icon_entry_set_pixmap_subdir (iconentry_Liste_Port_Ouvert, "/usr/share/pixmaps/AutoScan/Port/Up/");
	gnome_icon_entry_set_pixmap_subdir (iconentry_Liste_Port_Fermer, "/usr/share/pixmaps/AutoScan/Port/Down/");
}


void on_fileselection_Ouvrir_destroy (GtkObject * object, gpointer user_data)
{

}


void on_window_Force_Reseau_destroy (GtkObject * object, gpointer user_data)
{
	window_Force_Reseau = create_window_Force_Reseau ();
}


void on_window_Ajout_Script_destroy (GtkObject * object, gpointer user_data)
{
	window_Ajout_Script = create_window_Ajout_Script ();
	gtk_ctree_set_line_style (GTK_CTREE (ctree_Ajout_Script), GTK_CTREE_LINES_NONE);
}


void on_fileselection_Enregistrer_destroy (GtkObject * object, gpointer user_data)
{
	fileselection_Enregistrer = create_fileselection_Enregistrer ();
}



void on_window_Liste_Signatures_destroy (GtkObject * object, gpointer user_data)
{
	window_Liste_Signatures = create_window_Liste_Signatures ();
	gtk_ctree_set_line_style (GTK_CTREE (ctree_Liste_Signatures), GTK_CTREE_LINES_NONE);
	gnome_icon_entry_set_pixmap_subdir (iconentry_Liste_Signature_Allumer, "/usr/share/pixmaps/AutoScan/Equipment/Up/");
	gnome_icon_entry_set_pixmap_subdir (iconentry_Liste_Signature_Eteint, "/usr/share/pixmaps/AutoScan/Equipment/Down/");
}


void on_window_Debug_Scan_destroy (GtkObject * object, gpointer user_data)
{
	window_Debug_Scan = create_window_Debug_Scan ();
}


void on_window_Partage_destroy (GtkObject * object, gpointer user_data)
{
	window_Partage = create_window_Partage ();
}


void on_window_Dns_destroy (GtkObject * object, gpointer user_data)
{

}


void on_window_Recherche_Machine_destroy (GtkObject * object, gpointer user_data)
{
	window_Recherche_Machine = create_window_Recherche_Machine ();
}


void on_window_Resultat_Script_destroy (GtkObject * object, gpointer user_data)
{
	window_Resultat_Script = create_window_Resultat_Script ();
}


void on_iconlist_focus_icon (GnomeIconList * iconlist, gint num, gpointer user_data)
{
	int       NumPortSelectionner, i;


	printf ("[I] Focus icon %d\n", num);
	if (Mode_Liste_Icone_Port) {
		NumPortSelectionner = Liste_Machines[MachineSelectionner].Port[num].Num_Port;
		printf ("[I] Select Icone(%d) Port:[%d] IP:[%s]\n", num, NumPortSelectionner, Liste_Machines[MachineSelectionner].Adresse_Ip);
		/* Recherche de l'index du port dans le tableau */
		i = 0;
		while (Liste_Port_Scan[i].Num_Port != NumPortSelectionner) {
			i++;
		}
		gtk_label_set_text (label_Info, Liste_Port_Scan[i].Description);
	}
	printf ("[I] Focus icon %d Fin\n", num);
	IconeFocus = num;
}

void on_iconlist_move_cursor (GnomeIconList * iconlist, GtkDirectionType direction, gboolean clear_selection, gpointer user_data)
{
	printf ("[I] move_cursor icon\n");
}


void on_iconlist_unselect_icon (GnomeIconList * iconlist, gint num, GdkEvent * event, gpointer user_data)
{
	printf ("[I] unselect_icon icon %d\n", num);
	IconeFocus = -1;
}


void on_iconlist_toggle_cursor_selection (GnomeIconList * gnomeiconlist, gpointer user_data)
{
	printf ("[I] cursor_selection icon \n");
}





void on_extensions_activate (GtkMenuItem * menuitem, gpointer user_data)
{

}


void on_checkbutton_Liste_Port_Etat_Action_Email_clicked (GtkButton * button, gpointer user_data)
{

}


void on_checkbutton_Preference_Notification_Nouveau_Equipement_Email_clicked (GtkButton * button, gpointer user_data)
{

}


void on_checkbutton_Preference_Notification_Nouveau_Equipement_clicked (GtkButton * button, gpointer user_data)
{

}


void on_checkbutton_Liste_Signatures_Etat_Action_Email_clicked (GtkButton * button, gpointer user_data)
{

}





void on_window_Notification_destroy (GtkObject * object, gpointer user_data)
{

}
