/*
 *  Copyright (C) 2004 Thierry Lagarde <tlagarde@user.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include <gnome.h>
#include "eggtrayicon.h"

GdkPixmap *Pixmap_Inconnu;
GdkBitmap *Masque_Inconnu;
GdkPixmap *Pixmap_Firewall;
GdkBitmap *Masque_Firewall;
GdkPixmap *Pixmap_Station;
GdkBitmap *Masque_Station;
GdkPixmap *Pixmap_Serveur;
GdkBitmap *Masque_Serveur;
GdkPixmap *Pixmap_Domaine;
GdkBitmap *Masque_Domaine;
GdkPixmap *Pixmap_Hwinfo;
GdkBitmap *Masque_Hwinfo;
GdkPixmap *Pixmap_Info;
GdkBitmap *Masque_Info;
GdkPixmap *Pixmap_Utilisateur;
GdkBitmap *Masque_Utilisateur;
GdkPixmap *Pixmap_HostName;
GdkBitmap *Masque_HostName;
GdkPixmap *Pixmap_Switch;
GdkBitmap *Masque_Switch;
GdkPixmap *Pixmap_Imprimante;
GdkBitmap *Masque_Imprimante;
GdkPixmap *Pixmap_Routeur;
GdkBitmap *Masque_Routeur;
GdkPixmap *Pixmap_Routeur_Switch;
GdkBitmap *Masque_Routeur_Switch;
GdkPixmap *Pixmap_Wifi;
GdkBitmap *Masque_Wifi;
GtkCTreeNode *Node_Inconnu;
GtkCTreeNode *Node_Firewall;
GtkCTreeNode *Node_Materiel;
GtkCTreeNode *Node_Station;
GtkCTreeNode *Node_Serveur;
GtkCTreeNode *Node_Switch;
GtkCTreeNode *Node_Imprimante;
GtkCTreeNode *Node_Routeur;
GtkCTreeNode *Node_Routeur_Switch;
GtkCTreeNode *Node_Wifi;
GtkWidget *image, *evbox, *item, *frame_Documentation;
EggTrayIcon *tray_icon;
GtkTooltips *tray_icon_tooltip;
gboolean  Mode_Documentation, Mode_Documentation_Demarrage, Mode_Liste_Partage;
int       MachineSelectionner_Avant_Documentation;
GtkListStore *pTreeStore;
int IconeFocus;


void      on_window_destroy (GtkObject * object, gpointer user_data);
void      on_mettre____jour_activate (GtkMenuItem * menuitem, gpointer user_data);
void      on_nouveau_activate (GtkMenuItem * menuitem, gpointer user_data);
void      on_ouvrir_activate (GtkMenuItem * menuitem, gpointer user_data);
void      on_enregistrer_activate (GtkMenuItem * menuitem, gpointer user_data);
void      on_force_un_sous_r__seau_activate (GtkMenuItem * menuitem, gpointer user_data);
void      on_une_machine_activate (GtkMenuItem * menuitem, gpointer user_data);
void      on_le_proxy_activate (GtkMenuItem * menuitem, gpointer user_data);
void      on_serveur_dns_activate (GtkMenuItem * menuitem, gpointer user_data);
void      on_serveur_dhcp_activate (GtkMenuItem * menuitem, gpointer user_data);
void      on_quitter_activate (GtkMenuItem * menuitem, gpointer user_data);
void      on_pr__f__rences_activate (GtkMenuItem * menuitem, gpointer user_data);
void      on_liste_ports_activate (GtkMenuItem * menuitem, gpointer user_data);
void      on_ajoute_un_script_activate (GtkMenuItem * menuitem, gpointer user_data);
void      on_liste_des_signatures_activate (GtkMenuItem * menuitem, gpointer user_data);
void      on____propos_activate (GtkMenuItem * menuitem, gpointer user_data);
void      on_ctree_Liste_Machine_tree_select_row (GtkCTree * ctree, GtkCTreeNode * node, gint column, gpointer user_data);
gboolean  on_ctree_Liste_Machine_event (GtkWidget * widget, GdkEvent * event, gpointer user_data);
void      on_iconlist_select_icon (GnomeIconList * iconlist, gint num, GdkEvent * event, gpointer user_data);
gboolean  on_iconlist_event (GtkWidget * widget, GdkEvent * event, gpointer user_data);
void      on_re_scanne_la_machine_activate (GtkMenuItem * menuitem, gpointer user_data);
void      on_net_send_activate (GtkMenuItem * menuitem, gpointer user_data);
void      on_ajouter_signature_activate (GtkMenuItem * menuitem, gpointer user_data);
void      on_debug_scan_activate (GtkMenuItem * menuitem, gpointer user_data);
void      on_resultat_script_activate (GtkMenuItem * menuitem, gpointer user_data);
void      on_telnet_activate (GtkMenuItem * menuitem, gpointer user_data);
void      on_button_Tester_Smtp_Envoyer_clicked (GtkButton * button, gpointer user_data);
void      on_button_Tester_Smtp_Annuler_clicked (GtkButton * button, gpointer user_data);
void      on_button_Net_Send_Envoyer_clicked (GtkButton * button, gpointer user_data);
void      on_button_Net_Send_Annuler_clicked (GtkButton * button, gpointer user_data);
void      on_button_Pop3_Quitter_clicked (GtkButton * button, gpointer user_data);
void      on_button_Pop3_Rafraichir_clicked (GtkButton * button, gpointer user_data);
void      on_ctree_Liste_Port_tree_select_row (GtkCTree * ctree, GtkCTreeNode * node, gint column, gpointer user_data);
void      on_button_Liste_Port_Ok_clicked (GtkButton * button, gpointer user_data);
void      on_button_Liste_Port_Annuler_clicked (GtkButton * button, gpointer user_data);
void      on_button_Liste_Port_Sauvegarder_clicked (GtkButton * button, gpointer user_data);
void      on_button_Liste_Port_Enlever_clicked (GtkButton * button, gpointer user_data);
void      on_button_Liste_Port_Ajouter_clicked (GtkButton * button, gpointer user_data);
void      Liste_Port_changed (GtkEditable * editable, gpointer user_data);
void      on_ok_button_Ouvrir_clicked (GtkButton * button, gpointer user_data);
void      on_cancel_button_Ouvrir_clicked (GtkButton * button, gpointer user_data);
void      on_button_Force_Reseau_Appliquer_clicked (GtkButton * button, gpointer user_data);
void      on_button_Force_Reseau_Annuler_clicked (GtkButton * button, gpointer user_data);
void      on_ctree_Ajout_Script_tree_select_row (GtkCTree * ctree, GtkCTreeNode * node, gint column, gpointer user_data);
void      Liste_Script_changed (GtkEditable * editable, gpointer user_data);
void      on_button_Ajout_Script_Ajouter_clicked (GtkButton * button, gpointer user_data);
void      on_button_Ajout_Script_Enlever_clicked (GtkButton * button, gpointer user_data);
void      on_button_Ajout_Script_Ok_clicked (GtkButton * button, gpointer user_data);
void      on_button_Ajout_Script_Annuler_clicked (GtkButton * button, gpointer user_data);
void      on_button_Ajout_Script_Sauvegarder_clicked (GtkButton * button, gpointer user_data);
void      on_ok_button_Enregistrer_clicked (GtkButton * button, gpointer user_data);
void      on_cancel_button_Enregistrer_clicked (GtkButton * button, gpointer user_data);
void      on_button_Preference_Enregistrer_clicked (GtkButton * button, gpointer user_data);
void      on_button_Preference_Annuler_clicked (GtkButton * button, gpointer user_data);
void      on_ctree_Liste_Signatures_tree_select_row (GtkCTree * ctree, GtkCTreeNode * node, gint column, gpointer user_data);
void      on_button_Liste_Signatures_Ajouter_clicked (GtkButton * button, gpointer user_data);
void      on_button_Liste_Signatures_Enlever_clicked (GtkButton * button, gpointer user_data);
void      on_button_Liste_Signatures_Ok_clicked (GtkButton * button, gpointer user_data);
void      on_button_Liste_Signatures_Annuler_clicked (GtkButton * button, gpointer user_data);
void      on_button_Liste_Signatures_Sauvegarder_clicked (GtkButton * button, gpointer user_data);
void      Liste_Signatures_changed (GtkEditable * editable, gpointer user_data);
void      on_button_Debug_Scan_Fermer_clicked (GtkButton * button, gpointer user_data);
void      on_ctree_Partage_tree_select_row (GtkCTree * ctree, GtkCTreeNode * node, gint column, gpointer user_data);
void      on_button_Partage_Valider_clicked (GtkButton * button, gpointer user_data);
void      on_button_Partage_Fermer_clicked (GtkButton * button, gpointer user_data);
void      on_button_Partage_Monter_clicked (GtkButton * button, gpointer user_data);
void      on_button_Partage_Demonter_clicked (GtkButton * button, gpointer user_data);
void      on_ctree_Dns_Liste_tree_select_row (GtkCTree * ctree, GtkCTreeNode * node, gint column, gpointer user_data);
void      on_ctree_Dns_Info_tree_select_row (GtkCTree * ctree, GtkCTreeNode * node, gint column, gpointer user_data);
void      on_radiobutton_Recherche_Adresse_Mac_toggled (GtkToggleButton * togglebutton, gpointer user_data);
void      on_radiobutton_Recherche_Adresse_Ip_toggled (GtkToggleButton * togglebutton, gpointer user_data);
void      on_radiobutton_Recherche_Nom_NetBios_toggled (GtkToggleButton * togglebutton, gpointer user_data);
void      on_button_Recherche_Annuler_clicked (GtkButton * button, gpointer user_data);
void      on_button_Recherche_Valider_clicked (GtkButton * button, gpointer user_data);
void      on_button_Resultat_Script_Fermer_clicked (GtkButton * button, gpointer user_data);
void      on_rescan_etat_machine_activate (GtkMenuItem * menuitem, gpointer user_data);
void      on_rescan_reseau_activate (GtkMenuItem * menuitem, gpointer user_data);
void      on_iconlist_Demarrage_Fichier_select_icon (GnomeIconList * iconlist, gint num, GdkEvent * event, gpointer user_data);
void      on_button_Demarrage_Annuler_clicked (GtkButton * button, gpointer user_data);
void      on_button_Demarrage_Valider_clicked (GtkButton * button, gpointer user_data);
void      on_window_Tester_Smtp_destroy (GtkObject * object, gpointer user_data);
void      on_window_NetSend_destroy (GtkObject * object, gpointer user_data);
void      on_window_Pop3_destroy (GtkObject * object, gpointer user_data);
void      on_window_Liste_Port_destroy (GtkObject * object, gpointer user_data);
void      on_fileselection_Ouvrir_destroy (GtkObject * object, gpointer user_data);
void      on_window_Force_Reseau_destroy (GtkObject * object, gpointer user_data);
void      on_window_Ajout_Script_destroy (GtkObject * object, gpointer user_data);
void      on_fileselection_Enregistrer_destroy (GtkObject * object, gpointer user_data);
void      on_window_Preference_destroy (GtkObject * object, gpointer user_data);
void      on_window_Liste_Signatures_destroy (GtkObject * object, gpointer user_data);
void      on_window_Debug_Scan_destroy (GtkObject * object, gpointer user_data);
void      on_window_Partage_destroy (GtkObject * object, gpointer user_data);
void      on_window_Dns_destroy (GtkObject * object, gpointer user_data);
void      on_window_Recherche_Machine_destroy (GtkObject * object, gpointer user_data);
void      on_window_Resultat_Script_destroy (GtkObject * object, gpointer user_data);
void      on_window_demarrage_destroy (GtkObject * object, gpointer user_data);
void      on_button_Demarrage_Preferences_clicked (GtkButton * button, gpointer user_data);
void      on_Affiche_Cache_activate (GtkMenuItem * menuitem, gpointer user_data);
void      on_iconlist_focus_icon (GnomeIconList * iconlist, gint num, gpointer user_data);
void      on_iconlist_move_cursor (GnomeIconList * iconlist, GtkDirectionType direction, gboolean clear_selection, gpointer user_data);
void      on_iconlist_unselect_icon (GnomeIconList * iconlist, gint num, GdkEvent * event, gpointer user_data);
void      on_iconlist_toggle_cursor_selection (GnomeIconList * gnomeiconlist, gpointer user_data);
void      on_button_Preference_Sous_reseau_privee_Ajouter_clicked (GtkButton * button, gpointer user_data);
void      on_button_Preference_Sous_reseau_privee_Enlever_clicked (GtkButton * button, gpointer user_data);
void      on_button_Preference_Sous_reseau_privee_Ok_clicked (GtkButton * button, gpointer user_data);
void      on_button_Preference_Sous_reseau_privee_Annuler_clicked (GtkButton * button, gpointer user_data);
void      on_button_Preference_Type_equipement_Ajouter_clicked (GtkButton * button, gpointer user_data);
void      on_button_Preference_Type_equipement_Enlever_clicked (GtkButton * button, gpointer user_data);
void      on_button_Preference_Type_equipement_Enregister_clicked (GtkButton * button, gpointer user_data);
void      on_button_Preference_Type_equipement_Annuler_clicked (GtkButton * button, gpointer user_data);
void      on_button_Contributions_clicked (GtkButton * button, gpointer user_data);
void      on_extensions_activate (GtkMenuItem * menuitem, gpointer user_data);
void      on_checkbutton_Liste_Port_Etat_Action_Email_clicked (GtkButton * button, gpointer user_data);
void      on_checkbutton_Liste_Port_Etat_clicked (GtkButton * button, gpointer user_data);
void      on_ctree_Preference_Sous_reseau_privee_tree_select_row (GtkCTree * ctree, GtkCTreeNode * node, gint column, gpointer user_data);
void      Preference_Sous_reseau_privee_changed (GtkEditable * editable, gpointer user_data);
void      on_ctree_Preference_Type_equipement_tree_select_row (GtkCTree * ctree, GtkCTreeNode * node, gint column, gpointer user_data);
void      Liste_Type_Equipement_changed (GtkEditable * editable, gpointer user_data);
void      on_checkbutton_Preference_Type_equipement_Etat_Port_Actions_Email_clicked (GtkButton * button, gpointer user_data);
void      on_checkbutton_Preference_Type_equipement_Etat_Port_Actions_Script_clicked (GtkButton * button, gpointer user_data);
void      on_checkbutton_Preference_Type_equipement_Etat_Port_clicked (GtkButton * button, gpointer user_data);
void      on_checkbutton_Preference_Type_equipement_Etat_Equipement_Actions_Email_clicked (GtkButton * button, gpointer user_data);
void      on_checkbutton_Preference_Type_equipement_Etat_Equipement_Actions_Script_clicked (GtkButton * button, gpointer user_data);
void      on_checkbutton_Preference_Type_equipement_Etat_Equipement_clicked (GtkButton * button, gpointer user_data);
void      on_button_Preference_Type_equipement_Valider_clicked (GtkButton * button, gpointer user_data);
void      on_checkbutton_Preference_Notification_Nouveau_Equipement_Email_clicked (GtkButton * button, gpointer user_data);
void      on_checkbutton_Preference_Notification_Nouveau_Equipement_clicked (GtkButton * button, gpointer user_data);
void      on_checkbutton_Liste_Signatures_Etat_Action_Email_clicked (GtkButton * button, gpointer user_data);
void      on_checkbutton_Liste_Signatures_Etat_clicked (GtkButton * button, gpointer user_data);
void      on_optionmenu_Liste_Modes_changed (GtkOptionMenu * optionmenu, gpointer user_data);
void      on_button_Liste_Modes_Favorite_clicked (GtkButton * button, gpointer user_data);
void      on_button_Liste_Modes_Refresh_clicked (GtkButton * button, gpointer user_data);
void      on_window_Contributions_destroy (GtkObject * object, gpointer user_data);
void      on_window_Notification_destroy (GtkObject * object, gpointer user_data);
void      on_button_Notifications_Fermer_clicked (GtkButton * button, gpointer user_data);
void      on_combo_entry_Preference_Sous_reseau_privee_changed (GtkEditable * editable, gpointer user_data);
gboolean  on_iconlist_text_changed (GnomeIconList * iconlist, gint num, gchar * new_text, gpointer user_data);
void      on_iconlist_drag_begin (GtkWidget * widget, GdkDragContext * drag_context, gpointer user_data);
void      on_iconlist_drag_data_get (GtkWidget * widget, GdkDragContext * drag_context, GtkSelectionData * data, guint info, guint time, gpointer user_data);
void      on_iconlist_drag_data_received (GtkWidget * widget, GdkDragContext * drag_context, gint x, gint y, GtkSelectionData * data, guint info, guint time, gpointer user_data);
void      on_iconlist_drag_end (GtkWidget * widget, GdkDragContext * drag_context, gpointer user_data);

GtkWidget *about;
GdkPixbuf *about_icon_pixbuf;
GtkWidget *window;
GdkPixbuf *window_icon_pixbuf;
GtkWidget *fixed_Root;
GtkWidget *menubar;
GtkWidget *viewport;
GtkWidget *hpaned;
GtkWidget *scrolledwindow_Liste_Machine;
GtkWidget *ctree_Liste_Machine;
GtkWidget *vpaned;
GtkWidget *scrolledwindow_Info;
GtkWidget *ctree_Info;
GtkWidget *fixed_Modes;
GtkWidget *viewport_Modes;
GtkWidget *scrolledwindow_IconList;
GtkWidget *iconlist;
GtkWidget *optionmenu_Liste_Modes;
GtkWidget *menu_Liste_Modes;
GtkWidget *button_Liste_Modes_Favorite;
GtkWidget *image_Liste_Modes_Favorite;
GtkWidget *button_Liste_Modes_Refresh;
GtkWidget *image_Liste_Port_Refresh;
GtkWidget *viewport_Info;
GtkWidget *fixed_Info;
GtkWidget *progressbar_Info;
GtkWidget *vseparator_Info;
GtkWidget *vseparator_Info2;
GtkWidget *label_Info;
GtkTooltips *tooltips;
GtkWidget *menu_Liste_Machine;
GtkWidget *menu_Port;
GtkWidget *menu_Applet;
GtkWidget *window_Tester_Smtp;
GtkWidget *fixed_Tester_Smtp;
GtkWidget *entry_Tester_Smtp_Emetteur;
GtkWidget *entry_Tester_Smtp_Recepteur;
GtkWidget *scrolledwindow_Tester_Smtp_Message;
GtkWidget *textview_Tester_Smtp_Message;
GtkWidget *entry_Tester_Smtp_Objet;
GtkWidget *label_Tester_Smtp_Recepteur;
GtkWidget *label_Tester_Smtp_Emetteur;
GtkWidget *label_Tester_Smtp_Objet;
GtkWidget *button_Tester_Smtp_Annuler;
GtkWidget *alignment_Tester_Smtp_Annuler;
GtkWidget *hbox_Tester_Smtp_Annuler;
GtkWidget *image_Tester_Smtp_Annuler;
GtkWidget *label_Tester_Smtp_Annuler;
GtkWidget *button_Tester_Smtp_Envoyer;
GtkWidget *alignment_Tester_Smtp_Envoyer;
GtkWidget *hbox_Tester_Smtp_Envoyer;
GtkWidget *image_Tester_Smtp_Envoyer;
GtkWidget *label_Tester_Smtp_Envoyer;
GtkWidget *window_NetSend;
GdkPixbuf *window_NetSend_icon_pixbuf;
GtkWidget *fixed_Net_Send;
GtkWidget *label_Net_Send_Message;
GtkWidget *scrolledwindow_Net_Send;
GtkWidget *textview_Net_Send_Message;
GtkWidget *button_Net_Send_Annuler;
GtkWidget *alignment_Net_Send_Annuler;
GtkWidget *hbox_Net_Send_Annuler;
GtkWidget *image_Net_Send_Annuler;
GtkWidget *label_Net_Send_Annuler;
GtkWidget *button_Net_Send_Envoyer;
GtkWidget *alignment_Net_Send_Envoyer;
GtkWidget *hbox_Net_Send_Envoyer;
GtkWidget *image_Net_Send_Envoyer;
GtkWidget *label_Net_Send_Envoyer;
GtkWidget *window_Pop3;
GtkWidget *fixed_Pop3;
GtkWidget *entry_Pop3_User;
GtkWidget *entry_Pop3_Password;
GtkWidget *scrolledwindow_Pop3;
GtkWidget *textview_Pop3;
GtkWidget *label_Pop3_User;
GtkWidget *label_Pop3_Password;
GtkWidget *button_Pop3_Quitter;
GtkWidget *alignment_Pop3_Quitter;
GtkWidget *hbox_Pop3_Quitter;
GtkWidget *image_Pop3_Quitter;
GtkWidget *label_Pop3_Quitter;
GtkWidget *button_Pop3_Rafraichir;
GtkWidget *alignment_Pop3_Rafraichir;
GtkWidget *hbox_Pop3_Rafraichir;
GtkWidget *image_Pop3_Rafraichir;
GtkWidget *label_Pop3_Rafraichir;
GtkWidget *window_Liste_Port;
GdkPixbuf *window_Liste_Port_icon_pixbuf;
GtkWidget *fixed_Liste_Port;
GtkWidget *scrolledwindow_Liste_Port;
GtkWidget *ctree_Liste_Port;
GtkWidget *label_Liste_Port_Port;
GtkWidget *label_Liste_Port_Service;
GtkWidget *label_Liste_Port_Description;
GtkWidget *frame_Liste_Port_Modif;
GtkWidget *fixed_Liste_Port_Modif;
GtkWidget *entry_Liste_Port_Service;
GtkWidget *entry_Liste_Port_Description;
GtkWidget *entry_Liste_Port_Programme;
GtkObject *spinbutton_Liste_Port_Port_adj;
GtkWidget *spinbutton_Liste_Port_Port;
GtkWidget *combo_Liste_Port_Machine_Type;
GtkWidget *combo_entry_Liste_Port_Machine_Type;
GtkWidget *label_Liste_Port_Machine_Type;
GtkWidget *colorpicker_Liste_Port;
GtkWidget *label_Liste_Port_Port;
GtkWidget *label_Liste_Port_Service;
GtkWidget *label_Liste_Port_Programme;
GtkWidget *label_Liste_Port_Description;
GtkWidget *frame_Liste_Port_Etat;
GtkWidget *fixed_Liste_Port_Etat;
GtkWidget *frame_Liste_Port_Etat_Action;
GtkWidget *fixed_Liste_Port_Etat_Action;
GtkWidget *entry_Liste_Port_Etat_Action_Email;
GtkWidget *checkbutton_Liste_Port_Etat_Action_Email;
GtkWidget *checkbutton_Liste_Port_Etat_Action_Message;
GtkWidget *label_Liste_Port_Etat;
GtkWidget *checkbutton_Liste_Port_Etat_Close;
GtkWidget *checkbutton_Liste_Port_Etat;
GtkWidget *label_Liste_Port_Open;
GtkWidget *label_Liste_Port_Close;
GtkWidget *iconentry_Liste_Port_Ouvert;
GtkWidget *iconentry_Liste_Port_Fermer;
GtkWidget *checkbutton_Liste_Port_Marque;
GtkWidget *label_Liste_Port_Modif;
GtkWidget *button_Liste_Port_Ajouter;
GtkWidget *alignment_Liste_Port_Ajouter;
GtkWidget *hbox_Liste_Port_Ajouter;
GtkWidget *image_Liste_Port_Ajouter;
GtkWidget *label_Liste_Port_Ajouter;
GtkWidget *button_Liste_Port_Enlever;
GtkWidget *alignment_Liste_Port_Enlever;
GtkWidget *hbox_Liste_Port_Enlever;
GtkWidget *image_Liste_Port_Enlever;
GtkWidget *label_Liste_Port_Enlever;
GtkWidget *button_Liste_Port_Ok;
GtkWidget *alignment_Liste_Port_Enregistrer;
GtkWidget *hbox_Liste_Port_Enregistrer;
GtkWidget *image_Liste_Port_Enregistrer;
GtkWidget *label_Liste_Port_Enregistrer;
GtkWidget *button_Liste_Port_Annuler;
GtkWidget *alignment_Liste_Port_Annuler;
GtkWidget *hbox_Liste_Port_Annuler;
GtkWidget *image_Liste_Port_Annuler;
GtkWidget *label_Liste_Port_Annuler;
GtkWidget *button_Liste_Port_Sauvegarder;
GtkWidget *alignment_Liste_Port_Valider;
GtkWidget *hbox_Liste_Port_Valider;
GtkWidget *image_Liste_Port_Valider;
GtkWidget *label_Liste_Port_Valider;
GtkTooltips *tooltips;
GtkWidget *window_Force_Reseau;
GdkPixbuf *window_Force_Reseau_icon_pixbuf;
GtkWidget *fixed_Force_Reseau;
GtkWidget *entry_Force_Reseau;
GtkWidget *label_Force_Reseau_Format;
GtkWidget *label_Force_Reseau;
GtkWidget *button_Force_Reseau_Ok;
GtkWidget *alignment_Force_Reseau_Ok;
GtkWidget *hbox_Force_Reseau_Ok;
GtkWidget *image_Force_Reseau_Ok;
GtkWidget *label_Force_Reseau_Ok;
GtkWidget *button_Force_Reseau_Annuler;
GtkWidget *alignment_Force_Reseau_Annuler;
GtkWidget *hbox_Force_Reseau_Annuler;
GtkWidget *image_Force_Reseau_Annuler;
GtkWidget *label_Force_Reseau_Annuler;
GtkWidget *window_Ajout_Script;
GdkPixbuf *window_Ajout_Script_icon_pixbuf;
GtkWidget *fixed_Ajout_Script;
GtkWidget *scrolledwindow_Ajout_Script;
GtkWidget *ctree_Ajout_Script;
GtkWidget *label_Ajout_Script;
GtkWidget *label_Ajout_Script;
GtkWidget *frame_Ajout_Script;
GtkWidget *fixed_Ajout_Script_Modif;
GtkWidget *entry_Ajout_Script_Nom;
GtkWidget *entry_Ajout_Script_Parametre;
GtkWidget *fileentry_Ajout_Script;
GtkWidget *combo_entry_Ajout_Script;
GtkWidget *label_Ajout_Script_Parametre;
GtkWidget *label_Ajout_Script_Nom;
GtkWidget *label_Ajout_Script_Chemin;
GtkWidget *label_Ajout_Script_Modif;
GtkWidget *button_Ajout_Script_Enlever;
GtkWidget *alignment_Ajout_Script_Enlever;
GtkWidget *hbox_Ajout_Script_Enlever;
GtkWidget *image_Ajout_Script_Enlever;
GtkWidget *label_Ajout_Script_Enlever;
GtkWidget *button_Ajout_Script_Ok;
GtkWidget *alignment_Ajout_Script_Ok;
GtkWidget *hbox_Ajout_Script_Ok;
GtkWidget *image_Ajout_Script_Ok;
GtkWidget *label_Ajout_Script_Ok;
GtkWidget *button_Ajout_Script_Annuler;
GtkWidget *alignment_Ajout_Script_Annuler;
GtkWidget *hbox_Ajout_Script_Annuler;
GtkWidget *image_Ajout_Script_Annuler;
GtkWidget *label_Ajout_Script_Annuler;
GtkWidget *button_Ajout_Script_Ajouter;
GtkWidget *alignment_Ajout_Script_Ajouter;
GtkWidget *hbox_Ajout_Script_Ajouter;
GtkWidget *image_Ajout_Script_Ajouter;
GtkWidget *label_Ajout_Script_Ajouter;
GtkWidget *button_Ajout_Script_Sauvegarder;
GtkWidget *alignment_Ajout_Script_Sauvegarder;
GtkWidget *hbox_Ajout_Script_Sauvegarder;
GtkWidget *image_Ajout_Script_Sauvegarder;
GtkWidget *label_Ajout_Script_Sauvegarder;
GtkTooltips *tooltips;
GtkWidget *fileselection_Enregistrer;
GdkPixbuf *fileselection_Enregistrer_icon_pixbuf;
GtkWidget *ok_button_Enregistrer;
GtkWidget *alignment_Enregistrer_Save;
GtkWidget *hbox_Enregistrer_Save;
GtkWidget *image_Enregistrer_Save;
GtkWidget *label_Enregistrer_Save;
GtkWidget *cancel_button_Enregistrer;
GtkWidget *window_Preference;
GdkPixbuf *window_Preference_icon_pixbuf;
GtkWidget *fixed_Preference;
GtkWidget *notebook_Preference;
GtkWidget *fixed_Preference_Interface;
GtkObject *spinbutton_Preference_Interface_Max_Thread_Scan_adj;
GtkWidget *spinbutton_Preference_Interface_Max_Thread_Scan;
GtkWidget *label_Preference_Interface_Max_Thread_Scan;
GtkWidget *combo_Preference_Interface_Interface;
GtkWidget *combo_entry_Preference_Interface;
GtkWidget *label_Preference_Interface_Interface;
GtkWidget *frame_Preference_Sous_reseau_privee;
GtkWidget *fixed_Preference_Sous_reseau_privee;
GtkWidget *scrolledwindow_Preference_Sous_reseau_privee;
GtkWidget *ctree_Preference_Sous_reseau_privee;
GtkWidget *label_Preference_Sous_reseau_privee_Mask;
GtkWidget *label_Preference_Sous_reseau_privee_Sous_reseau;
GtkWidget *combo_Preference_Sous_reseau_privee;
GtkWidget *combo_entry_Preference_Sous_reseau_privee;
GtkWidget *entry_Preference_Sous_reseau_privee_1;
GtkWidget *entry_Preference_Sous_reseau_privee_2;
GtkWidget *entry_Preference_Sous_reseau_privee_3;
GtkWidget *button_Preference_Sous_reseau_privee_Enlever;
GtkWidget *alignment_Preference_Sous_reseau_privee_Enlever;
GtkWidget *hbox_Preference_Sous_reseau_privee_Enlever;
GtkWidget *image_Preference_Sous_reseau_privee_Enlever;
GtkWidget *label_Preference_Sous_reseau_privee_Enlever;
GtkWidget *button_Preference_Sous_reseau_privee_Ok;
GtkWidget *alignment_Preference_Sous_reseau_privee_Ok;
GtkWidget *hbox_Preference_Sous_reseau_privee_Ok;
GtkWidget *image_Preference_Sous_reseau_privee_Ok;
GtkWidget *label_Preference_Sous_reseau_privee_Ok;
GtkWidget *button_Preference_Sous_reseau_privee_Annuler;
GtkWidget *alignment_Preference_Sous_reseau_privee_Annuler;
GtkWidget *hbox_Preference_Sous_reseau_privee_Annuler;
GtkWidget *image_Preference_Sous_reseau_privee_Annuler;
GtkWidget *label_Preference_Sous_reseau_privee_Annuler;
GtkWidget *button_Preference_Sous_reseau_privee_Ajouter;
GtkWidget *alignment_Preference_Sous_reseau_privee_Ajouter;
GtkWidget *hbox_Preference_Sous_reseau_privee_Ajouter;
GtkWidget *image_Preference_Sous_reseau_privee_Ajouter;
GtkWidget *label_Preference_Sous_reseau_privee_Ajouter;
GtkWidget *label_Preference_Interface_Reseau_Prive;
GtkWidget *fixed_Menu_Interfaces;
GtkWidget *image_Menu_Interfaces;
GtkWidget *label_Menu_Interfaces;
GtkWidget *fixed_Preference_Type_equipement;
GtkWidget *scrolledwindow_Preference_Type_equipement;
GtkWidget *ctree_Preference_Type_equipement;
GtkWidget *entry_Preference_Type_equipement_Type;
GtkWidget *frame_Preference_Type_equipement_Etat_Port;
GtkWidget *fixed_Preference_Type_equipement_Etat_Port;
GtkWidget *frame_Preference_Type_equipement_Etat_Port_Actions;
GtkWidget *fixed_Preference_Type_equipement_Etat_Port_Actions;
GtkWidget *entry_Preference_Type_equipement_Etat_Port_Actions_Email;
GtkWidget *entry_Preference_Type_equipement_Etat_Port_Actions_Script;
GtkWidget *checkbutton_Preference_Type_equipement_Etat_Port_Actions_Email;
GtkWidget *checkbutton_Preference_Type_equipement_Etat_Port_Actions_Script;
GtkWidget *checkbutton_Preference_Type_equipement_Etat_Port_Actions_Message;
GtkWidget *label_Preference_Type_equipement_Etat_Port_Actions;
GtkWidget *checkbutton_Preference_Type_equipement_Etat_Port_Down;
GtkWidget *checkbutton_Preference_Type_equipement_Etat_Port;
GtkWidget *frame_Preference_Type_equipement_Etat_Equipement;
GtkWidget *fixed_Preference_Type_equipement_Etat_Equipement;
GtkWidget *frame_Preference_Type_equipement_Etat_Equipement;
GtkWidget *fixed_Preference_Type_equipement_Etat_Equipement_Actions;
GtkWidget *entry_Preference_Type_equipement_Etat_Equipement_Actions_Email;
GtkWidget *entry_Preference_Type_equipement_Etat_Equipement_Actions_Script;
GtkWidget *checkbutton_Preference_Type_equipement_Etat_Equipement_Actions_Email;
GtkWidget *checkbutton_Preference_Type_equipement_Etat_Equipement_Actions_Message;
GtkWidget *checkbutton_Preference_Type_equipement_Etat_Equipement_Actions_Script;
GtkWidget *label_Preference_Type_equipement_Etat_Equipement_Actions;
GtkWidget *checkbutton_Preference_Type_equipement_Etat_Equipement_Down;
GtkWidget *checkbutton_Preference_Type_equipement_Etat_Equipement;
GtkWidget *label_Preference_Type_equipement_Type;
GtkWidget *iconentry_Preference_Type_equipement;
GtkWidget *button_Preference_Type_equipement_Ajouter;
GtkWidget *alignment_Preference_Type_equipement_Ajouter;
GtkWidget *hbox_Preference_Type_equipement_Ajouter;
GtkWidget *image_Preference_Type_equipement_Ajouter;
GtkWidget *label_Preference_Type_equipement_Ajouter;
GtkWidget *button_Preference_Type_equipement_Enlever;
GtkWidget *alignment_Preference_Type_equipement_Enlever;
GtkWidget *hbox_Preference_Type_equipement_Enlever;
GtkWidget *image_Preference_Type_equipement_Enlever;
GtkWidget *label_Preference_Type_equipement_Enlever;
GtkWidget *button_Preference_Type_equipement_Valider;
GtkWidget *alignment_Preference_Type_equipement_Valider;
GtkWidget *hbox_Preference_Type_equipement_Valider;
GtkWidget *image_Preference_Type_equipement_Valider;
GtkWidget *label_Preference_Type_equipement_Valider;
GtkWidget *button_Preference_Type_equipement_Annuler;
GtkWidget *alignment_Preference_Type_equipement_Annuler;
GtkWidget *hbox_Preference_Type_equipement_Annuler;
GtkWidget *image_Preference_Type_equipement_Annuler;
GtkWidget *label_Preference_Type_equipement_Annuler;
GtkWidget *fixed_Menu_Type_Equipement;
GtkWidget *image_Menu_Type_Equipement;
GtkWidget *label_Menu_Type_Equipement;
GtkWidget *fixed_Preference_Notification;
GtkWidget *frame_Preference_Notification_Nouveau_Equipement;
GtkWidget *fixed_Preference_Notification_Nouveau_Equipement;
GtkWidget *entry_Preference_Notification_Nouveau_Equipement_Email;
GtkWidget *checkbutton_Preference_Notification_Nouveau_Equipement_Message;
GtkWidget *checkbutton_Preference_Notification_Nouveau_Equipement_Email;
GtkWidget *checkbutton_Preference_Notification_Nouveau_Equipement;
GtkWidget *frame_Preference_Notification_Etat_Equipement;
GtkWidget *fixed_Preference_Notification_Etat_Equipement;
GtkObject *spinbutton_Preference_Notification_Etat_Equipement_Up_Secondes_adj;
GtkWidget *spinbutton_Preference_Notification_Etat_Equipement_Up_Secondes;
GtkObject *spinbutton_Preference_Notification_Etat_Equipement_Down_Secondes_adj;
GtkWidget *spinbutton_Preference_Notification_Etat_Equipement_Down_Secondes;
GtkWidget *label_Preference_Notification_Etat_Equipement_Test_Up_Secondes;
GtkWidget *label_Preference_Notification_Etat_Equipement_Test_Up_Secondes;
GtkWidget *label_Preference_Notification_Etat_Equipement_Test_Up;
GtkWidget *label_Preference_Notification_Etat_Equipement_Down;
GtkWidget *label_Preference_Notification_Etat_Equipement;
GtkWidget *frame_Preference_Notification_Etat_Port;
GtkWidget *fixed_Preference_Notification_Etat_Port;
GtkObject *spinbutton_Preference_Notification_Etat_Port_Up_Secondes_adj;
GtkWidget *spinbutton_Preference_Notification_Etat_Port_Up_Secondes;
GtkObject *spinbutton_Preference_Notification_Etat_Port_Down_Secondes_adj;
GtkWidget *spinbutton_Preference_Notification_Etat_Port_Down_Secondes;
GtkWidget *label_Preference_Notification_Etat_Port_Test_Up;
GtkWidget *label_Preference_Notification_Etat_Port_Test_Down;
GtkWidget *label_Preference_Notification_Etat_Port_Test_Up;
GtkWidget *label_Preference_Notification_Etat_Port_Test_Down;
GtkWidget *label_Preference_Notification_Etat_Port;
GtkWidget *checkbutton_Preference_Notification_Etat_NBNS;
GtkWidget *fixed_Menu_Notifications;
GtkWidget *image_Menu_Notifications;
GtkWidget *label_Menu_Notifications;
GtkWidget *fixed_Preference_Preference;
GtkWidget *entry_Preference_Preference_Shell;
GtkWidget *entry_Preference_Preference_Samba;
GtkWidget *entry_Preference_Preference_Web;
GtkWidget *label_Preference_Preference_Samba;
GtkWidget *label_Preference_Preference_Shell;
GtkWidget *label_Preference_Preference_Web;
GtkWidget *label_Preference_Preference_Smtp;
GtkWidget *entry_Preference_Preference_Smtp;
GtkWidget *fixed_Menu_Preferences;
GtkWidget *image_Menu_Preferences;
GtkWidget *label_Menu_Preferences;
GtkWidget *fixed_Preference_Extensions;
GtkWidget *ctree_Preference_Extensions;
GtkWidget *label_Preference_Extensions;
GtkWidget *fixed_Menu_Extensions;
GtkWidget *image_Menu_Extensions;
GtkWidget *label_Menu_Extensions;
GtkWidget *button_Preference_Enregistrer;
GtkWidget *alignment_Preference_Enregistrer;
GtkWidget *hbox_Preference_Enregistrer;
GtkWidget *image_Preference_Enregistrer;
GtkWidget *label_Preference_Enregistrer;
GtkWidget *button_Preference_Annuler;
GtkWidget *alignment_Preference_Annuler;
GtkWidget *hbox_Preference_Annuler;
GtkWidget *image_Preference_Annuler;
GtkWidget *label_Preference_Annuler;
GtkWidget *window_Liste_Signatures;
GdkPixbuf *window_Liste_Signatures_icon_pixbuf;
GtkWidget *fixed_Liste_Signatures;
GtkWidget *scrolledwindow_Liste_Signatures;
GtkWidget *ctree_Liste_Signatures;
GtkWidget *label_Liste_Signatures_Nom_Systeme;
GtkWidget *label_Liste_Signatures_md5;
GtkWidget *frame_Liste_Signatures;
GtkWidget *fixed_Liste_Signatures_Ajout;
GtkWidget *entry_Liste_Signatures_Nom;
GtkWidget *entry_Liste_Signatures_md5;
GtkWidget *combo_Liste_Signatures_Type;
GtkWidget *entry_Liste_Signatures_Type;
GtkWidget *label_Liste_Signatures_Type;
GtkWidget *label_Liste_Signatures_Up;
GtkWidget *label_Liste_Signatures_Down;
GtkWidget *label_Liste_Signatures_Nom;
GtkWidget *label_Liste_Signatures_md5;
GtkWidget *frame_Liste_Signatures_Etat;
GtkWidget *fixed_Liste_Signatures_Etat;
GtkWidget *frame_Liste_Signatures_Etat_Action;
GtkWidget *fixed_Liste_Signatures_Etat_Action;
GtkWidget *entry_Liste_Signatures_Etat_Action_Email;
GtkWidget *checkbutton_Liste_Signatures_Etat_Action_Message;
GtkWidget *checkbutton_Liste_Signatures_Etat_Action_Email;
GtkWidget *label_Liste_Signatures_Etat_Action;
GtkWidget *checkbutton_Liste_Signatures_Etat_Down;
GtkWidget *checkbutton_Liste_Signatures_Etat;
GtkWidget *checkbutton_Liste_Signatures_NETBIOS;
GtkWidget *checkbutton_Liste_Signatures_Routeur;
GtkWidget *iconentry_Liste_Signature_Allumer;
GtkWidget *iconentry_Liste_Signature_Eteint;
GtkWidget *label_Liste_Signatures_Ajout;
GtkWidget *button_Liste_Signatures_Annuler;
GtkWidget *alignment_Liste_Signatures_Annuler;
GtkWidget *hbox_Liste_Signatures_Annuler;
GtkWidget *image_Liste_Signatures_Annuler;
GtkWidget *label_Liste_Signatures_Annuler;
GtkWidget *button_Liste_Signatures_Ok;
GtkWidget *alignment_Liste_Signatures_Enregistrer;
GtkWidget *hbox_Liste_Signatures_Enregistrer;
GtkWidget *image_Liste_Signatures_Enregistrer;
GtkWidget *label_Liste_Signatures_Enregistrer;
GtkWidget *button_Liste_Signatures_Enlever;
GtkWidget *alignment_Liste_Signatures_Enlever;
GtkWidget *hbox_Liste_Signatures_Enlever;
GtkWidget *image_Liste_Signatures_Enlever;
GtkWidget *label_Liste_Signatures_Enlever;
GtkWidget *button_Liste_Signatures_Ajouter;
GtkWidget *alignment_Liste_Signatures_Ajouter;
GtkWidget *hbox_Liste_Signatures_Ajouter;
GtkWidget *image_Liste_Signatures_Ajouter;
GtkWidget *label_Liste_Signatures_Ajouter;
GtkWidget *button_Liste_Signatures_Sauvegarder;
GtkWidget *alignment_Liste_Signatures_Sauvegarder;
GtkWidget *hbox_Liste_Signatures_Sauvegarder;
GtkWidget *image_Liste_Signatures_Sauvegarder;
GtkWidget *label_Liste_Signatures_Sauvegarder;
GtkWidget *window_Debug_Scan;
GtkWidget *fixed_Debug_Scan;
GtkWidget *scrolledwindow_Debug_Scan;
GtkWidget *textview_Debug_Scan;
GtkWidget *button_Debug_Scan_Fermer;
GtkWidget *window_Dns;
GtkWidget *hpaned_Dns;
GtkWidget *scrolledwindow_Dns_Liste;
GtkWidget *ctree_Dns_Liste;
GtkWidget *scrolledwindow_Dns_Info;
GtkWidget *ctree_Dns_Info;
GtkWidget *label_Dns_Info_Nom;
GtkWidget *label_Dns_Info_Type;
GtkWidget *label_Dns_Info_Donnees;
GtkWidget *window_Recherche_Machine;
GdkPixbuf *window_Recherche_Machine_icon_pixbuf;
GtkWidget *fixed_Recherche;
GtkWidget *entry_Recherche_Adresse_Mac;
GtkWidget *entry_Recherche_Adresse_Ip;
GtkWidget *entry_Recherche_Nom_NetBios;
GtkWidget *radiobutton_Recherche_Adresse_Mac;
GtkWidget *radiobutton_Recherche_Nom_NetBios;
GtkWidget *radiobutton_Recherche_Adresse_Ip;
GtkWidget *button_Recherche_Annuler;
GtkWidget *alignment_Recherche_Annuler;
GtkWidget *hbox_Recherche_Annuler;
GtkWidget *image_Recherche_Annuler;
GtkWidget *label_Recherche_Annuler;
GtkWidget *button_Recherche_Valider;
GtkWidget *alignment_Recherche_Valider;
GtkWidget *hbox_Recherche_Valider;
GtkWidget *image_Recherche_Valider;
GtkWidget *label_Recherche_Valider;
GtkAccelGroup *accel_group;
GtkWidget *window_Resultat_Script;
GtkWidget *fixed_Resultat_Script;
GtkWidget *scrolledwindow_Resultat_Script;
GtkWidget *textview_Resultat_Script;
GtkWidget *button_Resultat_Script_Fermer;
GtkWidget *window_demarrage;
GdkPixbuf *window_demarrage_icon_pixbuf;
GtkWidget *fixed_Demarrage;
GtkWidget *viewport_Demarrage_Titre;
GtkWidget *fixed_Demarrage_Titre;
GtkWidget *label_Demarrage_Titre;
GtkWidget *iconlist_Demarrage_Fichier;
GtkWidget *button_Demarrage_Preferences;
GtkWidget *alignment_Demarrage_Preferences;
GtkWidget *hbox_Demarrage_Preferences;
GtkWidget *image_Demarrage_Preferences;
GtkWidget *label_Demarrage_Preferences;
GtkWidget *checkbutton_Demarrage_Ajouter;
GtkWidget *checkbutton_Demarrage_Mise_A_Jour;
GtkWidget *button_Demarrage_Annuler;
GtkWidget *alignment_Demarrage_Valider;
GtkWidget *hbox_Demarrage_Valider;
GtkWidget *image_Demarrage_Valider;
GtkWidget *label_Demarrage_Valider;
GtkWidget *button_Demarrage_Valider;
GtkWidget *alignment_Demarrage_Valider;
GtkWidget *hbox_Demarrage_Valider;
GtkWidget *image_Demarrage_Valider;
GtkWidget *label_Demarrage_Valider;
GtkWidget *window_Contributions;
GdkPixbuf *window_Contributions_icon_pixbuf;
GtkWidget *fixed_Contributions;
GtkWidget *scrolledwindow_Contributions;
GtkWidget *textview_Contributions;
GtkWidget *label_Contributions;
GtkWidget *button_Contributions;
GtkWidget *window_Notification;
GdkPixbuf *window_Notification_icon_pixbuf;
GtkWidget *fixed_Notifications;
GtkWidget *label_Notifications;
GtkWidget *checkbutton_Notifications;
GtkWidget *image_Notifications;
GtkWidget *button_Notifications_Fermer;
GtkWidget *alignment_Notifications_Fermer;
GtkWidget *hbox_Notifications_Fermer;
GtkWidget *image_Notifications_Fermer;
GtkWidget *label_Notifications_Fermer;
GtkWidget *window_Partage;
GtkWidget *fixed_Partage;
GtkWidget *entry_Partage_Utilisateur;
GtkWidget *entry_Partage_Mot_Passe;
GtkWidget *entry_Partage_Domaine;
GtkWidget *label_Partage_Mot_Passe;
GtkWidget *label_Partage_Domaine;
GtkWidget *button_Partage_Fermer;
GtkWidget *button_Partage_Valider;
GtkWidget *checkbutton_Partage_Password;
GtkWidget *label_Partage_Utilisateur;
GtkWidget *image_Partage_Cle;
GtkAccelGroup *accel_group;
GtkWidget *href_autoscan;
