/*
 *  Copyright (C) 2004 Thierry Lagarde <tlagarde@user.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>
#include <signal.h>
#include <sys/ipc.h>
#include <sys/msg.h>

#include "interface.h"
#include "support.h"
#include "Reseau.h"
#include "callbacks.h"
#include "Commun.h"
#include "Machine.h"


GThreadFunctions *vtable;
static int ptimer_Rafraichi = 0;
extern int h_errno;

static const char version[] = "AutoScan 0.92: compilé le " __TIME__ " " __DATE__ "\n";



int       Num_Machine = 0;
int       Nb_thread_Scan = 0;
gboolean  refresh, Script_Retour;
int       Afficher_Fenetre_Image_Demarrage;
gboolean  Affiche_Image;

gboolean timer ()
{
	struct struct_Machines_Resultat Resultat;
	struct struct_Message Message_Envoyer;
	struct struct_Message_Temps_Reel Message_Envoyer_Temps_Reel;
	int       Taille_Recuperer, i, Machine, Nb_Machine_Recuperer, Taille_Recuperer_Message, Taille_Recuperer_Message_Temps_Reel, Pourcentage;
	gboolean  NouvelleMachine, Modification_Liste_Machine;
	char      temp[255];
	gdouble   Total, A_Faire;
	gchar    *titre[1];

	if (Affiche_Image)
		if (Afficher_Fenetre_Image_Demarrage < 2) {
			//printf("[I] + une seconde\n");
			Afficher_Fenetre_Image_Demarrage++;
		}
		else {
			//printf ("[I] Cache fenetre image demarrage\n");
			Cache_Icone_Demarrage ();
			Affiche_Image = FALSE;
		}

	Nb_Machine_Recuperer = 0;
	Modification_Liste_Machine = FALSE;
	do {
		if ((Taille_Recuperer_Message_Temps_Reel = msgrcv (File_Envoie_Message_Temps_Reel, (void *) &Message_Envoyer_Temps_Reel, sizeof (Message_Envoyer_Temps_Reel) - sizeof (long), 0, IPC_NOWAIT)) > -1) {
			switch (Message_Envoyer_Temps_Reel.type_message) {
			    case ARRET_MACHINE:
				    i = 0;
				    printf ("[I] %02X:%02X:%02X:%02X:%02X:%02X\n", Message_Envoyer_Temps_Reel.Mac_Adresse_Machine[0], Message_Envoyer_Temps_Reel.Mac_Adresse_Machine[1], Message_Envoyer_Temps_Reel.Mac_Adresse_Machine[2], Message_Envoyer_Temps_Reel.Mac_Adresse_Machine[3], Message_Envoyer_Temps_Reel.Mac_Adresse_Machine[4], Message_Envoyer_Temps_Reel.Mac_Adresse_Machine[5]);
				    while ((i < Nb_Machine_Trouve) && (memcmp (&Message_Envoyer_Temps_Reel.Mac_Adresse_Machine, &Liste_Machines[i].AdresseMAC, 6) != 0)) {
					    i++;
				    }
				    printf ("[I] %02X:%02X:%02X:%02X:%02X:%02X   trouvé %d\n", Liste_Machines[i].AdresseMAC[0], Liste_Machines[i].AdresseMAC[1], Liste_Machines[i].AdresseMAC[2], Liste_Machines[i].AdresseMAC[3], Liste_Machines[i].AdresseMAC[4], Liste_Machines[i].AdresseMAC[5], Nb_Machine_Trouve);

				    if (memcmp (&Message_Envoyer_Temps_Reel.Mac_Adresse_Machine, &Liste_Machines[i].AdresseMAC, 6) == 0) {
					    printf ("[I]   Arret machine [%d]  [%s]\n", i, Liste_Machines[i].Adresse_Mac);
					    /* gtk_ctree_node_set_pixmap (GTK_CTREE (ctree_Liste_Machine), Liste_Machines[i].ctree, 0, Liste_Machines[i].Image_Eteint, Liste_Machines[i].Masque_Eteint);
					     * if (Liste_Machines[i].Smb.HostName[0] == 0)
					     * titre[0] = g_strdup_printf (Liste_Machines[i].Adresse_Ip);
					     * else
					     * titre[0] = g_strdup_printf (Liste_Machines[i].Smb.HostName);
					     * gtk_ctree_node_set_text (GTK_CTREE (ctree_Liste_Machine), Liste_Machines[i].ctree, 0, titre);
					     * g_free (titre[0]); */
					    if (!Modification_Liste_Machine) {
						    Modification_Liste_Machine = TRUE;
						    gtk_clist_freeze (GTK_CLIST (ctree_Liste_Machine));	// gel l'affichage
					    }
					    Affiche_Nouvelle_Machine (i, FALSE, FALSE);
				    }
				    else
					    printf ("[I]  ###########################  Arret machine inconnu\n");
				    break;
			    case DEMARRAGE_MACHINE:
				    i = 0;
				    printf ("[I] %02X:%02X:%02X:%02X:%02X:%02X\n", Message_Envoyer_Temps_Reel.Mac_Adresse_Machine[0], Message_Envoyer_Temps_Reel.Mac_Adresse_Machine[1], Message_Envoyer_Temps_Reel.Mac_Adresse_Machine[2], Message_Envoyer_Temps_Reel.Mac_Adresse_Machine[3], Message_Envoyer_Temps_Reel.Mac_Adresse_Machine[4], Message_Envoyer_Temps_Reel.Mac_Adresse_Machine[5]);
				    while ((i < Nb_Machine_Trouve) && (memcmp (&Message_Envoyer_Temps_Reel.Mac_Adresse_Machine, &Liste_Machines[i].AdresseMAC, 6) != 0)) {
					    i++;
					    //printf ("+\n");
				    }
				    printf ("[I] %02X:%02X:%02X:%02X:%02X:%02X   trouvé %d\n", Liste_Machines[i].AdresseMAC[0], Liste_Machines[i].AdresseMAC[1], Liste_Machines[i].AdresseMAC[2], Liste_Machines[i].AdresseMAC[3], Liste_Machines[i].AdresseMAC[4], Liste_Machines[i].AdresseMAC[5], Nb_Machine_Trouve);
				    if (memcmp (&Message_Envoyer_Temps_Reel.Mac_Adresse_Machine, &Liste_Machines[i].AdresseMAC, 6) == 0) {
					    printf ("[I]   Demmarage machine [%d]  [%s]\n", i, Liste_Machines[i].Adresse_Mac);
					    /*gtk_ctree_node_set_pixmap (GTK_CTREE (ctree_Liste_Machine), Liste_Machines[i].ctree, 0, Liste_Machines[i].Image, Liste_Machines[i].Masque);
					     * if (Liste_Machines[i].Smb.HostName[0] == 0)
					     * titre[0] = g_strdup_printf (Liste_Machines[i].Adresse_Ip);
					     * else
					     * titre[0] = g_strdup_printf (Liste_Machines[i].Smb.HostName);
					     * gtk_ctree_node_set_text (GTK_CTREE (ctree_Liste_Machine), Liste_Machines[i].ctree, 0, titre);
					     * g_free (titre[0]); */
					    if (!Modification_Liste_Machine) {
						    Modification_Liste_Machine = TRUE;
						    gtk_clist_freeze (GTK_CLIST (ctree_Liste_Machine));	// gel l'affichage
					    }
					    Affiche_Nouvelle_Machine (i, FALSE, TRUE);
				    }
				    else
					    printf ("[I]  ###########################  Demarrage machine inconnu\n");
				    break;
			    default:
				    printf ("[I] ################ Type de message inconnu  (Message_Envoyer_Temps_Reel)\n");
			}

		}
		if ((Taille_Recuperer_Message = msgrcv (File_Envoie_Message, (void *) &Message_Envoyer, sizeof (Message_Envoyer) - sizeof (long), 0, IPC_NOWAIT)) > -1) {
			switch (Message_Envoyer.type_message) {
			    case ERREUR:
				    Message (Message_Envoyer.donnee, GNOME_MESSAGE_BOX_ERROR);
				    break;
			    case WARNING:
				    Message (Message_Envoyer.donnee, GNOME_MESSAGE_BOX_WARNING);
				    break;
			    case INFO:
				    Message (Message_Envoyer.donnee, GNOME_MESSAGE_BOX_INFO);
				    break;
			    case RETOUR_SCRIPT:
				    gtk_text_insert (GTK_EDITABLE (textview_Resultat_Script), NULL, NULL, NULL, Message_Envoyer.donnee, strlen (Message_Envoyer.donnee));
				    Script_Retour = TRUE;
				    break;
			    case RETOUR_SCRIPT_TERMINE:
				    gtk_widget_show (window_Resultat_Script);
				    gtk_text_insert (GTK_EDITABLE (textview_Resultat_Script), NULL, NULL, NULL, "\n************************************\n\n\n", 40);
				    Script_Retour = FALSE;
				    break;
			    case RETOUR_INFO:
				    Total = Message_Envoyer.Nb_Machine_Dans_La_Liste;
				    A_Faire = Message_Envoyer.Nb_Machine_En_Cours_De_Scan + Message_Envoyer.Nb_Machine_En_Attente_De_Scan;
				    Pourcentage = (int) ((Total - A_Faire) / Total);
				    printf ("%g %g   %d\n", Total, A_Faire, (int) ((Pourcentage) * 100));
				    gtk_progress_bar_set_fraction (GTK_PROGRESS_BAR (progressbar_Info), (gdouble) Pourcentage);
				    sprintf (temp, "Total : %g (%d/%d)   %%%d", Total, Message_Envoyer.Nb_Machine_En_Cours_De_Scan, Message_Envoyer.Nb_Machine_En_Attente_De_Scan, (int) ((Pourcentage) * 100));
				    printf ("[I] %s\n", temp);
				    gtk_progress_bar_set_text (GTK_PROGRESS_BAR (progressbar_Info), temp);
				    break;
			    case AUTOSCAN_SEGMENTATION_FAULT:
				    Bug_autoscan_d = TRUE;
				    printf ("[I] autoscan_d a plante\n");
				    break;
			    default:
				    printf ("[I] ################ Type de message inconnu (Message_Envoyer)\n");
			}
		}

		if ((Taille_Recuperer = msgrcv (File_Reception_Nouvelle_Machine, (void *) &Resultat, sizeof (Resultat) - sizeof (long), 0, IPC_NOWAIT)) > -1) {
			printf ("[I] Reception nouvelle machine ou resultat rescan machine   %d=%d  %d\n", Taille_Recuperer, (sizeof (Resultat) - sizeof (long)), sizeof (gboolean));
			if (Taille_Recuperer == (sizeof (Resultat) - sizeof (long))) {
				if (!Modification_Liste_Machine) {
					Modification_Liste_Machine = TRUE;
					gtk_clist_freeze (GTK_CLIST (ctree_Liste_Machine));	// gel l'affichage
				}
				/* Est que c'est une nouvelle machine ou juste un rescan */
				NouvelleMachine = TRUE;
				i = 0;
				printf ("%04X  %04X\n", Resultat.AdresseIp, Liste_Machines[i].AdresseIp);
				while ((i < Nb_Machine_Trouve) && (memcmp (&Resultat.AdresseIp, &Liste_Machines[i].AdresseIp, 4) != 0)) {
					i++;
				}
				if (memcmp (&Resultat.AdresseIp, &Liste_Machines[i].AdresseIp, 4) == 0)
					NouvelleMachine = FALSE;	// ce n'est pas une nouvelle machine juste un rescan
				if (NouvelleMachine) {
					Machine = Nb_Machine_Trouve;
					Total = Resultat.Nb_Machine_Dans_La_Liste;
					A_Faire = Resultat.Nb_Machine_En_Cours_De_Scan + Resultat.Nb_Machine_En_Attente_De_Scan;
					printf ("[I] Resultat Nouvelle Machine  %d   --> %g %g   %g\n", Machine, Total, A_Faire, (Total - A_Faire) / Total);
					gtk_progress_bar_set_fraction (GTK_PROGRESS_BAR (progressbar_Info), (Total - A_Faire) / Total);
					sprintf (temp, "Total : %d (%d/%d)   %%%d", Resultat.Nb_Machine_Dans_La_Liste, Resultat.Nb_Machine_En_Cours_De_Scan, Resultat.Nb_Machine_En_Attente_De_Scan, (int) (((Total - A_Faire) / Total) * 100));
					gtk_progress_bar_set_text (GTK_PROGRESS_BAR (progressbar_Info), temp);
				}
				else {
					Machine = i;
					printf ("[I] Resultat rescanne Machine  %d\n", i);
				}
				Initialise_Structure_Machine (Machine);
				Ajoute_Nouvelle_Machine (Machine, Resultat.Adresse_Ip, Resultat.Adresse_Mac, Resultat.AdresseIp, Resultat.AdresseMAC, NouvelleMachine);
				memcpy (Liste_Machines[Machine].digest, Resultat.digest, 16);
				Identifie_Machine (Machine);
				/* Ajout les ports */
				Liste_Machines[Machine].Nb_Port_Ouvert = 0;
				for (i = 0; i < Resultat.Nb_Port_Ouvert; i++)
					Ajoute_port (Machine, Resultat.Port[i].Index_Port, Resultat.Port[i].Etat, Resultat.Port[i].Num_Port, Resultat.Port[i].Type_Machine);
				Liste_Machines[Machine].Nb_Port_Fermer = Resultat.Nb_Port_Fermer;
				Liste_Machines[Machine].Nb_Port_Firewaller = Resultat.Nb_Port_Firewaller;
				Liste_Machines[Machine].Nb_Port_Total_Scanner = Resultat.Nb_Port_Total_Scanner;
				/* Ajout les infos netbios */
				strcpy (Liste_Machines[Machine].Smb.HostName, Resultat.Smb.HostName);
				strcpy (Liste_Machines[Machine].Smb.DomainName, Resultat.Smb.DomainName);
				strcpy (Liste_Machines[Machine].Smb.Utilisateur, Resultat.Smb.Utilisateur);
				i = 0;
				while (Resultat.Smb.Smb_Registration[i].Type != 0) {
					Liste_Machines[Machine].Smb.Smb_Registration[i].Type = Resultat.Smb.Smb_Registration[i].Type;
					strcpy (Liste_Machines[Machine].Smb.Smb_Registration[i].Name, Resultat.Smb.Smb_Registration[i].Name);
					Liste_Machines[Machine].Smb.Smb_Registration[i].Numero = Resultat.Smb.Smb_Registration[i].Numero;
					i++;
				}
				Liste_Machines[Machine].Serveur = Resultat.Serveur;
				Affiche_Nouvelle_Machine (Machine, NouvelleMachine, TRUE);
				Nb_Machine_Recuperer++;
			}
			else {
				printf ("[I] Erreur taille de reponse nouvelle machine trouve\n");
				exit (-1);
			}
		}
	} while ((Taille_Recuperer_Message_Temps_Reel != -1) || (Taille_Recuperer_Message != -1) || (Taille_Recuperer != -1));
	if (Modification_Liste_Machine)
		gtk_clist_thaw (GTK_CLIST (ctree_Liste_Machine));
	return TRUE;
}

int Valeur_Semaphore (sem_t * sem)
{
	int       valeur;

	sem_getvalue (sem, &valeur);
	return valeur;
}

void Control_C (int sig)
{
	Fin (ARRET_CONTROL_C);
}

void segfault_handler (int sig)
{
	char      erreur[255];


	g_print ("\n[I] Segmentation fault    Et oui. Encore un bug   pid : %d\n", getpid ());
	Fin (ARRET);
}


int main (int argc, char *argv[])
{
	GdkColor  Transparent;
	GdkColor  CouleurFond;
	pid_t     pid_fils;


	printf ("[I] Creation du signal\n");
	signal (SIGSEGV, segfault_handler);
	signal (SIGINT, Control_C);

	gtk_set_locale ();
	gnome_program_init (PACKAGE, VERSION, LIBGNOMEUI_MODULE, argc, argv, GNOME_PARAM_APP_DATADIR, PACKAGE_DATA_DIR, NULL);
	window = create_window ();
	Afficher_Icone_Demarrage ();
	Affiche_Image = TRUE;
	Afficher_Fenetre_Image_Demarrage = 0;
	IconeFocus = -1;

	Demarrage = TRUE;
	Script_Retour = FALSE;
	Bug_autoscan_d = FALSE;
	Info_User = getpwuid (getuid ());
	MachineSelectionner = INCONNU;
	IconeSelectionner = INCONNU;
	Nb_Machine_Trouve = 0;
	printf (version);
	Scan_Actif = TRUE;
	Mode_Liste_Icone_Port = TRUE;
	Mode_Liste_Partage = FALSE;
	Mode_Documentation = FALSE;
	Mode_Documentation_Demarrage = FALSE;
	/* Destruction des files de messages */
	if (msgctl (msgget (KEY_FILE_RECEPTION_NOUVELLE_MACHINE, 0), IPC_RMID, NULL) == 0) {
		printf ("[I] File KEY_FILE_RECEPTION_NOUVELLE_MACHINE detruite\n");
	}
	if (msgctl (msgget (KEY_FILE_DEMANDE, 0), IPC_RMID, NULL) == 0) {
		printf ("[I] File KEY_FILE_DEMANDE detruite\n");
	}
	if (msgctl (msgget (KEY_FILE_MESSAGE, 0), IPC_RMID, NULL) == 0) {
		printf ("[I] File KEY_FILE_MESSAGE detruite\n");
	}
	if (msgctl (msgget (KEY_FILE_MESSAGE_TEMP_REEL, 0), IPC_RMID, NULL) == 0) {
		printf ("[I] File KEY_FILE_MESSAGE_TEMP_REEL detruite\n");
	}
	/* Création des files de messages */
	if ((File_Reception_Nouvelle_Machine = msgget (KEY_FILE_RECEPTION_NOUVELLE_MACHINE, IPC_CREAT | 0777)) == -1) {
		perror ("[I] msgget");
		exit (1);
	}
	if ((File_Envoie_Demande = msgget (KEY_FILE_DEMANDE, IPC_CREAT | 0777)) == -1) {
		perror ("[I] msgget");
		exit (1);
	}
	if ((File_Envoie_Message = msgget (KEY_FILE_MESSAGE, IPC_CREAT | 0777)) == -1) {
		perror ("[I] msgget");
		exit (1);
	}
	if ((File_Envoie_Message_Temps_Reel = msgget (KEY_FILE_MESSAGE_TEMP_REEL, IPC_CREAT | 0777)) == -1) {
		perror ("[I] msgget");
		exit (1);
	}

	/* Interface au démarrage */
	Interface = (char *) malloc (6);
	strncpy (Interface, "eth0", 5);
	/* Lecture de la configuration */
	Copie_Fichier_Configuration ();
	Creer_PortList ();
	Creer_ScriptList ();
	Creer_Liste_Sous_Reseau ();
	Creer_MacListe ();
	Initialise_Structure_Domaine ();
	Init_Liste_Partage_Monter ();
	/* Creation des fenetres */
	window_Tester_Smtp = create_window_Tester_Smtp ();
	window_NetSend = create_window_NetSend ();
	window_Pop3 = create_window_Pop3 ();
	window_Liste_Port = create_window_Liste_Port ();
	window_Force_Reseau = create_window_Force_Reseau ();
	window_Ajout_Script = create_window_Ajout_Script ();
	window_Liste_Signatures = create_window_Liste_Signatures ();
	window_Debug_Scan = create_window_Debug_Scan ();
	window_Partage = create_window_Partage ();
	window_Preference = create_window_Preference ();
	Liste_Interface ();
	Lecture_Fichier_Interface ();
	fileselection_Enregistrer = create_fileselection_Enregistrer ();
	window_Resultat_Script = create_window_Resultat_Script ();
	window_Recherche_Machine = create_window_Recherche_Machine ();
	window_demarrage = create_window_demarrage ();
	gtk_widget_set_sensitive (checkbutton_Demarrage_Mise_A_Jour, FALSE);
	window_Contributions = create_window_Contributions ();
	IconeSelectionner_Nouveau = 0;
	Affiche_Liste_Reseau ();

	gtk_widget_realize (window);
	printf ("[I] Creation des fenetres terminees\n");
	Creer_SignatureList ();
	/* Creation des menus */
	create_menu_Port ();
	create_menu_Liste_Machine ();
	create_menu_Applet ();
	//Creer_Menu_Modes ();  creer dans l'interface probl avec message information
	printf ("[I] Creation des Menus termines\n");
	/* Modification des fenetres */
	gtk_ctree_set_expander_style (GTK_CTREE (ctree_Liste_Machine), GTK_CTREE_EXPANDER_CIRCULAR);
	gtk_ctree_set_line_style (GTK_CTREE (ctree_Liste_Machine), GTK_CTREE_LINES_DOTTED);
	gtk_ctree_set_expander_style (GTK_CTREE (ctree_Liste_Machine), GTK_CTREE_EXPANDER_CIRCULAR);
	gtk_ctree_set_line_style (GTK_CTREE (ctree_Ajout_Script), GTK_CTREE_LINES_NONE);
	gtk_ctree_set_line_style (GTK_CTREE (ctree_Liste_Port), GTK_CTREE_LINES_NONE);
	gtk_ctree_set_line_style (GTK_CTREE (ctree_Liste_Signatures), GTK_CTREE_LINES_NONE);
	gtk_ctree_set_line_style (GTK_CTREE (ctree_Preference_Sous_reseau_privee), GTK_CTREE_LINES_NONE);
	gtk_clist_set_row_height (GTK_CLIST (ctree_Liste_Machine), 17);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_Demarrage_Ajouter), TRUE);
	CouleurFond.red = 191;
	CouleurFond.green = 191;
	CouleurFond.blue = 191;
	gtk_clist_set_background (GTK_CLIST (ctree_Liste_Machine), 0, &CouleurFond);
	gtk_clist_set_sort_column (GTK_CLIST (ctree_Liste_Machine), 0);	// trie sur la colonne 0
	gtk_clist_set_sort_type (GTK_CLIST (ctree_Liste_Machine), GTK_SORT_ASCENDING);
	gtk_clist_set_auto_sort (GTK_CLIST (ctree_Liste_Machine), TRUE);
	/* Chargement des images utilisees dans la liste des machines et info */
	Pixmap_Inconnu = gdk_pixmap_create_from_xpm (window->window, &Masque_Inconnu, &Transparent, "/usr/share/pixmaps/AutoScan/Inconnu.png");
	Pixmap_Firewall = gdk_pixmap_create_from_xpm (window->window, &Masque_Firewall, &Transparent, "/usr/share/pixmaps/AutoScan/firewall.png");
	Pixmap_Serveur = gdk_pixmap_create_from_xpm (window->window, &Masque_Serveur, &Transparent, "/usr/share/pixmaps/AutoScan/Serveur.png");
	Pixmap_Station = gdk_pixmap_create_from_xpm (window->window, &Masque_Station, &Transparent, "/usr/share/pixmaps/AutoScan/Station.xpm");
	Pixmap_Domaine = gdk_pixmap_create_from_xpm (window->window, &Masque_Domaine, &Transparent, "/usr/share/pixmaps/AutoScan/Domaine.png");
	Pixmap_Hwinfo = gdk_pixmap_create_from_xpm (window->window, &Masque_Hwinfo, &Transparent, "/usr/share/pixmaps/AutoScan/hwinfo.png");
	Pixmap_Info = gdk_pixmap_create_from_xpm (window->window, &Masque_Info, &Transparent, "/usr/share/pixmaps/AutoScan/info.png");
	Pixmap_Utilisateur = gdk_pixmap_create_from_xpm (window->window, &Masque_Utilisateur, &Transparent, "/usr/share/pixmaps/AutoScan/Utilisateur.xpm");
	Pixmap_HostName = gdk_pixmap_create_from_xpm (window->window, &Masque_HostName, &Transparent, "/usr/share/pixmaps/AutoScan/HostName.png");
	Pixmap_Switch = gdk_pixmap_create_from_xpm (window->window, &Masque_Switch, &Transparent, "/usr/share/pixmaps/AutoScan/switch.png");
	Pixmap_Imprimante = gdk_pixmap_create_from_xpm (window->window, &Masque_Imprimante, &Transparent, "/usr/share/pixmaps/AutoScan/printer.png");
	Pixmap_Routeur = gdk_pixmap_create_from_xpm (window->window, &Masque_Routeur, &Transparent, "/usr/share/pixmaps/AutoScan/router.png");
	Pixmap_Routeur_Switch = gdk_pixmap_create_from_xpm (window->window, &Masque_Routeur_Switch, &Transparent, "/usr/share/pixmaps/AutoScan/routerswitch.png");
	Pixmap_Wifi = gdk_pixmap_create_from_xpm (window->window, &Masque_Wifi, &Transparent, "/usr/share/pixmaps/AutoScan/Access_Point.xpm");
	gnome_icon_entry_set_pixmap_subdir (iconentry_Liste_Signature_Allumer, "/usr/share/pixmaps/AutoScan/Equipment/Up/");
	gnome_icon_entry_set_pixmap_subdir (iconentry_Liste_Signature_Eteint, "/usr/share/pixmaps/AutoScan/Equipment/Down/");
	gnome_icon_entry_set_pixmap_subdir (iconentry_Liste_Port_Ouvert, "/usr/share/pixmaps/AutoScan/Port/Up/");
	gnome_icon_entry_set_pixmap_subdir (iconentry_Liste_Port_Fermer, "/usr/share/pixmaps/AutoScan/Port/Down/");
	/* Creation des l'icone applet */
	creation_applet_icone ();
	Creer_Menu_Script ();
	Init_Documentation ("/usr/share/doc/AutoScan/Intro.html");
	Mode_Documentation = TRUE;
	Mode_Documentation_Demarrage = TRUE;
	/* Lancement du service super utilisateur */
	pid_fils = fork ();	// création d'un fils
	if (pid_fils == 0) {
		/* Fils */
		system ("autoscan_d");
		exit (127);
	}

	init_Samba ();


	/* Timer de rafraichissement */
	ptimer_Rafraichi = gtk_timeout_add (1000, timer, NULL);
	/* Boucle infini GTK */


	gtk_main ();
	return 0;
}
